/*
 *  Editor - a menu-driven text editor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
 
#include <X11/Intrinsic.h>
#include "Files.h"
#include "icon.h"

#ifdef XPM
#include <X11/xpm.h>
#include "pixmaps/xfm_icon.xpm"
#else
#include "bitmaps/xfm_icon.xbm"
#include "bitmaps/xfm_icon_mask.xbm"
#endif

static Pixmap	xfm_Icon,xfm_Mask;

void
ReadIcons(Widget toplevel)
{
	XWMHints *hints;
	Display *dpy=XtDisplay(toplevel);
	int Width,Height;
	int scrn=DefaultScreen(dpy);
	int dpth=XDefaultDepth(dpy,scrn);
	Window win=DefaultRootWindow(dpy);
	/* Create the pixmaps accordingly		       *
	 * All the pixmaps MUST have the same height and width */
#ifdef XPM
	XpmAttributes xpmattributes;
	xpmattributes.depth=dpth;
	xpmattributes.valuemask=XpmSize | XpmDepth;
	XpmCreatePixmapFromData(dpy,win,xfm_icon_xpm,&xfm_Icon,&xfm_Mask,
				&xpmattributes);
	Width=xpmattributes.width;
	Height=xpmattributes.height;
#else
	xfm_Icon=XCreatePixmapFromBitmapData(dpy,win,xfm_icon_bits,
			xfm_icon_width,xfm_icon_height,BlackPixel(dpy,scrn),
			WhitePixel(dpy,scrn),dpth);
	xfm_icon_Mask=XCreateBitmapFromData(dpy, win,xfm_icon_mask_bits,
			xfm_icon_mask_width,xfm_icon_mask_height);
	Width=xfm_icon_width;
	Height=xfm_icon_height;
#endif
	
	/* Now tell the window manager what the icon is */
	hints=XAllocWMHints();
	hints->flags=IconPixmapHint | IconMaskHint;
	hints->icon_pixmap=xfm_Icon;
	hints->icon_mask=xfm_Mask;
	XSetWMHints(dpy,XtWindow(toplevel),hints);
	XFree(hints);
}
