#!
# AfterStep Control Panel 
#
#     Configuration Modules for AfterStep
#
# Copyright (c) 1996 Alfredo K. Kojima
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

# This requires TkSTEP 0.5 or higher 


# the default steprc to look for
set ASConfig(file)	"~/.steprc"
# if user does not have a steprc, use the system's default one.
set ASConfig(sysfile) 	"/usr/lib/X11/afterstep/system.steprc"

#
# Variables:
# ASConfig - various configuration settings
# Wharf - Wharf bindings
# Windows - Window options
# KeyBind
# MouseBind

#module configuration stuff
set ASConfig(wtitle,1)	"Font Preferences"
set ASConfig(wtitle,2)	"Gradient Preferences"
set ASConfig(wtitle,3)	"Window Handling"
set ASConfig(wtitle,4)	"Desktop Preferences"
set ASConfig(wtitle,5)	"Sound Preferences"
set ASConfig(wtitle,6)	"Wharf Bindings"
set ASConfig(wtitle,7)	"Path Settings"
set ASConfig(wtitle,8)	"Window Preferences"
set ASConfig(wtitle,9)	"Menu Bindings"
set ASConfig(wtitle,10)	"Wharf Preferences"
set ASConfig(wtitle,11)	"Keyboard Bindings"
set ASConfig(wtitle,12)	"Mouse Bindings"
set ASConfig(wtitle,13)	"Function Definitions"
set ASConfig(wtitle,14)	"Other Decorations"

#gradient style icons
set ASConfig(gtypep,0)  "afterstep/nograd.xbm"
set ASConfig(gtypep,1)  "afterstep/dgrad.xbm"
set ASConfig(gtypep,2)  "afterstep/vgrad.xbm"
set ASConfig(gtypep,3)  "afterstep/vcgrad.xbm"
set ASConfig(gtypep,4)  "afterstep/hgrad.xbm"
set ASConfig(gtypep,5)  "afterstep/hcgrad.xbm"
set ASConfig(gtypep,6)	"afterstep/xpmgrad.xbm"
#icon box types
set ASConfig(ibox,0)	"afterstep/sibox.xbm"
set ASConfig(ibox,1)	"afterstep/nibox.xbm"
set ASConfig(ibox,2)	"afterstep/wibox.xbm"
set ASConfig(ibox,3)	"afterstep/eibox.xbm"

#wharf position
set ASConfig(whpos)	"afterstep/whcorner.xbm"
#wharf direction
set ASConfig(dir,0)	"afterstep/whvert.xbm"
set ASConfig(dir,1)	"afterstep/whhoriz.xbm"
set ASConfig(dir,2)	"afterstep/userdef.xbm"

#text alignment
set ASConfig(alg,0)	"afterstep/ale.xbm"
set ASConfig(alg,1)	"afterstep/ace.xbm"
set ASConfig(alg,2)	"afterstep/ari.xbm"

#edge resistance for scrolling
set ASConfig(er,0)	"afterstep/er0.xbm"
set ASConfig(er,1)	"afterstep/er1.xbm"
set ASConfig(er,2)	"afterstep/er2.xbm"
set ASConfig(er,3)	"afterstep/er3.xbm"
set ASConfig(er,4)	"afterstep/er4.xbm"
#for moving
set ASConfig(erm,0)	"afterstep/erm0.xbm"
set ASConfig(erm,1)	"afterstep/erm1.xbm"
set ASConfig(erm,2)	"afterstep/erm2.xbm"
set ASConfig(erm,3)	"afterstep/erm3.xbm"
set ASConfig(erm,4)	"afterstep/erm4.xbm"

#for moving
set ASConfig(mb,0)	"afterstep/mb0.xbm"
set ASConfig(mb,1)	"afterstep/mb1.xbm"
set ASConfig(mb,2)	"afterstep/mb2.xbm"
set ASConfig(mb,3)	"afterstep/mb3.xbm"

#time
set ASConfig(tm,0)	"afterstep/time0.xbm"
set ASConfig(tm,1)	"afterstep/time1.xbm"
set ASConfig(tm,2)	"afterstep/time2.xbm"
set ASConfig(tm,3)	"afterstep/time3.xbm"
set ASConfig(tm,mask)	"afterstep/time.xbmM"

#contexts
set ASConfig(ctx,0)	"afterstep/ctx_root.xbm"
set ASConfig(ctx,1)	"afterstep/ctx_win.xbm"
set ASConfig(ctx,2)	"afterstep/ctx_icon.xbm"
set ASConfig(ctx,3)	"afterstep/ctx_side.xbm"
set ASConfig(ctx,4)	"afterstep/ctx_frame.xbm"
set ASConfig(ctx,5)	"afterstep/ctx_title.xbm"
set ASConfig(ctx,6)	"afterstep/ctx_btn.xbm"


####### configurations


#wharf corner
set ASConfig(whcorner)	ne
#wharf direction
set ASConfig(whdir)	0
#wharf size
set ASConfig(wsize) 	1
#wharf options
set ASConfig(whanim) 	0
set ASConfig(whanimm) 	0
set ASConfig(whborder) 	1
set ASConfig(whfpush) 	0
set ASConfig(whdisable) 0
#configuration stuff
set ASConfig(UFScolor) "#111111"
set ASConfig(UBScolor) "#bfbfbf"
set ASConfig(FFScolor) "White"
set ASConfig(FBScolor) "Black"
set ASConfig(MBScolor) "#bfbfbf"
set ASConfig(MFScolor) "black"

set ASConfig(WBScolor) "#bfbfbf"
#icon
set ASConfig(CBScolor) "#bfbfbf"

set ASConfig(Tfont) "-adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*"
set ASConfig(Ifont) "-adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*"
set ASConfig(Cfont) "-adobe-helvetica-medium-r-*-*-8-*-*-*-*-*-*-*"

set ASConfig(FTexture) 0
set ASConfig(UTexture) 0
set ASConfig(MTexture) 0
set ASConfig(ITexture) 0
set ASConfig(STexture) 0
set ASConfig(WTexture) 0
set ASConfig(CTexture) 0
set ASConfig(Fmaxcols) 16
set ASConfig(Umaxcols) 16
set ASConfig(Mmaxcols) 16
set ASConfig(Imaxcols) 16
set ASConfig(Smaxcols) 16
set ASConfig(Wmaxcols) 16
set ASConfig(Cmaxcols) 16
set ASConfig(FFcolor) "#101030"
set ASConfig(FTcolor) "#303080"
set ASConfig(UFcolor) "#86868a"
set ASConfig(UTcolor) "#c0b8c3"
set ASConfig(MFcolor) "#101030"
set ASConfig(MTcolor) "#303080"
set ASConfig(IFcolor) "#86868a"
set ASConfig(ITcolor) "#c0b8c3"
set ASConfig(SFcolor) "#301030"
set ASConfig(STcolor) "#803080"
set ASConfig(WFcolor) "#404040"
set ASConfig(WTcolor) "#808080"
set ASConfig(CFcolor) "#404040"
set ASConfig(CTcolor) "#808080"
set ASConfig(Fpixmap) ""
set ASConfig(Upixmap) ""
set ASConfig(Mpixmap) ""
set ASConfig(Ipixmap) ""
set ASConfig(Spixmap) ""
set ASConfig(Wpixmap) ""
set ASConfig(Cpixmap) ""
set ASConfig(GTFcolor) "white"
set ASConfig(GTTcolor) "black"

#others
set ASConfig(talig)	0

set ASConfig(SticI)	0
set ASConfig(StubI) 	0
set ASConfig(StubIP)	0
set ASConfig(IconT)	0
set ASConfig(CSkipI) 	0

set ASConfig(TBnpush)	0
set ASConfig(THandle)	0
set ASConfig(GText)	0

set ASConfig(RandomP)	0
set ASConfig(SmartP)	0
set ASConfig(IconBox)	0
set ASConfig(EScroll,h) 0
set ASConfig(EScroll,v) 0
set ASConfig(EScroll,hw) 0
set ASConfig(EScroll,vw) 0
set ASConfig(ERes,s)	0
set ASConfig(ERes,m)	0
set ASConfig(ClickF)	0
set ASConfig(SlopF)	0
set ASConfig(ABackS)	0
set ASConfig(BackS)	0
set ASConfig(SaveU)	0
set ASConfig(OMove)	0
set ASConfig(NoPos)	0
set ASConfig(DTrans) 	0
set ASConfig(ORes)	0
set ASConfig(Auto)	0
set ASConfig(AutoOn)	0
set ASConfig(CTime)	150
set ASConfig(DTSize,v)	2
set ASConfig(DTSize,h)	2
set ASConfig(DTScale)	32
#Audio
set ASConfig(AuCmd)	"play"
set ASConfig(AuDir)	"/usr/lib/X11/afterstep/sounds/"
set ASConfig(AuDelay)	1
set ASConfig(AuOn)	0
set ASConfig(AuEv,count) 18
set ASConfig(AuEv,0)	startup
set ASConfig(AuEv,1)	shutdown
set ASConfig(AuEv,2)	add_window
set ASConfig(AuEv,3)	raise_window
set ASConfig(AuEv,4)	lower_window
set ASConfig(AuEv,5)	focus_change
set ASConfig(AuEv,6)	destroy_window
set ASConfig(AuEv,7)	iconify
set ASConfig(AuEv,8)	deiconify
set ASConfig(AuEv,9)	toggle_paging
set ASConfig(AuEv,10)	new_page
set ASConfig(AuEv,11)	new_desk
set ASConfig(AuEv,12)	configure_window
set ASConfig(AuEv,13)	window_name
set ASConfig(AuEv,14)	icon_name
set ASConfig(AuEv,15)	res_class
set ASConfig(AuEv,16)	res_name
set ASConfig(AuEv,17)	end_windowlist
set ASConfig(AuSnd,0)	""
set ASConfig(AuSnd,1)	""
set ASConfig(AuSnd,2)	""
set ASConfig(AuSnd,3)	""
set ASConfig(AuSnd,4)	""
set ASConfig(AuSnd,5)	""
set ASConfig(AuSnd,6)	""
set ASConfig(AuSnd,7)	""
set ASConfig(AuSnd,8)	""
set ASConfig(AuSnd,9)	""
set ASConfig(AuSnd,10)	""
set ASConfig(AuSnd,11)	""
set ASConfig(AuSnd,12)	""
set ASConfig(AuSnd,13)	""
set ASConfig(AuSnd,14)	""
set ASConfig(AuSnd,15)	""
set ASConfig(AuSnd,16)	""
set ASConfig(AuSnd,17)	""

#paths
set ASConfig(modPath) "/usr/lib/X11/afterstep/"
set ASConfig(pixPath) "/usr/include/X11/pixmaps/:/usr/lib/X11/icons/"
set ASConfig(icoPath) "/usr/include/X11/bitmaps/"

#others
set Windows(idx) {}
set MouseBind(idx) {}
set KeyBind(idx) {}
set Functions(idx) {}

#register destroy procedure
set ASCPDestroy($ASCPDestroy(n)) as_bye
incr ASCPDestroy(n)

#to be called when exiting prog.
proc as_bye {} {
	set tmp [tk_dialog .dlg "Afterstep Preferences" \
		"Do you wish to update your AfterStep preferences ?" {} 0 Save Cancel "   No   "]
	if {$tmp==0} {
		save_asconfig
	} elseif {$tmp==2} {
		#nothing
	} else {
		return 1
	}
	return 0
}


#---------------------------------------------------------------
proc invoke {button} {
	#make sure we're not catching an event bound by another module
	set state [$button cget -relief]
	if {[catch {$button configure -relief sunken}]} return
   	update idletasks
	after 100
	$button configure -relief $state
	$button invoke
}

proc getIconName {path} {
	global ASConfig
	
	set icon [lindex [split $path /] end]
	set result [findIconFile $icon]
	if {$result==$path} {return $path}
	return $icon
}

proc findIconFile {icon} {
	global ASConfig
	
	if {[string range [string trim $icon] 0 0]=="/"} {
		if {[file exists $icon]} {
			return $icon
		} else {
			return
		}
	} else {
		foreach dir [split [string trim "$ASConfig(pixPath)"] ":" ] {
			if {[file exists $dir/$icon]} {
				return $dir/$icon
			} else {
				set ifile [lindex [split $icon ,] 0]
				if {[file exists $dir/$ifile]} {
					return $dir/$ifile
				}
			}
		}
	}
}

#---------------------------------------------------------------
# colors and fonts
#---------------------------------------------------------------
proc module_color {rw w} {
	global ASConfig ASCPConfig
	
	wm title $rw $ASConfig(wtitle,1)

#standard FG and BG colorwell box
	frame $w.stdcol -bd 2 -relief groove -text "Standard Colors"
	tksColorWell $w.stdcol.fg ASConfig(UFScolor) F
	tksColorWell $w.stdcol.bg ASConfig(UBScolor) B
	place $w.stdcol -x 8 -y 1 -width 125 -height 58
	place $w.stdcol.fg -in $w.stdcol -x 6 -y 14
	place $w.stdcol.bg -in $w.stdcol -x 63 -y 14
#highlight FG and BG colorwell box
	frame $w.hicol -bd 2 -relief groove -text "Highlight Colors"
	tksColorWell $w.hicol.fg ASConfig(FFScolor) F
	tksColorWell $w.hicol.bg ASConfig(FBScolor) B
	place $w.hicol -x 8 -y 61 -width 125 -height 58
	place $w.hicol.fg -in $w.hicol -x 6 -y 14
	place $w.hicol.bg -in $w.hicol -x 63 -y 14
#menu item FG and BG colorwell box
	frame $w.mncol -bd 2 -relief groove -text "Menu Item Colors"
	tksColorWell $w.mncol.fg ASConfig(MFScolor) F
	tksColorWell $w.mncol.bg ASConfig(MBScolor) B
	place $w.mncol -x 8 -y 121 -width 125 -height 58
	place $w.mncol.fg -in $w.mncol -x 6 -y 14
	place $w.mncol.bg -in $w.mncol -x 63 -y 14
#updates font	
	proc set_font {w item} {
		global ASConfig
		
		set f [tksFontChooser]
		if {$f=={}} return
		set ASConfig($item) $f
		regsub fnt.b $w fnt.s wi
		$wi configure -font $f
	}
#titlebar font
	frame $w.tfnt -bd 2 -relief groove -text "Titlebar Font"
	entry $w.tfnt.e -width 20 -textvariable ASConfig(Tfont)
	button $w.tfnt.b -text "..." -pady 1 -padx 2 \
		-command "set_font $w.tfnt.b Tfont"
	label $w.tfnt.s -text "Sample" -font $ASConfig(Tfont) -padx 0 -pady 0
	bind $w.tfnt.e <Return> "$w.tfnt.s configure -font $[$w.tfnt.e cget -text]"
	
	place $w.tfnt -x 140 -y 1 -width 240 -height 60
	place $w.tfnt.e -in $w.tfnt -x 7 -y 14 -width 200 -height 20
	place $w.tfnt.b -in $w.tfnt -x 212 -y 14
	place $w.tfnt.s -in $w.tfnt -x 7 -y 38
#menu item font
	frame $w.mfnt -bd 2 -relief groove -text "Menu Font"
	entry $w.mfnt.e -width 20 -textvariable ASConfig(Ifont)
	button $w.mfnt.b -text "..." -pady 1 -padx 2 \
 		-command "set_font $w.mfnt.b Ifont"
	label $w.mfnt.s -text "Sample" -font $ASConfig(Ifont) -padx 0 -pady 0
	bind $w.mfnt.e <Return> "$w.mfnt.s configure -font $[$w.mfnt.e cget -text]"
	
	place $w.mfnt -x 140 -y 61 -width 240 -height 60
	place $w.mfnt.e -in $w.mfnt -x 7 -y 14 -width 200 -height 20
	place $w.mfnt.b -in $w.mfnt -x 212 -y 14
	place $w.mfnt.s -in $w.mfnt -x 7 -y 38
#icon title font
	frame $w.cfnt -bd 2 -relief groove -text "Icon Font"
	entry $w.cfnt.e -width 20 -textvariable ASConfig(Cfont)
	button $w.cfnt.b -text "..." -pady 1 -padx 2 \
 		-command "set_font $w.cfnt.b Cfont"
	label $w.cfnt.s -text "Sample" -font $ASConfig(Cfont) -padx 0 -pady 0
	bind $w.cfnt.e <Return> "$w.cfnt.s configure -font $[$w.cfnt.e cget -text]"
	
	place $w.cfnt -x 140 -y 121 -width 240 -height 60
	place $w.cfnt.e -in $w.cfnt -x 7 -y 14 -width 200 -height 20
	place $w.cfnt.b -in $w.cfnt -x 212 -y 14
	place $w.cfnt.s -in $w.cfnt -x 7 -y 38

#buttons
#	button $w.help -text "Help" -pady 1 -command $ASCPConfig(help,as)
#	button $w.save -text "Save" -pady 1
#	button $w.undo -text "Load" -pady 1
#	place $w.save -x 330  -y 95 -width 52
#	place $w.undo -x 330  -y 120 -width 52
#	place $w.help -x 330  -y 155 -width 52
	
	pack $w -fill both -expand y
}


#---------------------------------------------------------------
# Texture configuration
#---------------------------------------------------------------
proc module_gradients {rw w} {
	global ASConfig MenuValue ASCPConfig ASCPLibDir
	
	set MenuValue Focused
	wm title $rw $ASConfig(wtitle,2)

	tk_optionMenu $w.menu  MenuValue Focused Unfocused Sticky Menu \
		"Menu Item" Wharf Icons
	$w.menu configure -pady 1
	place $w.menu -x 20 -y 5 -width 100

#gradient type setting
	frame $w.grad -bd 2 -relief groove -text "Gradient/Texture Type"
	place $w.grad -x 175 -y 5 -width 200 -height 55

	if {[catch txtp0]} {
		for {set i 0} {$i <= 6} {incr i} {
			image create bitmap txtp$i -file $ASCPLibDir[]$ASConfig(gtypep,$i)
		}
	}
	for {set i 0} {$i <= 6} {incr i} {
		radiobutton $w.grad.gt$i -image txtp$i -indicatoron 0 \
			-variable ASConfig(FTexture) -value $i
		place $w.grad.gt$i -x [expr 26 * $i + 6] -y 16 -width 26 -height 26
	}
	#set the pixmap type to the correct value
	$w.grad.gt6 configure -value 128

#maxcolors
	frame $w.mc -bd 2 -relief groove -text "Color Limit"
	entry $w.mc.e -textvariable ASConfig(Fmaxcols) -justify center
	bind $w.mc.e <Return> {if {$ASConfig(Fmaxcols)<3} set ASConfig(Fmaxcols) 3}
	button $w.mc.l -image ASCPConfig(img,left) \
		-command {if {$ASConfig(Fmaxcols)>3} {incr ASConfig(Fmaxcols) -1}}
	button $w.mc.r -image ASCPConfig(img,right) \
		-command {incr ASConfig(Fmaxcols)}
	place $w.mc -x 20 -y 38 -width 108 -height 50
	place $w.mc.e -in $w.mc -x 30 -y 16 -width 40 -height 20
	place $w.mc.l -in $w.mc -x 10 -y 18
	place $w.mc.r -in $w.mc -x 75 -y 18 
#gradient colors
	frame $w.col -bd 2 -relief groove -text "Gradient Colors"
	tksColorWell $w.col.from ASConfig(FFcolor)
	tksColorWell $w.col.to ASConfig(FTcolor)
	label $w.col.f -text "From" -pady 0
	label $w.col.t -text "To" -pady 0
	place $w.col -x 20 -y 100 -width 134 -height 74
	place $w.col.from -in $w.col -x 15 -y 16
	place $w.col.to -in $w.col -x 70 -y 16
	place $w.col.f -x 20 -y 48
	place $w.col.t -x 80 -y 48
#tile pixmap
	frame $w.xpm -bd 2 -relief groove -text "Tile Pixmap"
	entry $w.xpm.e -textvariable ASConfig(Fpixmap)

	xpmPreview blank
	button $w.xpmv -relief groove -image xpmPreview -command "preview $w"

	place $w.xpmv -x 310 -y 115 -width 68 -height 68
	place $w.xpm.e -in $w.xpm -x 6 -y 14 -width 182 -height 20
	place $w.xpm -x 175 -y 65 -width 200 -height 44
	
	proc handle_drop {w type file} {
		if {$type!="File"} return
		$w.xpm.e delete 0 end
		$w.xpm.e insert 0 [getIconName $file]
		preview $w
	}
	bind $w.xpmv <Drop> "handle_drop $w %P %D"
	bind $w.xpm.e <Return> "invoke $w.xpmv"
#solid colors
	label $w.lsolid -text "Solid"
	tksColorWell $w.solid ASConfig(WBScolor)	
	
#buttons
#	button $w.help -text "Help" -pady 1 -command $ASCPConfig(help,as)
#	button $w.save -text "Save" -pady 1
#	button $w.undo -text "Load" -pady 1
#	place $w.help -x 323  -y 140	
#	place $w.save -x 250  -y 140
#	place $w.undo -x 310  -y 140

	pack $w -fill both -expand y
#

	proc preview {w} {
		image delete xpmPreview
		image create photo xpmPreview
		if {[set xpm [$w.xpm.e get]]=={}} return
		if {[set file [findIconFile $xpm]]=={}} return
		xpmPreview read $file
	}
	preview $w
#wait for action
	while {1} {
		tkwait variable MenuValue
#change current values for new item
		if {$MenuValue == "Focused"} {
			set txt FTexture
			set max Fmaxcols
			set file Fpixmap
			tksColorWell $w.col.from ASConfig(FFcolor)
			tksColorWell $w.col.to ASConfig(FTcolor)
			place forget $w.solid
			place forget $w.lsolid
		} elseif {$MenuValue == "Unfocused"} {
			set txt UTexture
			set max Umaxcols
			set file Upixmap
			tksColorWell $w.col.from ASConfig(UFcolor)
			tksColorWell $w.col.to ASConfig(UTcolor)
			place forget $w.solid
			place forget $w.lsolid
		} elseif {$MenuValue == "Menu"} {
			set txt MTexture
			set max Mmaxcols
			set file Mpixmap
			tksColorWell $w.col.from ASConfig(MFcolor)
			tksColorWell $w.col.to ASConfig(MTcolor)
			place forget $w.solid
			place forget $w.lsolid
		} elseif {$MenuValue == "Sticky"} {
			set txt STexture
			set max Smaxcols
			set file Spixmap
			tksColorWell $w.col.from ASConfig(SFcolor)
			tksColorWell $w.col.to ASConfig(STcolor)
			place forget $w.solid
			place forget $w.lsolid			
		} elseif {$MenuValue == "Menu Item"} {
			set txt ITexture
			set max Imaxcols
			set file Ipixmap
			tksColorWell $w.col.from ASConfig(IFcolor)
			tksColorWell $w.col.to ASConfig(ITcolor)
			place forget $w.solid
			place forget $w.lsolid
		} elseif {$MenuValue == "Wharf"} {
			set txt WTexture
			set max Wmaxcols
			set file Wpixmap
			tksColorWell $w.col.from ASConfig(WFcolor)
			tksColorWell $w.col.to ASConfig(WTcolor)
			
			tksColorWell $w.solid ASConfig(WBScolor)
			place $w.solid -x 175 -y 130 
			place $w.lsolid -x 177 -y 160
		} elseif {$MenuValue == "Icons"} {
			set txt CTexture
			set max Cmaxcols
			set file Cpixmap
			tksColorWell $w.col.from ASConfig(CFcolor)
			tksColorWell $w.col.to ASConfig(CTcolor)
						
			tksColorWell $w.solid ASConfig(CBScolor)
			place $w.solid -x 175 -y 130
			place $w.lsolid -x 177 -y 160			
		} else {
			return
		}
		for {set i 0} {$i <= 6} {incr i} {
			$w.grad.gt$i configure -variable ASConfig($txt)
		}
		$w.mc.e configure -textvariable ASConfig($max)
		$w.xpm.e configure -textvariable ASConfig($file)
		$w.mc.l configure -command "incr ASConfig($max) -1"
		$w.mc.r configure -command "incr ASConfig($max)"
		if {[lindex $MenuValue 0]=="Menu"} {
			$w.grad.gt6 config -state disabled
		} else {
			$w.grad.gt6 config -state normal
		}
		preview $w
	}
}


#---------------------------------------------------------------
# General window settings
#---------------------------------------------------------------
proc module_window {rw w} {
	global ASConfig ASCPConfig ASCPLibDir
	
	wm title $rw $ASConfig(wtitle,3)

	if {[catch {tima0 cget -foreground}]} {
	    for {set i 0} {$i < 4} {incr i} {
		image create bitmap time$i -file $ASCPLibDir[]$ASConfig(tm,$i) -maskfile \
			$ASCPLibDir[]$ASConfig(tm,mask) -foreground black -background "#6060a0"
	    }
	} else {
	    for {set i 0} {$i < 4} {incr i} {
		time$i configure -background "#6060a0"
	    }	
	}
	checkbutton $w.b1 -variable ASConfig(RandomP) -text "Random Placement"\
		-anchor w
	checkbutton $w.b2 -variable ASConfig(SmartP) -text "Smart Placement"\
		 -anchor w
	checkbutton $w.b3 -variable ASConfig(ClickF) -text "Click to Focus"\
		 -anchor w
	checkbutton $w.b4 -variable ASConfig(SlopF) -text "Sloppy Focus"\
		 -anchor w
	checkbutton $w.b5 -variable ASConfig(NoPos) -text "Ignore PPosition"\
		 -anchor w
	checkbutton $w.b6 -variable ASConfig(DTrans) -text \
		"Decorate Transients"  -anchor w
	checkbutton $w.b7 -variable ASConfig(ABackS) -text "App Backing Store"\
		 -anchor w
	checkbutton $w.b8 -variable ASConfig(BackS) -text "Backing Store"\
		 -anchor w
	checkbutton $w.b9 -variable ASConfig(SaveU) -text "Save Unders"  \
		-anchor w
#	checkbutton $w.b10 -variable ASConfig() -text ""\
#		 -anchor w
	scale $w.s1 -variable ASConfig(OMove) -orient horizontal
	checkbutton $w.s2 -variable ASConfig(ORes) -text "Opaque Resize"\
		-anchor w
	label $w.l1 -text "Opaque Move\n for windows<"
	frame $w.ar -text "Auto Raise" -bd 2 -relief groove
	frame $w.ct -text "Click Timeout" -bd 2 -relief groove
	entry $w.ar.e -textvariable ASConfig(Auto) -width 4 -justify right
	checkbutton $w.ar.enab -text "Enable" -anchor w -variable ASConfig(AutoOn)
	button $w.ar.b1 -image ASCPConfig(img,left) -command {
		if {$ASConfig(Auto)>9} {incr ASConfig(Auto) -10}}
	button $w.ar.b2 -image ASCPConfig(img,right) -command {
		incr ASConfig(Auto) 10}
	entry $w.ct.e -textvariable ASConfig(CTime) -width 4 -justify right
	proc select_s {new} {
		for {set i 0} {$i < 4} {incr i} {
			time$i configure -background "#6060a0"
		}
		time$new configure -background white
	}
	for {set i 0} {$i < 4} {incr i} {
		if {[expr $i*75]==$ASConfig(CTime)} "select_s $i"
		radiobutton $w.ct.t$i -image time$i -indicatoron 0 -bd 0 \
		    -relief flat -variable ASConfig(CTime) -value [expr ($i+1)*50]\
		    -selectcolor gray -command "select_s $i"
		place $w.ct.t$i -x [expr $i*28 + 5] -y 12
	}
#
	place $w.b1 -x 5 -y 5 -width 180 -height 20
	place $w.b2 -x 5 -y 25 -width 180 -height 20
	place $w.b3 -x 5 -y 45 -width 180 -height 20
	place $w.b4 -x 5 -y 65 -width 180 -height 20
	place $w.b5 -x 5 -y 85 -width 180 -height 20
	place $w.b6 -x 185 -y 5 -width 180 -height 20
	place $w.b7 -x 185 -y 25 -width 180 -height 20
	place $w.b8 -x 185 -y 45 -width 180 -height 20
	place $w.b9 -x 185 -y 65 -width 180 -height 20
	
	place $w.l1 -x 5 -y 105
	place $w.s1 -x 100 -y 105 -width 100 -height 40 
	place $w.s2 -x 5 -y 145 -height 40

	place $w.ar -x 210 -y 85 -width 165 -height 45
	place $w.ct -x 210 -y 135 -width 165 -height 45
	place $w.ar.e -x 24 -y 15 -height 20
	place $w.ar.b1 -x 5 -y 17
	place $w.ar.b2 -x 61 -y 17
	place $w.ar.enab -x 85 -y 16	
	place $w.ct.e -x 120 -y 16 -height 20

#	button $w.help -text "Help" -pady 1 -command $ASCPConfig(help,as)
#	button $w.save -text "Save" -pady 1
#	button $w.undo -text "Load" -pady 1
#	place $w.help -x 323  -y 155
#	place $w.save -x 265  -y 155
#	place $w.undo -x 323  -y 155

	pack $w -fill both -expand y
}


#---------------------------------------------------------------
# Desktop settings
#---------------------------------------------------------------
proc module_desktop {rw w} {
	global ASConfig ASCPConfig ASCPLibDir

	wm title $rw $ASConfig(wtitle,4)
	
#load some bitmaps
	if {[catch {$w.dti0 cget -foreground}]} {
		for {set i 0} {$i < 4} {incr i} {
			image create bitmap $w.dti$i -file $ASCPLibDir[]$ASConfig(ibox,$i)
		}	
		for {set i 0} {$i < 5} {incr i} {
			image create bitmap dter$i -file $ASCPLibDir[]$ASConfig(er,$i) \
				-foreground "#3c3c7d" -maskfile $ASCPLibDir[]$ASConfig(er,$i)M
			image create bitmap dtem$i -file $ASCPLibDir[]$ASConfig(erm,$i) \
				-foreground "#3c3c7d" -maskfile $ASCPLibDir[]$ASConfig(erm,$i)M
		}
	} else {
		for {set i 0} {$i < 5} {incr i} {
			dter$i configure -background {}
			dtem$i configure -background {}
		}
	}	
#
	checkbutton $w.b1 -variable ASConfig(SticI) -text "Sticky Icons"\
		-anchor w
	checkbutton $w.b2 -variable ASConfig(StubI) -text "Stubborn Icons"\
		 -anchor w
	checkbutton $w.b3 -variable ASConfig(StubIP) -text "Smart Icon Placement"\
		 -anchor w
	checkbutton $w.b4 -variable ASConfig(CSkipI) -text "Skip icons on Circulate"\
		 -anchor w
	place $w.b1 -x 5 -y 5 -width 180 -height 20
	place $w.b2 -x 5 -y 25 -width 180 -height 20
	place $w.b3 -x 5 -y 45 -width 180 -height 20
	place $w.b4 -x 5 -y 65 -width 180 -height 20	
#icon box position
	frame $w.grad -bd 2 -relief groove -text "Icon Box"
	place $w.grad -x 310 -y 5 -width 70 -height 78
	
	for {set i 0} {$i < 4} {incr i} {
		radiobutton $w.grad.gt$i -image $w.dti$i -indicatoron 0 \
			-variable ASConfig(IconBox) -value $i
		place $w.grad.gt$i -x [expr 26*($i%2)+6] -y [expr 26*($i/2)+15]\
				-width 26 -height 26
	}

# edge resistance
	proc select_s {d new} {
		for {set i 0} {$i < 5} {incr i} {
			dte$d$i configure -background {} -foreground "#3c3c7d"
		}
		dte$d$new configure -background "#ffe215" -foreground black
	}
	frame $w.er -bd 2 -relief groove -text "Edge Resistance"
	set sval(0)	0
	set sval(1)	200
	set sval(2)	500
	set sval(3)	1000
	set sval(4)	10000
	for {set i 0} {$i < 5} {incr i} {
		if {$sval($i)==$ASConfig(ERes,s)} "select_s r $i"
		radiobutton $w.er.s$i -image dter$i -indicatoron 0 -bd 0 \
			-relief flat -selectcolor gray -command "select_s r $i"\
			-variable ASConfig(ERes,s) -value $sval($i)
		place $w.er.s$i -x [expr $i*(19+$i)+5] -y 22
		
		if {[expr $i*5]==$ASConfig(ERes,m)} "select_s m $i"
		radiobutton $w.er.m$i -image dtem$i -indicatoron 0 -bd 0 \
			-relief flat -selectcolor gray -command "select_s m $i"\
			-variable ASConfig(ERes,m) -value [expr $i*5]
		place $w.er.m$i -x [expr $i*24+5] -y 62
	}
	
	entry $w.er.s -textvariable ASConfig(ERes,s) -justify right
	entry $w.er.m -textvariable ASConfig(ERes,m) -justify right
	label $w.er.ms -text "ms" -font $ASCPConfig(font,helv10)
	label $w.er.px -text "pels" -font $ASCPConfig(font,helv10)	
	place $w.er.s -x 125 -y 25 -width 40 -height 20
	place $w.er.m -x 125 -y 62 -width 33 -height 20
	place $w.er -x 190 -y 85 -width 190 -height 95
	place $w.er.ms -x 167 -y 27
	place $w.er.px -x 160 -y 64
#edge scroll	
	frame $w.es -text "Edge Scroll (%)" -bd 2 -relief groove

	label $w.es.lhs -text "Hor"
	label $w.es.lvs -text "Ver"
	scale $w.es.hs -variable ASConfig(EScroll,v) -orient horizontal \
		-showvalue 1 -font $ASCPConfig(font,helv10) -width 6
	scale $w.es.vs -variable ASConfig(EScroll,h) -orient horizontal \
		-showvalue 1 -font $ASCPConfig(font,helv10) -width 6
	checkbutton $w.es.hw -anchor w -text "Wrap" -pady 0 -padx 0 \
		-variable ASConfig(EScroll,hw)
	checkbutton $w.es.vw -anchor w -text "Wrap" -pady 0 -padx 0 \
		-variable ASConfig(EScroll,vw)	
	
	place $w.es.lhs -x 5 -y 23
	place $w.es.lvs -x 5 -y 46
	place $w.es.hs -x 32 -y 12 -width 85
	place $w.es.vs -x 32 -y 37 -width 85
	place $w.es.hw -x 120 -y 23
	place $w.es.vw -x 120 -y 46
	
	place $w.es -x 5 -y 110 -width 180 -height 70

#desktop size
	frame $w.f1 -text "Desktop Size" -bd 2 -relief groove
	entry $w.f1.e1 -textvariable ASConfig(DTSize,v) -width 4 -justify center
	entry $w.f1.e2 -textvariable ASConfig(DTSize,h) -width 4 -justify center
	place $w.f1 -x 180 -y 5 -width 118 -height 65
	button $w.f1.l1 -image ASCPConfig(img,left) -command {if {$ASConfig(DTSize,v)>1} {incr ASConfig(DTSize,v) -1}}
	button $w.f1.r1 -image ASCPConfig(img,right) -command {incr ASConfig(DTSize,v)}
	button $w.f1.l2 -image ASCPConfig(img,left) -command {if {$ASConfig(DTSize,h) > 1} {incr ASConfig(DTSize,h) -1}}
	button $w.f1.r2 -image ASCPConfig(img,right) -command {incr ASConfig(DTSize,h)}

	place $w.f1.e1 -in $w.f1 -x 9 -y 14 -height 20
	place $w.f1.e2 -in $w.f1 -x 69 -y 14 -height 20
	place $w.f1.l1 -in $w.f1 -x 10 -y 36
	place $w.f1.r1 -in $w.f1 -x 26 -y 36
	place $w.f1.l2 -in $w.f1 -x 70 -y 36
	place $w.f1.r2 -in $w.f1 -x 86 -y 36
	label $w.f1.l -text "X"
	place $w.f1.l -in $w.f1 -x 48 -y 16

	label $w.l4 -text "Pager Scale"
	scale $w.s1 -orient horizontal -variable ASConfig(DTScale) -width 9 \
		-showvalue 0
	place $w.l4 -x 5 -y 89
	place $w.s1 -x 80 -y 92 -width 100 
	
#	button $w.help -text "Help" -pady 1 -command $ASCPConfig(help,as)
#	button $w.save -text "Save" -pady 1
#	button $w.undo -text "Load" -pady 1
#	place $w.help -x 323  -y 140
#	place $w.save -x 265  -y 140
#	place $w.undo -x 323  -y 140

	pack $w -fill both -expand y
}


#---------------------------------------------------------------
proc audio_scandir {w first} {
	global ASConfig SoundFile SoundSelection
	
	catch {unset SoundFile}
	catch {unset SoundSelection}
	if ![file exists $ASConfig(AuDir)] return
	set files [split [exec /bin/ls -1 $ASConfig(AuDir)] \n]
	if !$first {
		$w.snd.lb delete 1 end
	}
	set i 0	
	foreach f $files {
		if [file isfile $ASConfig(AuDir)/$f] {
			incr i
			set SoundFile($i) $f
			$w.snd.lb insert end $f
		}
	}
	set SoundFile(0) {}
	if $first {
		for {set j 0} {$j < 18} {incr j} {
			set i [lsearch -exact $files $ASConfig(AuSnd,$j)]
			if {$i>=0} {
				set SoundSelection($j) [expr $i + 1]
			} else {
				set SoundSelection($j) 0
				set ASConfig(AuSnd,$j) {}
			}
		}
	} else {
		for {set i 0} {$i < 18} {incr i} {
			set SoundSelection($i) 0
			set ASConfig(AuSnd,$i) {}
		}
	}
}

#---------------------------------------------------------------
# Audio event bindings
#---------------------------------------------------------------
proc module_audio {rw w} {
	global ASConfig ASCPConfig SoundFile SoundSelection

	wm title $rw $ASConfig(wtitle,5)

	if ![file exists $ASConfig(AuDir)] {
		tk_dialog .dlg "Invalid Sound Path" \
		"The current sound path is invalid. Correct at the Path Setting panel."\
			{} 0 Ok
		return
	}
	frame $w.f1 -text "Sound Player" -bd 2 -relief groove
	entry $w.f1.e -textvariable ASConfig(AuCmd) -width 35
	place $w.f1 -x 5 -y 0 -width 240 -height 40
	place $w.f1.e -in $w.f1 -x 5 -y 12 -width 224 -height 20

	label $w.l1 -text "Event Timeout"
	label $w.ll -text "ms"
	entry $w.e -textvariable ASConfig(AuDelay) -width 2
	place $w.l1 -x 250 -y 20
	place $w.e -x 340 -y 20 -height 20
	place $w.ll -x 360 -y 20
	checkbutton $w.b -text "Enable Sounds" -variable ASConfig(AuOn) -anchor w
	place $w.b -x 250 -y 0

#lists	
	label $w.l2 -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text Event -relief sunken
	label $w.l3 -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text Sound -relief sunken
	frame $w.evs -bd 2 -relief sunken
	frame $w.snd -bd 2 -relief sunken
	listbox $w.evs.lb -relief flat -yscrollcommand "$w.evs.sb set" \
		-exportselection 0
	listbox $w.snd.lb -relief flat -yscrollcommand "$w.snd.sb set" \
		-exportselection 0
	scrollbar $w.evs.sb -orient vertical -command "$w.evs.lb yview" -takefocus 0
	scrollbar $w.snd.sb -orient vertical -command "$w.snd.lb yview" -takefocus 0

#fill lists
	for {set i 0} {$i < 18} {incr i} {
		$w.evs.lb insert end $ASConfig(AuEv,$i)
	}
	$w.snd.lb insert end ".none."
	audio_scandir $w 1
#bindings
	bind $w.f1.e <Return> "audio_scandir $w 0"
	
	bind $w.snd.lb <ButtonRelease> {
		regsub .snd.lb %W .evs.lb other
		set tmp1 [$other curselection]
		if {$tmp1=={}} return
		set tmp2 [%W curselection]
		if {$tmp2=={}} return
		set SoundSelection($tmp1) [expr $tmp2 + 1]
		set ASConfig(AuSnd,$tmp1) $SoundFile($tmp2)
	}
	bind $w.evs.lb <ButtonRelease> {
		regsub .evs.lb %W .snd.lb other
		$other selection clear 0 end
		set cursel [%W curselection]
		if {$cursel=={}} return
		set tmp $SoundSelection($cursel)
		$other activate $tmp
		$other selection set $tmp
		$other see $tmp
	}
	bind $w.snd.lb <1> {
		regsub .snd.lb %W .evs.lb other
		set tmp1 [$other curselection]
		if {$tmp1=={}} return
		set tmp2 [%W index @%x,%y]
		if {$tmp2=={}} return
		set SoundSelection($tmp1) [expr $tmp2 + 1]
		set ASConfig(AuSnd,$tmp1) $SoundFile($tmp2)
	}
	bind $w.evs.lb <1> {
		regsub .evs.lb %W .snd.lb other
		$other selection clear 0 end
		set tmp $SoundSelection([%W index @%x,%y])
		$other selection set $tmp
		$other see $tmp
	}	
	bind $w.snd.lb <Double-1> "play $w"
	
	#make first event selected by default
	$w.evs.lb selection set 0
	$w.snd.lb selection set $SoundSelection(0)
	
	proc play {w} {
		global ASConfig SoundFile
		
		if {[$w.snd.lb index active]>0} {
			set cursel [$w.snd.lb curselection]
			if {$cursel=={}} return
			exec $ASConfig(AuCmd) \
				$ASConfig(AuDir)/$SoundFile($cursel) &
		}	
	}
#place listboxes
	place $w.l2 -x 5 -y 45 -width 155 -height 20
	place $w.l3 -x 165 -y 45 -width 155 -height 20
	place $w.evs -x 5 -y 67 -width 155 -height 110
	place $w.snd -x 165 -y 67 -width 155 -height 110
	place $w.evs.sb -in $w.evs -x -1 -y -1 -width 20 -height 108
	place $w.snd.sb -in $w.snd -x -1 -y -1 -width 20 -height 108
	place $w.evs.lb -in $w.evs -x 20 -y 0 -width 132 -height 106
	place $w.snd.lb -in $w.snd -x 20 -y 0 -width 132 -height 106
#buttons
	button $w.test -text "Play" -pady 1 -command "play $w"
#	button $w.save -text "Save" -pady 1
#	button $w.undo -text "Load" -pady 1
#	place $w.save -x 330  -y 95 -width 52
#	place $w.undo -x 330  -y 120 -width 52
	place $w.test -x 330  -y 155 -width 52

	pack $w -fill both -expand y
}

#---------------------------------------------------------------
# wharf editor
#---------------------------------------------------------------
proc module_wharf {rw w} {
	global ASConfig ASCPConfig MenuValue Wharf CurIndex InFolder

	wm title $rw $ASConfig(wtitle,6)
	
	if {![info exists Wharf(idx)]} {
		set CurIndex 0
		set Wharf(idx) {}
	} elseif {![info exists CurIndex]} {
		set CurIndex [llength Wharf(idx)]
	}
	set InFolder 0
#--- internal commands
	# remake listbox
	proc set_actionlist {w} {
		global Wharf
		
		$w.f1.lb1 delete 0 end
		set infolder 0
		foreach i $Wharf(idx) {
			if {[lindex $Wharf(cmd,$i) 0]=="EndFolder"} {
				set infolder 0
			} 
			if {$infolder} {
				$w.f1.lb1 insert end "    $Wharf(cmd,$i)"
			} else {
				$w.f1.lb1 insert end $Wharf(cmd,$i)
			}
			if {[lindex $Wharf(cmd,$i) 0]=="Folder"} {
				set infolder 1
			}
		}
		$w.b2 configure -foreground black
	}
	#adds a new command or changes a existing one
	proc add_cmd {w position} {
		global MenuValue CurIndex Wharf InFolder

		proc get_label {t} {
			set lab [lindex [split [lindex $t 0] /] end]
			if {$lab=={}} {return {}}
			if {[string range $lab 0 0]=="x"} {
				set l [string toupper [string range $lab 0 1]]
				set la "$l[string range $lab 2 end]"
			} else {
				set l [string toupper [string range $lab 0 0]]
				set la "$l[string range $lab 1 end]"
			}
			return $la
		}
		set icon [string trim [$w.f2.e get]]
		set action [string trim [$w.e2 get]]
		set index $CurIndex
		if {$MenuValue=="Exec" || $MenuValue=="Swallow" || \
			$MenuValue=="MaxSwallow"} {
			if {$action=={}} {return 0}
			set Wharf(cmd,$index) \
				"$MenuValue\t\"[get_label $action]\" $action"
			set Wharf(ico,$index) "$icon"
			$w.f1.lb1 insert $position "$MenuValue $action"
		} else {
		#--- folder, quit, restart, etc.
			$w.f1.lb1 insert $position $MenuValue
 			set Wharf(cmd,$index) "$MenuValue"
			if {$MenuValue == "EndFolder"} {
				set InFolder 0
				set Wharf(ico,$index) {}
				$w.level configure -text "in Main"
			} else {
				set InFolder 1
				set Wharf(ico,$index) "$icon"
				$w.level configure -text "in Folder"
			}
		}
		return 1
	}
	#handles push in the Add button
	proc push_add {w} {
		global CurIndex MenuValue InFolder Wharf

		if {!$InFolder && $MenuValue=="EndFolder"} return
		#nested folders and Swallows are  not supported in Wharf
		if {$InFolder && ($MenuValue=="Folder" || $MenuValue=="Swallow" \
			|| $MenuValue=="MaxSwallow")} return
		if {[set idx [$w.f1.lb1 curselection]]=={}} {
			set idx [$w.f1.lb1 size]
		} else {
			incr idx
		}
		if {![add_cmd $w $idx]} return
		$w.e2 selection range 0 end
		$w.f2.e selection range 0 end
		set curpos [$w.f1.lb1 curselection]
		if {$curpos=={}} {set curpos [$w.f1.lb1 size]} else {incr curpos}
		set Wharf(idx) [linsert $Wharf(idx) $curpos $CurIndex]
		set_actionlist $w
		$w.f1.lb1 selection set $curpos
		$w.f1.lb1 see $curpos
		incr CurIndex		
	}
	#changes current entry
	proc push_chg {w} {
		global CurIndex MenuValue InFolder Wharf

#		if {!$InFolder && $MenuValue=="EndFolder"} return
		#nested folders and Swallows are  not supported in Wharf
#		if {$InFolder && ($MenuValue=="Folder" || $MenuValue=="Swallow" \
#			|| $MenuValue=="MaxSwallow")} return
		if {[set idx [$w.f1.lb1 curselection]]=={}} {
			set idx [expr [$w.f1.lb1 size] -1]
		}
		set backup $CurIndex
		set CurIndex [lindex $Wharf(idx) $idx]
		if {![add_cmd $w $idx]} return
		set CurIndex $backup
		$w.e2 selection range 0 end
		$w.f2.e selection range 0 end
		set_actionlist $w
		$w.f1.lb1 selection set $idx
		$w.f1.lb1 see $idx
		show_select $w
	}
	#delete entry
	proc del_cmd {w} {
		global CurIndex Wharf

		if {[$w.f1.lb1 size]==0} return
		if {[set idx [$w.f1.lb1 curselection]]=={}} {
			return
		}
		set lidx [lindex $Wharf(idx) $idx]
		unset Wharf(cmd,$lidx)
		unset Wharf(ico,$lidx)
		set Wharf(idx) [lreplace $Wharf(idx) $idx $idx]
		set_actionlist $w
		$w.f1.lb1 selection set $idx
		$w.f1.lb1 see $idx
		show_select $w
	}
	#shows selected entry settings
	proc show_select {w {pos -}} {
		global MenuValue Wharf InFolder
		
		if {![$w.f1.lb1 size]} return
		if {$pos=="-"} {
			set cur [$w.f1.lb1 curselection]
			if {$cur=={}} {set cur 0}
		} else {
			set cur [$w.f1.lb1 index @$pos]
		}
		set item [$w.f1.lb1 get $cur]
		set cmd [lindex $item 0]
		if {$cmd=="Folder" || [string range "$item" 0 3]=="    "} {
			$w.level configure -text "in Folder"
		} else {$w.level configure -text "in Main"}
		set MenuValue [lindex $item 0]
		$w.e2 delete 0 end
		$w.f2.e delete 0 end
		set ind [lindex $Wharf(idx) $cur]
		$w.f2.e insert 0 $Wharf(ico,$ind)
		set citem $Wharf(cmd,$ind)
		preview $w		
		if {[llength $citem]<2} return
		$w.e2 insert 0 [string trim [lrange $citem 2 end]]; #[string range "$citem" [string first "\t" $citem] end]]
	}
	#move up current entry
	proc move_up {w} {
		global Wharf
		
		set idx [$w.f1.lb1 curselection]
		if {$idx=={} || $idx==0} return
		set cur [lindex $Wharf(idx) $idx]
		set pidx [expr $idx - 1]
		set prev [lindex $Wharf(idx) $pidx]
		set Wharf(idx) [lreplace $Wharf(idx) $idx $idx $prev]
		set Wharf(idx) [lreplace $Wharf(idx) $pidx $pidx $cur]
		set_actionlist $w
		$w.f1.lb1 selection set $pidx
		$w.f1.lb1 see $pidx
	}
	#move down current entry
	proc move_down {w} {
		global Wharf
		
		set idx [$w.f1.lb1 curselection]
		if {$idx=={} || $idx==[expr [$w.f1.lb1 size]-1]} return
		set cur [lindex $Wharf(idx) $idx]
		set nidx [expr $idx + 1]
		set next [lindex $Wharf(idx) $nidx]
		set Wharf(idx) [lreplace $Wharf(idx) $idx $idx $next]
		set Wharf(idx) [lreplace $Wharf(idx) $nidx $nidx $cur]
		set_actionlist $w
		$w.f1.lb1 selection set $nidx
		$w.f1.lb1 see $nidx		
	}	
#--- layout
	label $w.l1 -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text "Action" -relief sunken
	frame $w.f1 -bd 2 -relief sunken
	listbox $w.f1.lb1 -relief flat -yscrollcommand "$w.f1.sb set" \
		-exportselection 0
	scrollbar $w.f1.sb -orient vertical -takefocus 0\
		-command "$w.f1.lb1 yview"
	place $w.l1 -x 5 -y 5 -width 220 -height 20
	place $w.f1 -x 5 -y 25 -width 220 -height 100
	place $w.f1.sb -x -1 -y -1 -width 20 -height 98
	place $w.f1.lb1 -x 20 -y 0 -width 196 -height 96
	
	label $w.level -text "in Main" -font $ASCPConfig(font,helvb)
	place $w.level -x 230 -y 5

	set MenuValue Exec
	tk_optionMenu $w.menu MenuValue Exec Swallow MaxSwallow Folder "EndFolder" Restart Quit
	$w.menu configure -pady 1
	button $w.b1 -text "Add" -pady 1 -command "push_add $w" -indicatoron 1
	button $w.b2 -text "Change" -pady 1 -command "push_chg $w"
	button $w.b3 -text "Delete" -pady 1 -command "del_cmd $w"
	button $w.b4 -image ASCPConfig(img,up) -pady 1 -command "move_up $w"
	button $w.b5 -image ASCPConfig(img,down) -pady 1 -command "move_down $w"
	entry $w.e2 -exportselection 0	

	frame $w.f2 -text "Icon" -bd 2 -relief groove
	entry $w.f2.e -exportselection 0
#---
	xpmPreview blank
	button $w.xpmv -relief groove -image xpmPreview -command "preview $w"
	bind $w.xpmv <Drop> "handle_drop $w %P %D"

	proc handle_drop {w type file} {
		if {$type!="File"} return
		$w.f2.e delete 0 end
		$w.f2.e insert 0 [getIconName $file]
		preview $w
	}

	proc preview {w} {
		image delete xpmPreview
		image create photo xpmPreview
		if {[set xpm [$w.f2.e get]]=={}} return
		if {[set file [findIconFile $xpm]]=={}} return
		xpmPreview read $file
	}
	preview $w
	place $w.xpmv -x 315 -y 100 -width 68 -height 68

	place $w.menu -x 230 -y 25 -width 120
	place $w.f2 -x 230 -y 50 -width 150 -height 40
	place $w.f2.e -x 4 -y 11 -width 138 -height 20

	place $w.e2 -x 5 -y 130 -width 220 -height 20

	place $w.b1 -x 5 -y 155 -width 65
	place $w.b2 -x 75 -y 155 -width 65
	place $w.b3 -x 145 -y 155 -width 65
	place $w.b4 -x 230 -y 95 -width 30
	place $w.b5 -x 230 -y 110 -width 30
	
	pack $w -fill both -expand y
#---- bindings
	bind $rw <Return> "invoke $w.b1"
	bind $w.f1.lb1 <ButtonRelease-1> "show_select $w %x,%y"
	bind $w.f1.lb1 <KeyPress> "show_select $w"
	set_actionlist $w
	$w.f1.lb1 selection set [$w.f1.lb1 size]
	show_select $w
#---- check for command type changes
	while {1} {
		tkwait variable MenuValue
		if [string length $CurIndex] continue
		switch $MenuValue {
			Exec {
				$w.b3 configure -state disabled
			}
			Swallow {
				$w.b3 configure -state disabled
			}
			MaxSwallow {
				$w.b3 configure -state disabled
			}
			Folder {
				$w.b3 configure -state normal
			}
			Restart {
				$w.b3 configure -state disabled
			}
			Quit {
				$w.b3 configure -state disabled
			}
		}
	}
}


#---------------------------------------------------------------
# Edit paths
#---------------------------------------------------------------
proc module_aspaths {rw w} {
	global ASConfig ASCPConfig 

	wm title $rw $ASConfig(wtitle,7)
	
	frame $w.f1 -text "Pixmap Path" -bd 2 -relief groove
	entry $w.f1.e -textvariable ASConfig(pixPath)	
	frame $w.f2 -text "Icon Path" -bd 2 -relief groove
	entry $w.f2.e -textvariable ASConfig(icoPath)
	frame $w.f3 -text "Module Path" -bd 2 -relief groove
	entry $w.f3.e -textvariable ASConfig(modPath)	
	frame $w.f4 -text "Sound Path" -bd 2 -relief groove
	entry $w.f4.e -textvariable ASConfig(AuDir)
	frame $w.f5 -text "Sound Player" -bd 2 -relief groove
	entry $w.f5.e -textvariable ASConfig(AuCmd)
	place $w.f1 -x 5 -y 0 -width 375 -height 40
	place $w.f1.e -x 4 -y 11 -width 361 -height 20
	place $w.f2 -x 5 -y 45 -width 375 -height 40
	place $w.f2.e -x 4 -y 11 -width 361 -height 20
	place $w.f3 -x 5 -y 90 -width 375 -height 40
	place $w.f3.e -x 4 -y 11 -width 361 -height 20
	place $w.f4 -x 5 -y 135 -width 180 -height 40
	place $w.f4.e -x 4 -y 11 -width 166 -height 20

	place $w.f5 -x 200 -y 135 -width 180 -height 40
	place $w.f5.e -x 4 -y 11 -width 166 -height 20

	pack $w -fill both -expand y
#bindings
	for {set i 1} {$i<5} {incr i} {
		bind $w.f$i.e <Drop> {if {"%P"=="Dir"} {%W delete 0 end
					%W insert 0 %D}}
	}
	bind $w.f5.e <Drop> {if {"%P"=="Exec"} {%W delete 0 end
					%W insert 0 %D}}
}

#---------------------------------------------------------------
#
# Configure single app options
#
#
# Configuration format is
# Windows(window_name,setting) value
# Windows(idx)	{window_name1 window_name2 etc.}
#---------------------------------------------------------------
proc module_windowops {rw w} {
	global ASConfig ASCPConfig Windows

	wm title $rw $ASConfig(wtitle,8)
	
#window list
	label $w.lab -bd 2 -relief sunken -bg gray30 -text "Windows" \
		-fg white -font $ASCPConfig(font,helvb)
	place $w.lab -x 5 -y 5 -width 120 -height 20

	frame $w.app -bd 2 -relief sunken
	listbox $w.app.lb -bd 0 -relief flat -yscrollcommand "$w.app.sb set" \
		-exportselection 0
	scrollbar $w.app.sb -command "$w.app.lb yview"
	place $w.app.sb -in $w.app -x -1 -y -1 -width 20 -height 147
	place $w.app.lb -in $w.app -x 20 -y 0 -width 95 -height 146
	place $w.app -x 5 -y 27 -width 120 -height 150

#options
	frame $w.name -bd 2 -relief groove -text "Window Name"
	entry $w.name.e -textvariable Windows(name) -exportselection 0
	frame $w.icon -bd 2 -relief groove -text "Icon"
	entry $w.icon.e -textvariable Windows(icon) -exportselection 0

	checkbutton $w.stic -text "Stick on Page" -anchor w \
		-variable Windows(sticky) -command "mark_change $w"
	checkbutton $w.noti -text "No Titlebar" -anchor w \
		-variable Windows(notitle) -command "mark_change $w"
	checkbutton $w.noha -text "No Handle" -anchor w \
		-variable Windows(nohandle) -command "mark_change $w"
	checkbutton $w.top -text "Always on Top" -anchor w \
		-variable Windows(ontop) -command "mark_change $w"
	checkbutton $w.skip -text "Not in Window List" -anchor w \
		-variable Windows(skip) -command "mark_change $w"
	checkbutton $w.nofc -text "No focus" -anchor w \
		-variable Windows(nofocus) -command "mark_change $w"
	checkbutton $w.sico -text "Start iconic" -anchor w \
		-variable Windows(startico) -command "mark_change $w"
		
	xpmPreview blank
	button $w.xpmv -relief groove -image xpmPreview -command "preview $w"
#
	place $w.xpmv -x 290 -y 52 -width 52 -height 52

	place $w.stic -x 135 -y 5
	place $w.noti -x 135 -y 25
	place $w.noha -x 135 -y 45
	place $w.top -x 250 -y 5
	place $w.skip -x 250 -y 25
	place $w.nofc -x 135 -y 85
	place $w.sico -x 135 -y 65

	place $w.name.e -in $w.name -x 4 -y 12 -width 106 -height 20
	place $w.name -x 135 -y 106 -width 120 -height 42
	place $w.icon.e -in $w.icon -x 4 -y 12 -width 106 -height 20
	place $w.icon -x 260 -y 106 -width 120 -height 42
#buttons
	button $w.add -text "Add" -pady 1 -padx 6 -command "add_window $w"\
		-indicatoron 1
	button $w.chg -text "Change" -pady 1 -padx 6 -command "chg_window $w
						$w.chg configure -fg black"
	button $w.rem -text "Delete" -pady 1 -padx 6 -command "del_window $w"
	place $w.add -x 135 -y 155 -width 60
	place $w.chg -x 200 -y 155 -width 60
	place $w.rem -x 265 -y 155 -width 60
	pack $w -fill both -expand y
#bindings
	bind $rw <Return> "invoke $w.add"
	bind $w.app.lb <ButtonRelease> "upd_view $w
			$w.chg configure -fg black"
	bind $w.name.e <KeyPress> "mark_change $w"
	bind $w.icon.e <KeyPress> "mark_change $w"
	
#fill initial data
	#clear shown_data
	proc clear_view {} {
		global Windows
	 	set Windows(name) {}
		set Windows(icon) {}
	 	set Windows(sticky) 0
	 	set Windows(notitle) 0
	 	set Windows(nohandle) 0
	 	set Windows(ontop) 0
	 	set Windows(skip) 0
	 	set Windows(nofocus) 0
	 	set Windows(startico) 0
	}	
	foreach i $Windows(idx) {
		$w.app.lb insert end $i
	}
	clear_view
#commands
	bind $w.xpmv <Drop> "handle_drop $w %P %D"

	proc handle_drop {w type file} {
		if {$type!="File"} return
		$w.icon.e delete 0 end
		$w.icon.e insert 0 [getIconName $file]
		preview $w
	}
	proc preview {w} {
		image delete xpmPreview
		image create photo xpmPreview
		if {[set xpm [$w.icon.e get]]=={}} return
		if {[set file [findIconFile $xpm]]=={}} return
		xpmPreview read $file
	}
	preview $w
	#remind user about changes
	proc mark_change {w} {
		if {[$w.app.lb curselection] == {}} return
		$w.chg configure -fg red
	}
	#change settings of the current win
	proc chg_window {w} {
		global Windows

		if {$Windows(name) == {}} return
		if {[set idx [$w.app.lb curselection]]=={}} {
			return
		}
		set oldname [$w.app.lb get $idx]
		set curwin $Windows(name)
		$w.app.lb delete $idx
		$w.app.lb insert $idx $curwin
		$w.app.lb selection set $idx
		set lidx [lsearch -exact $Windows(idx) $oldname]
		set Windows(idx) [lreplace $Windows(idx) $lidx $lidx $curwin]
		
		unset Windows($oldname,icon)
	 	unset Windows($oldname,sticky)
	 	unset Windows($oldname,notitle)
	 	unset Windows($oldname,nohandle)
	 	unset Windows($oldname,ontop)
	 	unset Windows($oldname,skip)
	 	unset Windows($oldname,nofocus)
	 	unset Windows($oldname,startico)
		
		set Windows($curwin,icon) $Windows(icon)
	 	set Windows($curwin,sticky) $Windows(sticky)
	 	set Windows($curwin,notitle)  $Windows(notitle)
	 	set Windows($curwin,nohandle) $Windows(nohandle)
	 	set Windows($curwin,ontop) $Windows(ontop)
	 	set Windows($curwin,skip) $Windows(skip)
	 	set Windows($curwin,nofocus) $Windows(nofocus)
	 	set Windows($curwin,startico) $Windows(startico)
	}
	#update settings to the selected window in listbox
	proc upd_view {w} {
		global Windows
		
		if {[set idx [$w.app.lb curselection]]!={}} {
			set curwin [$w.app.lb get $idx]
			set Windows(name) $curwin
			set Windows(icon) $Windows($curwin,icon)
		 	set Windows(sticky) $Windows($curwin,sticky)
		 	set Windows(notitle) $Windows($curwin,notitle)
		 	set Windows(nohandle) $Windows($curwin,nohandle)
		 	set Windows(ontop) $Windows($curwin,ontop)
		 	set Windows(skip) $Windows($curwin,skip)
		 	set Windows(nofocus) $Windows($curwin,nofocus)
		 	set Windows(startico) $Windows($curwin,startico)
		} else {
			clear_view
		}
		preview $w
	}
	#add a new window if it's not there, already and set 
	#change button to normal color
	proc add_window {w} {
		global Windows

		if {$Windows(name) == {}} return
		if {[lsearch -exact $Windows(idx) $Windows(name)]>=0} {
			return
		}
		$w.app.lb insert end $Windows(name)
		$w.app.lb selection clear 0 end
		set curwin $Windows(name)
		lappend Windows(idx) $curwin
		set Windows($curwin,icon) $Windows(icon)
	 	set Windows($curwin,sticky) $Windows(sticky)
	 	set Windows($curwin,notitle)  $Windows(notitle)
	 	set Windows($curwin,nohandle) $Windows(nohandle)
	 	set Windows($curwin,ontop) $Windows(ontop)
	 	set Windows($curwin,skip) $Windows(skip)
	 	set Windows($curwin,nofocus) $Windows(nofocus)
	 	set Windows($curwin,startico) $Windows(startico)
		
		clear_view		
		$w.chg configure -fg black
	}
	#delete the selected window and set change button to normal color
	proc del_window {w} {
		global Windows

		if {$Windows(name) == {}} return
		if {[set idx [$w.app.lb curselection]]!={}} {
			set curwin [$w.app.lb get $idx]
			if {[set lidx [lsearch -exact $Windows(idx) $curwin]]>=0} {
				set Windows(idx) [lreplace $Windows(idx)\
						$lidx $lidx]
			}
			$w.app.lb delete $idx
			unset Windows($curwin,icon)
		 	unset Windows($curwin,sticky)
		 	unset Windows($curwin,notitle)
		 	unset Windows($curwin,nohandle)
		 	unset Windows($curwin,ontop)
		 	unset Windows($curwin,skip)
	 		unset Windows($curwin,nofocus)
		 	unset Windows($curwin,startico)			
		}
		clear_view
		$w.chg configure -fg black		
	}
}

#---------------------------------------------------------------
#wharf layout
#---------------------------------------------------------------
proc module_wharfprefs {rw w} {
	global ASConfig ASCPConfig ASCPLibDir
	
	wm title $rw $ASConfig(wtitle,10)

	checkbutton $w.anim -text "Animate Folders" -anchor w \
			-variable ASConfig(whanim)
	checkbutton $w.animm -text "Animate Main Folder" -anchor w \
			-variable ASConfig(whanimm)			
	checkbutton $w.bord -text "Draw border" -anchor w \
			-variable ASConfig(whborder)	
	checkbutton $w.fpsh -text "Push whole button" -anchor w \
			-variable ASConfig(whfpush)
	checkbutton $w.dis -text "Disable Wharf" -anchor w \
			-variable ASConfig(whdisable)

	place $w.anim  -x 10 -y 5
	place $w.animm -x 10 -y 25
	place $w.bord  -x 10 -y 45
	place $w.fpsh  -x 10 -y 65

	place $w.dis -x 10 -y 125

	frame $w.pos -text "Position" -bd 2 -relief groove
	image create bitmap box -file $ASCPLibDir[]$ASConfig(whpos)
	radiobutton $w.pos.b0 -image box -variable ASConfig(whcorner) \
		-value nw -anchor nw -indicatoron 0
	radiobutton $w.pos.b1 -image box -variable ASConfig(whcorner) \
		-value ne -anchor ne -indicatoron 0
	radiobutton $w.pos.b2 -image box -variable ASConfig(whcorner) \
		-value sw -anchor sw -indicatoron 0
	radiobutton $w.pos.b3 -image box -variable ASConfig(whcorner) \
		-value se -anchor se -indicatoron 0
	
	place $w.pos -x 290 -y 90 -width 85 -height 75
	place $w.pos.b0 -x 5 -y 14 -width 35 -height 25
	place $w.pos.b1 -x 40 -y 14 -width 35 -height 25
	place $w.pos.b2 -x 5 -y 39 -width 35 -height 25
	place $w.pos.b3 -x 40 -y 39 -width 35 -height 25
	
	frame $w.dir -text "Geometry" -bd 2 -relief groove
	for {set i 0} {$i < 2} {incr i} {
		image create bitmap $w.d$i -file $ASCPLibDir[]$ASConfig(dir,$i)
		radiobutton $w.dir.dt$i -image $w.d$i -indicatoron 0 \
			-variable  ASConfig(whdir) -value $i -command "set_geo $w"
		place $w.dir.dt$i -x [expr 30 * $i + 25] -y 14 -width 26 -height 26
	}	
	entry $w.dir.size -textvariable ASConfig(wsize) -justify right
	button $w.dir.l -image ASCPConfig(img,left) -command {if {$ASConfig(wsize)>1} {incr ASConfig(wsize) -1}}
	button $w.dir.r -image ASCPConfig(img,right) -command {incr ASConfig(wsize)}

	label $w.dir.ls -text "Columns"
	place $w.dir.size -x 58 -y 48 -width 35 -height 20
	place $w.dir.ls -x 4 -y 48
	place $w.dir -x 170 -y 5 -width 105 -height 100
	place $w.dir.l -in $w.dir -x 60 -y 72
	place $w.dir.r -in $w.dir -x 76 -y 72
	pack $w -fill both -expand y
#procedures	
	proc set_geo {w} {
		global ASConfig
		
		if {$ASConfig(whdir)} {	
			$w.dir.ls config -text "Rows"
		} else {
			$w.dir.ls config -text "Columns"
		}
	}
}

#---------------------------------------------------------------
# menu binding editor
#---------------------------------------------------------------
proc module_menus {rw w} {
	global ASConfig ASCPConfig ASMenus MenuValue MnIndex

	wm title $rw $ASConfig(wtitle,9)
	#this is necessary to clean up some tkwaits in other modules
	set MenuValue {}
	
	frame $w.menus -bd 2 -relief sunken
	frame $w.cmds -bd 2 -relief sunken
	listbox $w.menus.lb -relief flat -bd 0 -exportselection 0 \
		-yscrollcommand "$w.menus.sb set"
	listbox $w.cmds.lb -relief flat -bd 0 -exportselection 0 \
		-yscrollcommand "$w.cmds.sb set"
	scrollbar $w.menus.sb -command "$w.menus.lb yview"
	scrollbar $w.cmds.sb -command "$w.cmds.lb yview"
	label $w.l1 -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text "Menus" -relief sunken
	label $w.l2 -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text "Commands" -relief sunken
	entry $w.mname -exportselection 0
	button $w.madd -text "Add" -pady 1 -padx 6 -command "add_menu $w"
	button $w.mdel -text "Delete" -pady 1 -padx 6 -command "del_menu $w"
	set MenuValue Exec
	tk_optionMenu $w.menu MenuValue Exec Module PopUp Function Restart \
		Quit Raise Lower PutOnTop Iconify Stick Maximize Destroy \
		Close Refresh Shade 
	button $w.cadd -text "Add" -pady 1 -padx 6 -command "add_cmd $w" \
		-indicatoron 1
	button $w.cdel -text "Delete" -pady 1 -padx 6 -command "del_cmd $w"

	frame $w.mtitle -text "Menu Title" -bd 2 -relief groove
	entry $w.mtitle.e -exportselection 0

	frame $w.title -text "Entry Title" -bd 2 -relief groove
	entry $w.title.e -exportselection 0
	entry $w.cmd -exportselection 0	
	focus $w.title.e

	button $w.up -image ASCPConfig(img,up) -command "move_up $w"
	button $w.down -image ASCPConfig(img,down) -command "move_down $w"
#--- layout
	place $w.l1 -x 5 -y 5 -width 100 -height 20
	place $w.l2 -x 110 -y 5 -width 130 -height 20
	place $w.menus.sb -in $w.menus -x -1 -y -1 -width 20 -height 95
	place $w.menus.lb -in $w.menus -x 20 -y 0 -width 76 -height 94
	place $w.menus -x 5 -y 26 -width 100 -height 99
	place $w.cmds.sb -in $w.cmds -x -1 -y -1 -width 20 -height 95
	place $w.cmds.lb -in $w.cmds -x 20 -y 0 -width 106 -height 94
	place $w.cmds -x 110 -y 26 -width 130 -height 99
#menu
	place $w.mname -x 5 -y 128 -width 100 -height 20
	place $w.madd -x 5 -y 153 -width 40
	place $w.mdel -x 50 -y 153 -width 54

#cmd
	place $w.menu -x 250 -y 128 -width 100 -height 25
	place $w.mtitle -x 250 -y 0 -width 130 -height 45
	place $w.mtitle.e -x 5 -y 14 -width 115 -height 20	
	place $w.title -x 250 -y 50 -width 130 -height 45
	place $w.title.e -x 5 -y 14 -width 115 -height 20
	place $w.cmd -x 110 -y 155 -width 260 -height 20
	place $w.cadd -x 250 -y 100 -width 60
	place $w.cdel -x 320 -y 100 -width 60
#move
	place $w.up -x 110 -y 128 -width 60 -height 18
	place $w.down -x 175 -y 128 -width 60 -height 18

	pack $w -fill both -expand y
#--- bindings
	bind $w.menus.lb <ButtonRelease-1> "select_menu $w;move_entry $w %x,%y"
	bind $w.menus.lb <1> "set MoveStart %x,%y"
	bind $w.cmds.lb <ButtonRelease-1> "select_cmd $w"
	bind $rw <Return> "invoke $w.cadd"
	bind $w.menus.lb <2> "change_name $w %x,%y"
#--- commands
	global MoveStart
	set MoveStart {}
	proc change_name {w pos} {
		global ASMenus
		set name [$w.mname get]
		if {$name=={}} return
		set ind [$w.menus.lb index @$pos]
		if {$ind=={}} return		
		set oname [$w.menus.lb get $ind]
		if {[lsearch -exact $ASMenus(idx) $name]>-1} return
		set oind [$w.menus.lb curselection]
		$w.menus.lb delete $ind
		$w.menus.lb insert $ind $name
		if {$ind==$oind} {
			$w.menus.lb selection set $ind
		}
		set ASMenus($name,idx) $ASMenus($oname,idx)
		set ASMenus(idx) [$w.menus.lb get 0 end]
		foreach i $ASMenus($name,idx) {
			set ASMenus($name,$i,t) $ASMenus($oname,$i,t)
			set ASMenus($name,$i,c) $ASMenus($oname,$i,c)
		}
	}	
	#move up current entry
	proc move_up {w} {
		global ASMenus

		set cursel [$w.menus.lb curselection]
		if {$cursel=={}} return
		set m [$w.menus.lb get $cursel]
		set idx [$w.cmds.lb curselection]
		if {$idx=={} || $idx==0} return
		set cur [lindex $ASMenus($m,idx) $idx]
		set pidx [expr $idx - 1]
		set prev [lindex $ASMenus($m,idx) $pidx]
		set ASMenus($m,idx) [lreplace $ASMenus($m,idx) $idx $idx $prev]
		set ASMenus($m,idx) [lreplace $ASMenus($m,idx) $pidx $pidx $cur]
		select_menu $w
		$w.cmds.lb selection clear 0 end
		$w.cmds.lb selection set $pidx
		select_cmd $w
	}
	#move down current entry
	proc move_down {w} {
		global ASMenus

		set cursel [$w.menus.lb curselection]
		if {$cursel=={}} return
		set m [$w.menus.lb get $cursel]
		set idx [$w.cmds.lb curselection]
		if {$idx=={} || $idx==[expr [$w.cmds.lb size]-1]} return
		set cur [lindex $ASMenus($m,idx) $idx]
		set nidx [expr $idx + 1]
		set next [lindex $ASMenus($m,idx) $nidx]
		set ASMenus($m,idx) [lreplace $ASMenus($m,idx) $idx $idx $next]
		set ASMenus($m,idx) [lreplace $ASMenus($m,idx) $nidx $nidx $cur]
		select_menu $w
		$w.cmds.lb selection clear 0 end
		$w.cmds.lb selection set $nidx
		select_cmd $w
	}
	proc move_entry {w pos} {
		global ASMenus MoveStart
		if {$MoveStart=={}} return
		set entry [$w.menus.lb get @$MoveStart]
		if {$entry=={}} return
		set old [$w.menus.lb index @$MoveStart]
		set new [$w.menus.lb index @$pos]
		if {$old==$new} return
		$w.menus.lb delete $old
		$w.menus.lb insert $new $entry
		$w.menus.lb selection clear 0 end
		$w.menus.lb selection set $new		
		set MoveStart {}
		set ASMenus(idx) [$w.menus.lb get 0 end]
		select_menu $w
	}
	proc select_cmd {w} {
		global ASMenus MenuValue
		
		set cursel [$w.menus.lb curselection]
		if {$cursel=={}} return
		set menu [$w.menus.lb get $cursel]
		set idx [$w.cmds.lb curselection]
		if {$idx=={}} {
			$w.title.e delete 0 end
			$w.cmd delete 0 end		
			return
		}
		$w.title.e delete 0 end
		set lidx [lindex $ASMenus($menu,idx) $idx]
		$w.title.e insert 0 $ASMenus($menu,$lidx,t)
		
		set MenuValue [lindex $ASMenus($menu,$lidx,c) 0]
		$w.cmd delete 0 end
		$w.cmd insert 0 [string trim [string range "$ASMenus($menu,$lidx,c)" \
				[string first " " $ASMenus($menu,$lidx,c)] end]]		
	}
	proc select_menu {w} {
		global ASMenus MnIndex
		
		set idx [$w.menus.lb curselection]
		if {$idx=={}} return
		set menu [$w.menus.lb get $idx]
		$w.cmds.lb delete 0 end
#		$w.mtitle.e delete 0 end
		$w.mtitle.e config -textvariable ASMenus($menu,0,t)
		foreach i $ASMenus($menu,idx) {
			$w.cmds.lb insert end $ASMenus($menu,$i,t)
		}
		set MnIndex [expr $i + 1]
		$w.cmds.lb selection clear 0 end
		$w.cmds.lb selection set 0
		$w.mname delete 0 end
		$w.mname insert 0 $menu
		select_cmd $w
	}
	proc add_menu {w} {
		global ASMenus
		
		set menu [$w.mname get]
		if {$menu=={}} return
		if {[lsearch -exact $ASMenus(idx) $menu]>=0} return
		lappend ASMenus(idx) $menu
		set ASMenus($menu,idx) {}
		$w.menus.lb insert end $menu
		$w.menus.lb selection clear 0 end
		$w.menus.lb selection set end
		$w.menus.lb see end
		$w.mtitle.e config -textvariable ASMenus($menu,0,t)
		select_menu $w
		select_cmd $w
	}

	proc del_menu {w} {
		global ASMenus	
		set idx [$w.menus.lb curselection]
		if {$idx=={}} return
		set name [$w.menus.lb get $idx]
		foreach i $ASMenus($name,idx) {
			unset ASMenus($name,$i,t)
			unset ASMenus($name,$i,c)
		}
		unset ASMenus($name,0,t)
		unset ASMenus($name,0,c)
		unset ASMenus($name,idx)
		set lidx [lsearch -exact $ASMenus(idx) $name]
		set ASMenus(idx) [lreplace $ASMenus(idx) $lidx $lidx]
		$w.mname delete 0 end
		set prev [$w.menus.lb curselection]
		if {$prev=={}} {set prev end}
		$w.menus.lb delete $idx		
		$w.menus.lb selection clear 0 end
		$w.menus.lb selection set $prev
		$w.menus.lb see $prev
		select_menu $w
		$w.cmds.lb delete 0 end
		select_cmd $w
	}
#---	
	proc add_cmd {w} {
		global ASMenus MenuValue MnIndex
		
		set title [$w.title.e get]
		if {$title=={}} return
		set cmd [$w.cmd get]
		if {$MenuValue=="Exec" || $MenuValue=="Module" \
			|| $MenuValue=="PopUp" ||$MenuValue=="Restart"} {
			if {$cmd=={}} return
		} else {
			set cmd {}
		}
		set idx [$w.menus.lb curselection]
		if {$idx=={}} return		
		set prev [$w.cmds.lb curselection]
		if {$prev=={}} {set prev end} else {incr prev}
		set menu [$w.menus.lb get $idx]
		if {[set place [lsearch [$w.cmds.lb get 0 end] $title]]>=0} {
			set place [lindex $ASMenus($menu,idx) $place]
			puts $place
			puts $ASMenus($menu,$place,c)
			set ASMenus($menu,$place,c) "$MenuValue $cmd"
			return
		}
		set ASMenus($menu,idx) [linsert $ASMenus($menu,idx) $prev $MnIndex]
		set ASMenus($menu,$MnIndex,c) "$MenuValue $cmd"
		set ASMenus($menu,$MnIndex,t) $title
		incr MnIndex
		$w.title.e selection range 0 end
		$w.cmd selection range 0 end
		$w.cmds.lb insert $prev $title
		$w.cmds.lb selection clear 0 end
		$w.cmds.lb selection set $prev
		$w.cmds.lb see $prev
	}

	proc del_cmd {w} {
		global ASMenus
		set idx [$w.menus.lb curselection]
		if {$idx=={}} return
		set name [$w.menus.lb get $idx]
		set cursel [$w.cmds.lb curselection]
		if {$cursel=={}} return
		set lidx [lindex $ASMenus($name,idx) $cursel]
		set ASMenus($name,idx) [lreplace $ASMenus($name,idx) $cursel $cursel]
		unset ASMenus($name,$lidx,c)
		unset ASMenus($name,$lidx,t)
		set prev [$w.cmds.lb curselection]
		if {$prev=={}} {set prev end}
		$w.cmds.lb delete $cursel		
		$w.cmds.lb selection clear 0 end
		$w.cmds.lb selection set $prev
		$w.cmds.lb see $prev
		select_cmd $w
	}
#--- initialize lists
	if {![info exists ASMenus(idx)]} {
		set ASMenus(idx) {}
		set MnIndex 0
	} else {
		if {![info exists MnIndex]} {
			set MnIndex [llength $ASMenus(idx)]
		}
		foreach i $ASMenus(idx) {
			$w.menus.lb insert end $i
		}
		$w.menus.lb selection set 0
		select_menu $w
	}	
}

#---------------------------------------------------------------
# keyboard bindings
#---------------------------------------------------------------
proc module_keybind {rw w} {
	global ASConfig ASCPConfig KeyBind KbIndex ASCPLibDir

	wm title $rw $ASConfig(wtitle,11)

	label $w.lkeys -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text "Bindings" -relief sunken

	frame $w.keys -bd 2 -relief sunken
	listbox $w.keys.lb -yscrollcommand "$w.keys.sb set" -bd 0\
		-exportselection 0
	scrollbar $w.keys.sb -command "$w.keys.lb yview"
	checkbutton $w.guess -anchor w -text "Type keyname" -command "rebind $w"\
		-variable TypeKey
	frame $w.where -bd 2 -relief groove -text "Context"
#context
	proc select_ctx {w i} {
		global KeyBind
		if {$KeyBind(cs,$i)<0} {return} elseif {$KeyBind(cs,$i)} {
		    $w.where.c$i configure -activebackground yellow
		    if {$i==4} {
			$w.where.c7 configure -activebackground yellow
		    }
		} else {
		    $w.where.c$i configure -activebackground gray
		    if {$i==4} {
			$w.where.c7 configure -activebackground gray
		    }		    
		}
	}
	if {[catch {ctx cget file}]} {
		for {set i 0} {$i < 7} {incr i} {
		    image create bitmap ctx$i -file $ASCPLibDir[]$ASConfig(ctx,$i) -foreground\
			gray20
		}
	}	
	for {set i 0} {$i < 7} {incr i} {
	    checkbutton $w.where.c$i -anchor w -image ctx$i -indicatoron 0\
		-variable KeyBind(cs,$i) -bd 0 -relief flat \
		-command "select_ctx $w $i" -bg gray -selectcolor yellow
	}
	checkbutton $w.where.c7 -anchor w -image ctx4 -indicatoron 0\
		-variable KeyBind(cs,4) -bd 0 -relief flat \
		-command "select_ctx $w 4" -bg gray -selectcolor yellow
	for {set i 0} {$i < 7} {incr i} {
	    select_ctx $w $i
	}
	for {set i 10} {$i < 11} {incr i} {
	    checkbutton $w.where.c$i -anchor w -image ctx6 -indicatoron 0\
		-variable KeyBind(cs,$i) -bd 0 -relief flat\
		-command "select_ctx $w $i" -bg gray  -selectcolor yellow
	    select_ctx $w $i
	}

	frame $w.mods -bd 2 -relief groove -text "Modifiers"
	checkbutton $w.mods.m -anchor w -text "Meta" -variable KeyBind(mm)
	checkbutton $w.mods.c -anchor w -text "Control" -variable KeyBind(mc)
	checkbutton $w.mods.s -anchor w -text "Shift" -variable KeyBind(ms)
	checkbutton $w.mods.a -anchor w -text "Any" -variable KeyBind(ma)

	frame $w.key -bd 2 -relief groove -text "Key"
	entry $w.key.e -exportselection 0
	frame $w.cmd -bd 2 -relief groove -text "Command"
	entry $w.cmd.e
	focus $w.key.e
	
	button $w.add -text "Add" -pady 1 -indicatoron 1 -command "add_bind $w"
	button $w.del -text "Delete" -pady 1 -command "del_bind $w"
	bind $rw <Return> "invoke $w.add"
	bind $w.keys.lb <ButtonRelease-1> "show_bind $w"
#----- procedures
	proc get_modifiers {} {
		global KeyBind
		
		if {$KeyBind(ma)} {return "A"}
		set mod ""
		if {$KeyBind(mm)} {set mod "M"}
		if {$KeyBind(mc)} {set mod "$mod[]C"}
		if {$KeyBind(ms)} {set mod "$mod[]S"}
		if {$mod==""} {return N}
		return $mod
	}
	proc show_bind {w} {
		global KeyBind
		
		if {[set lind [$w.keys.lb curselection]]=={}} return
		set ind [lindex $KeyBind(idx) $lind]
		$w.cmd.e delete 0 end
		$w.cmd.e insert 0 $KeyBind($ind,cmd)
		$w.key.e delete 0 end
		$w.key.e insert 0 $KeyBind($ind,key)
		
		for {set i 0} {$i<11} {incr i} {set KeyBind(cs,$i) 0}
		set KeyBind(cs,7) -1	
		set KeyBind(cs,8) -1
		set KeyBind(cs,9) -1		
		if {$KeyBind($ind,ctx)!="A"} {
			if {[string first R $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,0) 1}
			if {[string first W $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,1) 1}
			if {[string first I $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,2) 1}
			if {[string first S $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,3) 1}
			if {[string first F $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,4) 1}
			if {[string first T $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,5) 1}
			if {[string first 1 $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,6) 1}
			if {[string first 2 $KeyBind($ind,ctx)]>-1} {
				set KeyBind(cs,10) 1}
		}
		set KeyBind(ma) [expr [string first A $KeyBind($ind,mod)]>=0]
		set KeyBind(mm) [expr [string first M $KeyBind($ind,mod)]>=0]
		set KeyBind(mc) [expr [string first C $KeyBind($ind,mod)]>=0]
		set KeyBind(ms) [expr [string first S $KeyBind($ind,mod)]>=0]
		for {set i 0} {$i < 11} {incr i} {select_ctx $w $i}
	}	
	proc del_bind {w} {
		global KeyBind
		if {[set lind [$w.keys.lb curselection]]=={}} return
		set ind [lindex $KeyBind(idx) $lind]
		set KeyBind(idx) [lreplace $KeyBind(idx) $lind $lind]
		
		unset KeyBind($ind,cmd)
		unset KeyBind($ind,key)
		unset KeyBind($ind,mod)
		unset KeyBind($ind,ctx)
		$w.keys.lb delete $ind
		$w.keys.lb selection set $ind
		show_bind $w
	}	
	proc add_bind {w} {
		global KeyBind KbIndex
		
		set cmd [$w.cmd.e get]
		if {$cmd=={}} return
		set key [$w.key.e get]
		if {$key=={}} return
		$w.keys.lb insert end $cmd
		$w.keys.lb selection clear 0 end
		$w.keys.lb selection set end
		$w.keys.lb see end
		set ind $KbIndex
		lappend KeyBind(idx) $ind
		set KeyBind($ind,cmd) $cmd
		set KeyBind($ind,key) $key
		set KeyBind($ind,mod) [get_modifiers]
		set tmp ""
		if {$KeyBind(cs,0)} {set tmp "$tmp[]R"}
		if {$KeyBind(cs,1)} {set tmp "$tmp[]W"}
		if {$KeyBind(cs,2)} {set tmp "$tmp[]I"}
		if {$KeyBind(cs,3)} {set tmp "$tmp[]S"}
		if {$KeyBind(cs,4)} {set tmp "$tmp[]F"}
		if {$KeyBind(cs,5)} {set tmp "$tmp[]T"}
		if {$KeyBind(cs,6)} {set tmp "$tmp[]1"}
#		if {$KeyBind(cs,8)} {set tmp "$tmp[]3"}
#		if {$KeyBind(cs,9)} {set tmp "$tmp[]4"}
		if {$KeyBind(cs,10)} {set tmp "$tmp[]2"}
		if {$tmp==""} {set tmp "A"}		
		set KeyBind($ind,ctx)	$tmp
		incr KbIndex
	}
	proc rebind {w} {
		global TypeKey Key
		if {!$TypeKey} {
			bind $w.key.e <KeyPress> "getkey $w %K"
			bind $w.key.e <KeyRelease> {
				%W delete 0 end
				%W insert 0 $Key
			}
		} else {
			bind $w.key.e <KeyPress> {}
			bind $w.key.e <KeyRelease> {}
		}
	}
	proc getkey {w k} {
		global Key KeyBind
		
		if {![info exists Key]} {set Key {}}
		$w.key.e delete 0 end
		if {$k=="Shift_L" || $k=="Shift_R"} {
			if {$KeyBind(ms)} {set KeyBind(ms) 0
			} else { set KeyBind(ms) 1}
		} elseif {$k=="Control_L" || $k=="Control_R"} {
			if {$KeyBind(mc)} {set KeyBind(mc) 0
			} else { set KeyBind(mc) 1}			
		} elseif {$k=="Meta" || $k=="Alt_R" || $k=="Alt_L"} {
			if {$KeyBind(mm)} {set KeyBind(mm) 0
			} else { set KeyBind(mm) 1}
		} else {
			set Key $k
		}
	}
	foreach i $KeyBind(idx) {
		$w.keys.lb insert end $KeyBind($i,cmd)
	}
	$w.keys.lb selection set 0
	show_bind $w
	rebind $w
#----- layout
	place $w.lkeys -x 5 -y 5 -width 120 -height 20
	place $w.keys.sb -x -1 -y -1 -width 20 -height 118	
	place $w.keys.lb -x 20 -y 0 -width 96 -height 117
	place $w.keys -x 5 -y 27 -width 120 -height 120

	place $w.key.e -width 85 -height 20 -x 5 -y 14
	place $w.key -x 130 -y 5 -width 100 -height 45
	place $w.guess -x 130 -y 50

	place $w.where -x 130 -y 75 -width 165 -height 100	
	place $w.where.c0 -x 4 -y 12 -width 153 -height 79
	place $w.where.c1 -x 50 -y 30
	place $w.where.c2 -x 10 -y 66
	
	place $w.where.c3 -x 65 -y 80
	place $w.where.c4 -x 50 -y 80
	place $w.where.c7 -x 115 -y 80
	
	place $w.where.c5 -x 50 -y 20
	place $w.where.c6 -x 50 -y 20
#	place $w.where.c8 -x 60 -y 20
#	place $w.where.c9 -x 110 -y 20
	place $w.where.c10 -x 120 -y 20
	
	place $w.mods -x 300 -y 75 -width 85 -height 100
	place $w.mods.m -x 5 -y 14
	place $w.mods.c -x 5 -y 34
	place $w.mods.s -x 5 -y 54
	place $w.mods.a -x 5 -y 74
	
	place $w.cmd -x 235 -y 5 -width 150 -height 45
	place $w.cmd.e -x 5 -y 14 -width 135 -height 20
	
	place $w.add -x 5 -y 152 -width 58
	place $w.del -x 65 -y 152 -width 58
	pack $w -fill both -expand y 
}


#---------------------------------------------------------------
# mouse bindings
#---------------------------------------------------------------
proc module_mousebind {rw w} {
	global ASConfig ASCPConfig MouseBind MbIndex ASCPLibDir

	wm title $rw $ASConfig(wtitle,12)
	
	label $w.lbinds -font $ASCPConfig(font,helvb) -fg white -bg gray30 \
		-text "Bindings" -relief sunken

	frame $w.binds -bd 2 -relief sunken
	listbox $w.binds.lb -yscrollcommand "$w.binds.sb set" -bd 0\
		-exportselection 0
	scrollbar $w.binds.sb -command "$w.binds.lb yview"
	frame $w.where -bd 2 -relief groove -text "Context"
#contexts
	proc select_ctx {w i} {
		global MouseBind
		if {$MouseBind(cs,$i)<0} {
		    return
		} elseif {$MouseBind(cs,$i)} {
		    $w.where.c$i configure -activebackground yellow
		    if {$i==4} {
		    	$w.where.c7 configure -activebackground yellow
		    }
		} else {
		    $w.where.c$i configure -activebackground gray
		    if {$i==4} {
		    	$w.where.c7 configure -activebackground gray
		    }
		}
	}
	if {[catch {ctx cget file}]} {
		for {set i 0} {$i < 7} {incr i} {
		    image create bitmap ctx$i -file $ASCPLibDir[]$ASConfig(ctx,$i) -foreground\
			gray20
		}
	}
	for {set i 0} {$i < 7} {incr i} {
	    checkbutton $w.where.c$i -anchor w -image ctx$i -indicatoron 0\
		-variable MouseBind(cs,$i) -bd 0 -relief flat \
		-command "select_ctx $w $i" -bg gray -selectcolor yellow
	}
    	checkbutton $w.where.c7 -anchor w -image ctx4 -indicatoron 0\
		-variable MouseBind(cs,4) -bd 0 -relief flat \
		-command "select_ctx $w 4" -bg gray -selectcolor yellow
	for {set i 0} {$i < 7} {incr i} {
	    select_ctx $w $i
	}
	for {set i 10} {$i < 11} {incr i} {
	    checkbutton $w.where.c$i -anchor w -image ctx6 -indicatoron 0\
		-variable MouseBind(cs,$i) -bd 0 -relief flat\
		-command "select_ctx $w $i" -bg gray  -selectcolor yellow
	    select_ctx $w $i
	}
	frame $w.mods -bd 2 -relief groove -text "Modifiers"
	checkbutton $w.mods.m -anchor w -text "Meta" -variable MouseBind(mm)
	checkbutton $w.mods.c -anchor w -text "Control" -variable MouseBind(mc)
	checkbutton $w.mods.s -anchor w -text "Shift" -variable MouseBind(ms)
	checkbutton $w.mods.a -anchor w -text "Any" -variable MouseBind(ma)

	for {set i 0} {$i < 4} {incr i} {
		image create bitmap mb$i -file $ASCPLibDir[]$ASConfig(mb,$i)
	}
	set MouseBind(button) 0
	frame $w.but -bd 2 -relief groove -text "Button"
	radiobutton $w.but.b0 -variable MouseBind(button) -image mb3 -value 0 
	radiobutton $w.but.b1 -variable MouseBind(button) -image mb0 -value 1
	radiobutton $w.but.b2 -variable MouseBind(button) -image mb1 -value 2
	radiobutton $w.but.b3 -variable MouseBind(button) -image mb2 -value 3

	frame $w.cmd -bd 2 -relief groove -text "Command"
	entry $w.cmd.e
	
	button $w.add -text "Add" -pady 1 -indicatoron 1 -command "add_bind $w"
	button $w.del -text "Delete" -pady 1 -command "del_bind $w"
	bind $rw <Return> "invoke $w.add"
	bind $w.binds.lb <ButtonRelease-1> "show_bind $w"
#-- commands
	proc get_modifiers {} {
		global MouseBind
		
		if {$MouseBind(ma)} {return "A"}
		set mod ""
		if {$MouseBind(mm)} {set mod "M"}
		if {$MouseBind(mc)} {set mod "$mod[]C"}
		if {$MouseBind(ms)} {set mod "$mod[]S"}
		if {$mod==""} {set mod "N"}
		return $mod
	}
	proc get_context {} {
		global MouseBind
		set tmp ""
		if {$MouseBind(cs,0)} {set tmp "$tmp[]R"}
		if {$MouseBind(cs,1)} {set tmp "$tmp[]W"}
		if {$MouseBind(cs,2)} {set tmp "$tmp[]I"}
		if {$MouseBind(cs,3)} {set tmp "$tmp[]S"}
		if {$MouseBind(cs,4)} {set tmp "$tmp[]F"}
		if {$MouseBind(cs,5)} {set tmp "$tmp[]T"}
		if {$MouseBind(cs,6)} {set tmp "$tmp[]1"}
#		if {$MouseBind(cs,8)} {set tmp "$tmp[]3"}
#		if {$MouseBind(cs,9)} {set tmp "$tmp[]4"}
		if {$MouseBind(cs,10)} {set tmp "$tmp[]2"}		
		if {$tmp==""} {set tmp "A"}
		return $tmp
	}
	proc show_bind {w} {
		global MouseBind 
		
		if {[set lind [$w.binds.lb curselection]]=={}} return
		set ind [lindex $MouseBind(idx) $lind]
		$w.cmd.e delete 0 end
		$w.cmd.e insert 0 $MouseBind($ind,cmd)
		set MouseBind(button) $MouseBind($ind,but)
		for {set i 0} {$i<11} {incr i} {set MouseBind(cs,$i) 0}
		set MouseBind(cs,7) -1	
		set MouseBind(cs,8) -1
		set MouseBind(cs,9) -1		
		if {$MouseBind($ind,ctx)!="A"} {
			if {[string first R $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,0) 1}
			if {[string first W $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,1) 1}
			if {[string first I $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,2) 1}
			if {[string first S $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,3) 1}
			if {[string first F $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,4) 1}
			if {[string first T $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,5) 1}
			if {[string first 1 $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,6) 1}
			if {[string first 2 $MouseBind($ind,ctx)]>-1} {
				set MouseBind(cs,10) 1}
		}
		set MouseBind(ma) [expr [string first A $MouseBind($ind,mod)]>=0]
		set MouseBind(mm) [expr [string first M $MouseBind($ind,mod)]>=0]
		set MouseBind(mc) [expr [string first C $MouseBind($ind,mod)]>=0]
		set MouseBind(ms) [expr [string first S $MouseBind($ind,mod)]>=0]
		for {set i 0} {$i < 11} {incr i} {select_ctx $w $i}
	}
	proc del_bind {w} {
		global MouseBind 
		if {[set lind [$w.binds.lb curselection]]=={}} return
		set ind [lindex $MouseBind(idx) $lind]
		set MouseBind(idx) [lreplace $MouseBind(idx) $lind $lind]
		unset MouseBind($ind,cmd)
		unset MouseBind($ind,but)
		unset MouseBind($ind,ctx)
		unset MouseBind($ind,mod)
		$w.binds.lb delete $lind
		$w.binds.lb selection set $lind
		show_bind $w
	}
	proc add_bind {w} {
		global MouseBind MbIndex

		lappend MouseBind(idx) $MbIndex

		set cmd [$w.cmd.e get]
		$w.cmd.e selection range 0 end
		if {$cmd=={}} return
		set MouseBind($MbIndex,cmd) $cmd
		set MouseBind($MbIndex,but) $MouseBind(button)
		set MouseBind($MbIndex,ctx) [get_context]
		set MouseBind($MbIndex,mod) [get_modifiers]
		$w.binds.lb insert end $MouseBind($MbIndex,cmd)
		$w.binds.lb selection clear 0 end
		$w.binds.lb selection set end
		$w.binds.lb see end
		incr MbIndex
	}
	foreach i $MouseBind(idx) {
		$w.binds.lb insert end $MouseBind($i,cmd)
	}
	$w.binds.lb selection set 0
	show_bind $w
#-- layout
	place $w.where -x 130 -y 75 -width 165 -height 100
	place $w.where.c0 -x 4 -y 12 -width 153 -height 79
	place $w.where.c1 -x 50 -y 30
	place $w.where.c2 -x 10 -y 66
	
	place $w.where.c3 -x 65 -y 80
	place $w.where.c4 -x 50 -y 80
	place $w.where.c7 -x 115 -y 80
	
	place $w.where.c5 -x 50 -y 20
	place $w.where.c6 -x 50 -y 20
#	place $w.where.c8 -x 60 -y 20
#	place $w.where.c9 -x 110 -y 20
	place $w.where.c10 -x 120 -y 20

	place $w.but.b0 -x 5 -y 14
	place $w.but.b1 -x 5 -y 34
	place $w.but.b2 -x 55 -y 14
	place $w.but.b3 -x 55 -y 34
	place $w.but -x 130 -y 5 -width 100 -height 65

	place $w.lbinds -x 5 -y 5 -width 120 -height 20
	place $w.binds.sb -x -1 -y -1 -width 20 -height 118	
	place $w.binds.lb -x 20 -y 0 -width 96 -height 117
	place $w.binds -x 5 -y 27 -width 120 -height 120
	
	place $w.mods -x 300 -y 75 -width 85 -height 100
	place $w.mods.m -x 5 -y 14
	place $w.mods.c -x 5 -y 34
	place $w.mods.s -x 5 -y 54
	place $w.mods.a -x 5 -y 74
	
	place $w.cmd -x 235 -y 15 -width 150 -height 45
	place $w.cmd.e -x 5 -y 14 -width 135 -height 20
	
	place $w.add -x 5 -y 152 -width 58
	place $w.del -x 65 -y 152 -width 58
	pack $w -fill both -expand y 
}



#---------------------------------------------------------------
# Function definition
#---------------------------------------------------------------
proc module_functions {rw w} {
	global ASConfig ASCPConfig

	wm title $rw $ASConfig(wtitle,13)
	if {[catch {$rw.funcView cget -fg}]} {
		frame $rw.funcView -bd 2 -relief sunken
		scrollbar $rw.funcView.sbv -command "$rw.funcView.t yview"
		scrollbar $rw.funcView.sbh -command "$rw.funcView.t xview"\
			-orient horizontal
		text $rw.funcView.t -exportselection 0 -yscrollcommand \
			"$rw.funcView.sbv set" -relief flat \
			-xscrollcommand "$rw.funcView.sbh set" -wrap none
	} else {
		$rw.funcView.t delete @0,0 end
	}
	frame $w.f -bd 2 -relief groove -text "Function"
	entry $w.f.e -exportselection 0
	
	button $w.add -text "Add" -pady 1 -indicatoron 1 -command "add_func $rw $w"
	button $w.rem -text "Remove" -pady 1 -command "rem_func $rw $w"
	
	frame $w.fl -bd 2 -relief sunken
	listbox $w.fl.lb -exportselection 0 -yscrollcommand "$w.fl.sb set" \
		-relief flat
	scrollbar $w.fl.sb -command "$w.fl.lb yview"

	button $w.up -image ASCPConfig(img,up) -command "move_up $w"
	button $w.down -image ASCPConfig(img,down) -command "move_down $w"

	bind $w.f.e <Return> "invoke $w.add"
	bind $w.fl.lb <ButtonRelease> "show_func $rw $w;move_entry $rw $w %x,%y"
	bind $w.fl.lb <2> "change_name $w %x,%y"
	bind $w.fl.lb <1> "set MoveStart %x,%y"
#---- commands
	proc move_entry {rw w pos} {
		global Functions MoveStart
		if {$MoveStart=={}} return
		set entry [$w.fl.lb get @$MoveStart]
		if {$entry=={}} return
		set old [$w.fl.lb index @$MoveStart]
		set new [$w.fl.lb index @$pos]
		if {$old==$new} return
		$w.fl.lb delete $old
		$w.fl.lb insert $new $entry
		$w.fl.lb selection clear 0 end
		$w.fl.lb selection set $new
		set MoveStart {}
		set Functions(idx) [$w.fl.lb get 0 end]
		show_func $rw $w
	}	
	proc change_name {w pos} {
		global Functions
		set name [$w.f.e get]
		if {$name=={}} return
		set ind [$w.fl.lb index @$pos]
		if {$ind=={}} return		
		set oname [$w.fl.lb get $ind]
		if {[lsearch -exact $Functions(idx) $name]>-1} return
		set oind [$w.fl.lb curselection]
		$w.fl.lb delete $ind
		$w.fl.lb insert $ind $name
		if {$ind==$oind} {
			$w.fl.lb selection set $ind
		}
		set Functions($name) $Functions($oname)
		set Functions(idx) [$w.fl.lb get 0 end]
	}
	proc move_up {w} {
		global Functions
		
		if {[set ind [$w.fl.lb curselection]]=={}} return
		if {$ind<1} return 
		set entry [$w.fl.lb get $ind]
		$w.fl.lb delete $ind 
		$w.fl.lb insert [expr $ind - 1] $entry
		$w.fl.lb selection set [expr $ind - 1]		
		set Functions(idx) [$w.fl.lb get 0 end]
	}
	proc move_down {w} {
		global Functions
		
		if {[set ind [$w.fl.lb curselection]]=={}} return
		if {$ind>=[expr [$w.fl.lb size] - 1]} return
		set entry [$w.fl.lb get $ind]		
		$w.fl.lb delete $ind 
		$w.fl.lb insert [expr $ind + 1] $entry
		$w.fl.lb selection set [expr $ind + 1]
		set Functions(idx) [$w.fl.lb get 0 end]
	}	
	proc rem_func {rw w} {
		global Functions
		$w.f.e delete 0 end
		if {[set ind [$w.fl.lb curselection]]=={}} return
		set name [$w.fl.lb get $ind]
		$w.fl.lb delete $ind
		$rw.funcView.t delete @0,0 end
		set Functions(idx) [$w.fl.lb get 0 end]
		unset Functions($name)
	}
	proc add_func {rw w} {
		global Functions
		
		set name [$w.f.e get]
		if {$name=={}||[llength $name]>1} return
		set Functions($name)	[$rw.funcView.t get @0,0 end]
		if {[lsearch -exact $Functions(idx) $name]>-1} return
		$w.fl.lb insert end $name
		set Functions(idx) [$w.fl.lb get 0 end]
		$w.fl.lb selection clear 0 end
		$w.fl.lb selection set end
		$w.fl.lb see end
	}
	proc show_func {rw w} {
		global Functions

		set ind [$w.fl.lb curselection]
		if {$ind=={}} return
		set name [$w.fl.lb get $ind]
		if {$name=={}} return		
		$w.f.e delete 0 end
		$w.f.e insert 0 $name
		$rw.funcView.t dele @0,0 end
		$rw.funcView.t insert @0,0 $Functions($name)
	}
#---- initialize
	global Functions MoveStart
	if {![info exists Functions]} {
		set Functions(idx) {}
	} else {
		foreach i $Functions(idx) {
			$w.fl.lb insert end $i
			$w.fl.lb selection set 0
			show_func $rw $w
		}
	}	
#---- layout
	place $w.f.e -x 5 -y 12 -width 120 -height 20
	place $w.f -x 5 -y 5 -width 135 -height 42

	place $w.add -x 5 -y 52
	place $w.rem -x 70 -y 52

	place $w.fl -x 5 -y 77 -width 135 -height 75
	place $w.fl.sb  -x -1 -y -1 -width 20 -height 73
	place $w.fl.lb  -x 20 -y 0 -width 112 -height 71

	place $w.up -x 5 -y 158 -width 67 -height 18
	place $w.down -x 72 -y 158 -width 67 -height 18
	
	place $rw.funcView -in $w -x 150 -y 5 -width 230 -height 172
	place $rw.funcView.sbv -x -1 -y -1 -height 170
	place $rw.funcView.sbh -x 20 -y 148 -width 206
	place $rw.funcView.t -x 20 -y 0 -width 206 -height 148
	pack $w -fill both -expand y
}


#---------------------------------------------------------------
# Misc. Decoration
#---------------------------------------------------------------
proc module_decoration {rw w} {
	global ASConfig ASCPConfig ASCPLibDir

	wm title $rw $ASConfig(wtitle,14)
	checkbutton $w.b1 -text "Textured handles" -variable ASConfig(THandle)
	place $w.b1 -x 5 -y 10
	checkbutton $w.b2 -text "Disable pushable titlebars" -variable ASConfig(TBnpush)
	place $w.b2 -x 5 -y 30
	checkbutton $w.b3 -text "Titlebar in icons" -variable ASConfig(IconT)
	place $w.b3 -x 5 -y 50
	frame $w.tt -bd 2 -relief groove -text "Titlebar Text Gradient"
	checkbutton $w.tt.b -text "Gradiented text" -variable ASConfig(GText)
	frame $w.al -bd 2 -relief groove -text "Title Alignment"
	for {set i 0} {$i<3} {incr i} {
		image create bitmap i$i -file $ASCPLibDir[]$ASConfig(alg,$i)
		radiobutton $w.al.r$i -image i$i -variable ASConfig(talig)\
			-indicatoron 0
		place $w.al.r$i -in $w.al -x [expr 28 * $i + 10] -y 20
	}
	$w.al.r0 config -value 1
	$w.al.r1 config -value 0
	$w.al.r2 config -value 2
	
	place $w.al -in $w -x 200 -y 5 -width 110 -height 60
	
	tksColorWell $w.tt.from ASConfig(GTFcolor)
	tksColorWell $w.tt.to ASConfig(GTTcolor)
	place $w.tt -x 10 -y 90 -width 140 -height 80
	place $w.tt.b -x 10 -y 50
	place $w.tt.from -x 15 -y 15
	place $w.tt.to -x 75 -y 15
	pack $w -fill both -expand y -anchor w
}
