#!/bin/sh
# \
exec wishstep "$0" "$@"
#
#  AfterStep Control Panel
#     Copyright (c) 1996,1997 by Alfredo Kojima & Ludovic Marcotte 
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# where ascp is installed
set ASCPLibDir	"/usr/local/lib/ascp/"

# where XPM icons can be found
set ASCPIconPath "/usr/lib/X11/icons/"

#
# Test for correct version of TkSTEP
#
if {[catch {frame .f -text Foo}]} {
	tk_dialog .d "Fatal Error" \
	"This program requires TkSTEP 0.5 or newer." {} 0 Ok
	exit
} else {
	destroy .f
}
	

#Destroy procedures
set ASCPDestroy(n) 0


wm withdraw .
#
#configuration
#
#set ASCPLibDir "[file dirname $argv0]/"
set ASCPConfig(wtitle)	"AfterStep Settings"
set ASCPConfig(bsize)	65
set ASCPConfig(bnum)	14
set ASCPConfig(1,txt)	"Color\n&\nFonts"
set ASCPConfig(2,txt)	"Gradients"
set ASCPConfig(3,txt)	"Menus"
set ASCPConfig(4,txt)	"Window\nHandling"
set ASCPConfig(5,txt)	"Desktop"
set ASCPConfig(6,txt)	"Audio"
set ASCPConfig(7,txt)	"Paths"
set ASCPConfig(8,txt)	"Wharf"
set ASCPConfig(9,txt)	"Wharf\nStyle"
set ASCPConfig(10,txt)	"Windows"
set ASCPConfig(11,txt)	"Keybinds"
set ASCPConfig(12,txt)	"Mouse"
set ASCPConfig(13,txt)	"Functions"
set ASCPConfig(14,txt)	"Others"

set ASCPConfig(1,ico)	"Paint.xpm"
set ASCPConfig(1,cmd)	"module_color"
set ASCPConfig(2,ico)	"ColorPalette.xpm"
set ASCPConfig(2,cmd)	"module_gradients"
set ASCPConfig(3,ico)	"FileURL.xpm"
set ASCPConfig(3,cmd)	"module_menus"
set ASCPConfig(4,ico)	"Grab.xpm"
set ASCPConfig(4,cmd)	"module_window"
set ASCPConfig(5,ico)	"DesktopStars.xpm"
set ASCPConfig(5,cmd)	"module_desktop"
set ASCPConfig(6,ico)	"Microphone.xpm"
set ASCPConfig(6,cmd)	"module_audio"
set ASCPConfig(7,ico)	"Folders.xpm"
set ASCPConfig(7,cmd)	"module_aspaths"
set ASCPConfig(8,ico)	"InterfaceScrewdriver.xpm"
set ASCPConfig(8,cmd)	"module_wharf"
set ASCPConfig(9,ico)	"Interface.xpm"
set ASCPConfig(9,cmd)	"module_wharfprefs"
set ASCPConfig(10,ico)	"Window.xpm"
set ASCPConfig(10,cmd)	"module_windowops"
set ASCPConfig(11,ico)	"KeyPress.xpm"
set ASCPConfig(11,cmd)	"module_keybind"
set ASCPConfig(12,ico)	"Mouse.xpm"
set ASCPConfig(12,cmd)	"module_mousebind"
set ASCPConfig(13,ico)	"ClassEditor.xpm"
set ASCPConfig(13,cmd)	"module_functions"
set ASCPConfig(14,ico) 	"BrushText.xpm"
set ASCPConfig(14,cmd) 	"module_decoration"
#set ASCPConfig(14,ico)	"mouse.gif"
#set ASCPConfig(14,cmd)	"module_mouset"


set ASCPConfig(font,helvb) "-adobe-helvetica-bold-r-normal--12-120-75-75-p-70-iso8859-1"
set ASCPConfig(font,helv)  "-adobe-helvetica-medium-r-normal--12-120-75-75-p-67-iso8859-1"
set ASCPConfig(font,helv10) "-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-1"
#times font for calendar
set ASCPConfig(font,tbig)  "-adobe-times-medium-r-normal--18-180-75-75-p-94-iso8859-1"
#fixed font point 10
set ASCPConfig(font,fix) "-adobe-courier-medium-r-normal--11-110-75-75-m-70-iso8859-1"


#
# modules to load
#
#source "fingerInfo.tcl"
#source "date.tcl"
source $ASCPLibDir[]afterstep.tcl
source $ASCPLibDir[]loadsteprc.tcl
source $ASCPLibDir[]savesteprc.tcl
#source $ASCPLibDir[]mouset.tcl

set TRANSPARENT_GIF_COLOR	gray
set TRANSPARENT_XPM_COLOR	gray

set ASCPConfig(bmp,left) {
#define left_width 10
#define left_height 10
static unsigned char left_bits[] = {
   0x00, 0x00, 0x00, 0x02, 0x80, 0x03, 0xe0, 0x03, 0xf8, 0x03, 0xfe, 0x03,
   0xf8, 0x03, 0xe0, 0x03, 0x80, 0x03, 0x00, 0x02};
}
set ASCPConfig(bmp,right) {
#define right_width 10
#define right_height 10
static unsigned char right_bits[] = {
   0x00, 0x00, 0x02, 0x00, 0x0e, 0x00, 0x3e, 0x00, 0xfe, 0x00, 0xfe, 0x03,
   0xfe, 0x00, 0x3e, 0x00, 0x0e, 0x00, 0x02, 0x00};
}
set ASCPConfig(bmp,up) {
#define up_width 9
#define up_height 9
static unsigned char up_bits[] = {
   0x10, 0x00, 0x10, 0x00, 0x38, 0x00, 0x38, 0x00, 0x7c, 0x00, 0x7c, 0x00,
   0xfe, 0x00, 0xfe, 0x00, 0xff, 0x01};
}
set ASCPConfig(bmp,down) {
#define down_width 9
#define down_height 9
static unsigned char down_bits[] = {
   0xff, 0x01, 0xfe, 0x00, 0xfe, 0x00, 0x7c, 0x00, 0x7c, 0x00, 0x38, 0x00,
   0x38, 0x00, 0x10, 0x00, 0x10, 0x00};
}
#help commands 
#afterstep
set ASCPConfig(help,as) "#exec tkman afterstep"


# quit -
#	quit app
#
proc quit {} {
	global ASCPDestroy
	for {set i 0} {$i < $ASCPDestroy(n)} {incr i} {
		if [$ASCPDestroy($i)] return
	}
	exit
}

# openmain -
# 	Create and setup main window
#
proc openmain {w} {
	global ASCPConfig ASCPLibDir ASCPIconPath
	
	catch {destroy $w}
	toplevel $w -class ASCPanel
	$w configure -width 395 -height 300
	wm title $w $ASCPConfig(wtitle)
	wm iconname . ascp
	wm protocol $w WM_DELETE_WINDOW {quit}
	
	set canvw [expr ($ASCPConfig(bsize)+4) * $ASCPConfig(bnum) + 1]
	set sreg {0 0}
	lappend sreg $canvw $ASCPConfig(bsize)

	frame $w.f -relief sunken -bd 2 
	frame $w.frame -bd 2 -relief sunken
	place $w.f -x 8 -y 8 -height 93 -width 376
	place $w.frame -x 0 -y 110 -width 395 -height 2
	
	#frame for the module
	frame $w.mf -relief flat
	place $w.mf -x 5 -y 115 -width 385 -height 185
	
	set bSize [expr $ASCPConfig(bsize) + 4]
	scrollbar $w.f.sbar -orient horizontal -command "$w.f.canv xview" \
		-noarrows 1
	canvas $w.f.canv -relief sunken -height [expr 4 + $bSize]\
		-width 370 -scrollregion $sreg -xscrollcommand "$w.f.sbar set"\
		-highlightthickness 0
	place $w.f.canv -in $w.f -x 0 -y 0 -width 373 -height 68
	place $w.f.sbar -in $w.f -x 0 -y 70 -width 373 -height 20
	#construct button panel
	
	for {set i 1} {$i <= $ASCPConfig(bnum)} {incr i} {
		if {![catch {image create photo .i$i \
			-file $ASCPIconPath[]$ASCPConfig($i,ico)}]} {
		radiobutton $w.f.b$i -width $ASCPConfig(bsize)\
			-image .i$i \
			-height $ASCPConfig(bsize) -command \
			"catch { destroy $w.mf.base }; frame $w.mf.base;\
				$ASCPConfig($i,cmd) .main .main.mf.base" \
				-bd 2 -variable curModule\
				-value $i -indicatoron 0 -selectcolor gray
		} else {
		radiobutton $w.f.b$i -width $ASCPConfig(bsize)\
			-text $ASCPConfig($i,txt) \
			-height $ASCPConfig(bsize) -command \
			"catch { destroy $w.mf.base }; frame $w.mf.base;\
				$ASCPConfig($i,cmd) .main .main.mf.base" \
				-bd 2 -variable curModule\
				-value $i -indicatoron 0 -selectcolor gray
		}
		
		$w.f.canv create window [expr $bSize * $i - 35] 34 -window $w.f.b$i\
			-width $bSize -height $bSize
	}
	#initialize some stuff
	image create bitmap ASCPConfig(img,left) -data $ASCPConfig(bmp,left)
	image create bitmap ASCPConfig(img,right) -data $ASCPConfig(bmp,right)
	image create bitmap ASCPConfig(img,up) -data $ASCPConfig(bmp,up)
	image create bitmap ASCPConfig(img,down) -data $ASCPConfig(bmp,down)
	
	image create photo xpmPreview
}


#
rename tkButtonEnter {}
openmain .main
#opening writings
frame .main.mf.base
pack .main.mf.base -fill both -expand y 
label .main.mf.base.t -text "AfterStep Control Panel" -font $ASCPConfig(font,tbig)
label .main.mf.base.v -text "Version 0.5b"
label .main.mf.base.c -justify left \
	-text "Copyright (c) 1996,1997 Alfredo K. Kojima (kojima@inf.ufrgs.br)\nPortions Copyright (c) 1996 Ludovic Marcotte"

place .main.mf.base.t -x -100 -relx .5 -y 60
place .main.mf.base.v -x 40 -relx .5 -y 90
place .main.mf.base.c -x 10 -y 145

label .main.mf.base.s -text "Parsing configuration file..."
place .main.mf.base.s -x 10 -y 5
.main config -cursor watch
update
#setup progress meter
canvas .main.mf.base.m -bg black -bd 2 -relief sunken
.main.mf.base.m create rectangle 0 0 0 16
.main.mf.base.m itemconf 1 -fill blue
place .main.mf.base.m -x 180 -y 5 -width 100 -height 18
#load steprc
load_asconfig
global RcCur RcLines
.main config -cursor {}
destroy .main.mf.base.m
destroy .main.mf.base.s
