#!
# Load  AfterStep configuration file 
#
# Copyright (c) 1996 Alfredo K. Kojima
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#command types
# c1 - single color
# s - assign string
# n - single number
# es - edge scroll
# er - edge resist
# tt - texturetypes
# tm - texture maxcols
# tc - texture colors 
# b - boolean
# B - !boolean
# ds - desktop size
# ws - Style
# ib - IconBox
# m - module
# wg -wharf geometry
# wb - wharf binding
# f - function
# p - popup
# mb - mouse bind
# kb - keyb bind
# au - audio
# wz - wharf size (rows/columns)
#wheres
# a - ASConfig
# 

#command table (type where element)
set Tbl(STDFORECOLOR)  	{c1 a UFScolor}
set Tbl(STDBACKCOLOR)  	{c1 a UBScolor}
set Tbl(HIFORECOLOR)	{c1 a FFScolor}
set Tbl(HIBACKCOLOR)	{c1 a FBScolor}
set Tbl(MENUFORECOLOR)	{c1 a MFScolor}
set Tbl(MENUBACKCOLOR)	{c1 a MBScolor}
set Tbl(STICKYFORECOLOR)  {c1 a SFScolor}
set Tbl(STICKYBACKCOLOR)  {c1 a SBScolor}
set Tbl(*WHARFBGCOLOR) {c1 a WBScolor}
set Tbl(BUTTONBGCOLOR) {c1 a CBScolor}
set Tbl(FONT)		{s a Ifont}
set Tbl(WINDOWFONT)	{s a Tfont}
set Tbl(ICONFONT)	{s a Cfont}
set Tbl(ICONBOX)	{ib - -}
set Tbl(MODULE)		{m - -}
set Tbl(CLICKTIME)	{n a CTime}
set Tbl(STUBBORNICONS)	{b a StubI}
set Tbl(STUBBORNICONPLACEMENT} {b a StubIP}
set Tbl(STICKYICONS)	{b a SticI}
set Tbl(RANDOMPLACEMENT) {b a RandomP}
set Tbl(SMARTPLACEMENT) {b a SmartP}
set Tbl(EDGESCROLL)	{es - -}
set Tbl(EDGERESISTANCE)	{er - -}
set Tbl(SLOPPYFOCUS) 	{b a SlopF}
set Tbl(APPSBACKINGSTORE) {b a ABackS}
set Tbl(BACKINGSTORE)	{b a BackS}
set Tbl(SAVEUNDERS)	{b a SaveU}
set Tbl(OPAQUEMOVE)	{n a OMove}
set Tbl(OPAQUERESIZE)	{b a ORes}
set Tbl(NOPPOSITION)	{b a NoPos}
set Tbl(TEXTURETYPES)	{tt - -}
set Tbl(TEXTUREMAXCOLORS) {tm - -}
set Tbl(TITLETEXTURECOLOR) {tc a color FF FT}
set Tbl(UTITLETEXTURECOLOR) {tc a color UF UT}
set Tbl(MTITLETEXTURECOLOR) {tc a color MF MT} 
set Tbl(STITLETEXTURECOLOR) {tc a color SF ST}
set Tbl(MENUTEXTURECOLOR) {tc a color IF IT}
set Tbl(BUTTONTEXTURECOLOR) {tc a color CF CT}
set Tbl(*WHARFTEXTURECOLOR) {tc a color WF WT}

set Tbl(BUTTONTEXTURETYPE) {n a CTexture}
set Tbl(*WHARFTEXTURETYPE) {n a WTexture}
set Tbl(BUTTONMAXCOLORS) {n a Cmaxcols}
set Tbl(*WHARFMAXCOLORS) {n a Wmaxcols}
set Tbl(*WHARFANIMATE) {b a whanim}
set Tbl(*WHARFANIMATEMAIN) {b a whanimm}
set Tbl(*WHARFNOBORDER) {B a whborder}
set Tbl(TEXTGRADIENTCOLOR) {tc a color GTF GTT}
set Tbl(TEXTUREDHANDLE) {b a THandle}
set Tbl(GRADIENTTEXT) {b a GText}

set Tbl(*WHARFPIXMAP) {s a Wpixmap}
set Tbl(TITLEPIXMAP) {s a Fpixmap}
set Tbl(UTITLEPIXMAP) {s a Upixmap} 
#set Tbl(MTITLEPIXMAP) {s a Mpixmap} 
set Tbl(STITLEPIXMAP) {s a Spixmap}
#set Tbl(MENUPIXMAP) {s a Ipixmap}
set Tbl(BUTTONPIXMAP) {s a Cpixmap}

set Tbl(TITLEBARNOPUSH) {b a TBnpush}
set Tbl(CLICKTOFOCUS) {b a ClickF}
set Tbl(CIRCULATESKIPICONS) {b a CSkipI}
set Tbl(DECORATETRANSIENTS) {b a DTrans}
set Tbl(ICONTITLE) {b a IconT}
set Tbl(DESKTOPSIZE)	{ds - -}
set Tbl(DESKTOPSCALE)	{n a DTScale}
set Tbl(MODULEPATH) {s a modPath}
set Tbl(PIXMAPPATH) {s a pixPath}
set Tbl(ICONPATH) {s a icoPath}
set Tbl(STYLE)	{ws - -}
set Tbl(*WHARFGEOMETRY) {wg - -}
set Tbl(*WHARFROWS) {wz - 1 }
set Tbl(*WHARFCOLUMNS) {wz - 0 }
set Tbl(*WHARF) {wb - -}
set Tbl(ICON) {ws - -}
set Tbl(FUNCTION) {f - -}
set Tbl(POPUP) {p - -}
set Tbl(MOUSE) {mb - -}
set Tbl(KEY) {kb - -}
set Tbl(*AUDIOPLAYCMD) {s a AuCmd}
set Tbl(*AUDIODIR) {s a AuDir}
set Tbl(*AUDIODELAY) {s a AuDelay}
set Tbl(*AUDIO) {au - -}
set Tbl(NOBOUNDARYWIDTH) {nop - -}
set Tbl(BOUNDARYWIDTH) {nop - -}
set Tbl(TITLETEXTALIGN) {n a talig}

proc load_asconfig {} {
	global ASConfig Windows KeyBind Wharf MouseBind Tbl
	
#------------ aux procs
	#gets a valid line
	proc getLine {f} {
	    global RcCur
	    while {![eof $f]} {
	 	incr RcCur	    
		if {[gets $f line]>0} {
		    if {[set line [string trim $line]]!={} && [string range $line 0 0]!="#"} {
			upd_meter
			return $line
		    }
		}
	    }
	}
	proc is_number {s} {
		if {$s=={}} {return 0}
		return [expr ! [catch {expr $s + 0}]]
	}
	proc set_iconbox {s} {
		global ASConfig
		set ASConfig(IconBox) 0
		if {[llength $s]<4} return
		if {![is_number [set x1 [lindex $s 0]]]} return
		if {![is_number [set y1 [lindex $s 1]]]} return
		if {![is_number [set x2 [lindex $s 2]]]} return
		if {![is_number [set y2 [lindex $s 3]]]} return
		if {$x1<0} {set ASConfig(IconBox) 3 ; return}
		if {$y1<0} {return}
		if {$x2<0} {set ASConfig(IconBox) 1 ; return}
		set ASConfig(IconBox) 2
	}
	proc set_edges {s} {
		global ASConfig
		
		if {![is_number [set ASConfig(EScroll,v) [lindex $s 0]]]} {
			set ASConfig(EScroll,v) 0
		}
		if {![is_number [set ASConfig(EScroll,h) [lindex $s 1]]]} {
			set ASConfig(EScroll,h) 0
		}
		if {$ASConfig(EScroll,v) > 1000} {
			set ASConfig(EScroll,v) [expr $ASConfig(EScroll,v)/1000]
			set ASConfig(EScroll,vw) 1			
		}
		if {$ASConfig(EScroll,h) > 1000} {
			set ASConfig(EScroll,h) [expr $ASConfig(EScroll,h)/1000]
			set ASConfig(EScroll,hw) 1			
		}
	}
	proc set_edger {s} {
		global ASConfig
		
		if {![is_number [set ASConfig(ERes,s) [lindex $s 0]]]} {
			set ASConfig(ERes,s) 0
		}
		if {![is_number [set ASConfig(ERes,m) [lindex $s 1]]]} {
			set ASConfig(ERes,m) 0
		}
	}
	proc set_textypes {s} {
		global ASConfig
		
		if {![is_number [set ASConfig(FTexture) [lindex $s 0]]]} {
			set ASConfig(FTexture) 0
		}
		if {![is_number [set ASConfig(UTexture) [lindex $s 1]]]} {
			set ASConfig(UTexture) 0
		}
		if {![is_number [set ASConfig(STexture) [lindex $s 2]]]} {
			set ASConfig(STexture) 0
		}
		if {![is_number [set ASConfig(MTexture) [lindex $s 3]]]} {
			set ASConfig(MTexture) 0
		}
		if {![is_number [set ASConfig(ITexture) [lindex $s 4]]]} {
			set ASConfig(ITexture) 0
		}
	}
	proc set_texmcols {s} {
		global ASConfig
		
		if {![is_number [set ASConfig(Fmaxcols) [lindex $s 0]]]} {
			set ASConfig(Fmaxcols) 10
		}
		if {![is_number [set ASConfig(Umaxcols) [lindex $s 1]]]} {
			set ASConfig(Umaxcols) 10
		}
		if {![is_number [set ASConfig(Smaxcols) [lindex $s 2]]]} {
			set ASConfig(Smaxcols) 10
		}
		if {![is_number [set ASConfig(Mmaxcols) [lindex $s 3]]]} {
			set ASConfig(Mmaxcols) 10
		}
		if {![is_number [set ASConfig(Imaxcols) [lindex $s 4]]]} {
			set ASConfig(Imaxcols) 10
		}
	}
	proc set_texcols {s} {
		global ASConfig Tbl
		
		set line $Tbl([string toupper [string trim [lindex $s 0]]])
		if {[lindex $line 1]=="a"} {
			set item "[lindex $line 3][lindex $line 2]"
			set ASConfig($item) [lindex $s 1]
			
			set item "[lindex $line 4][lindex $line 2]"
			set ASConfig($item) [lindex $s 2]
		}
	}
	proc set_desksize {s} {
		global ASConfig
		
		set size [split [lindex $s 0] x]
		if {![is_number [set ASConfig(DTSize,v) [lindex $size 0]]]} {
			set ASConfig(DTSize,v) 2
		}
		if {![is_number [set ASConfig(DTSize,h) [lindex $size 1]]]} {
			set ASConfig(DTSize,h) 2
		}
	}
	proc set_style {s} {
	    global ASConfig Windows

	    set words {}
	    switch [lindex $s 0] {
		Style {set words [split [lrange $s 2 end] ,]}
		Icon {set words {};lappend words "Icon [lindex $s 2]"}
	    }
	    set win [lindex $s 1]
	    if {[lsearch $Windows(idx) $win]<0} {
		    lappend Windows(idx) $win
	    }
	    if {![info exists Windows($win,icon)]} {
		    set Windows($win,icon) ""
	    }
	    if {![info exists Windows($win,sticky)]} {
		set Windows($win,sticky) 0
	    	set Windows($win,notitle) 0
	    	set Windows($win,nohandle) 0
	    	set Windows($win,ontop) 0
	    	set Windows($win,skip) 0
	    	set Windows($win,nofocus) 0
	    	set Windows($win,startico) 0
	    }
	    foreach i $words {
		switch [string toupper [lindex $i 0]] {
			STICKY {set Windows($win,sticky) 1}
			NOTITLE {set Windows($win,notitle) 1}
			NOHANDLES {set Windows($win,nohandle) 1}
			STAYSONTOP {set Windows($win,ontop) 1}
			WINDOWLISTSKIP {set Windows($win,skip) 1}
			NOFOCUS {set Windows($win,nofocus) 1}
			STARTICONIC {set Windows($win,startico) 1}
			ICON {set Windows($win,icon) [lindex $i 1]}
		}
	    }
	}

	proc set_module {s} {
		global ASConfig
		
		set module [lindex $s 0]
		if {$module=="Wharf"} {set ASConfig(whdisable) 0;return}
		if {$module=="Auto"} {
			if {[is_number [lindex $s 1]]} {
				set ASConfig(AutoOn) 1
				set ASConfig(Auto) [lindex $s 1]
			}
			return			
		}
		if {$module=="Audio"} {set ASConfig(AuOn) 1;return}
		lappend ASConfig(MiscMod) $s
#		puts "Unknown module $module"
	}
	proc set_wharfgeo {s} {
		global ASConfig

		set w [string trim [string toupper $s]]
		if {[string range $w 0 0]=="-"} {
			set ASConfig(whcorner) "e"
		} else {
			set ASConfig(whcorner) "w"
		}
		if {[string first - [string range $w 1 end]]>=0} {
			set ASConfig(whcorner) "s$ASConfig(whcorner)"
		} else {
			set ASConfig(whcorner) "n$ASConfig(whcorner)"
		}
	}
	proc set_wharfsize {s d} {
		global ASConfig 
		
		set ASConfig(whdir) $d
		set ASConfig(wsize) $s
	}
	proc set_wharf {f s} {
		global Wharf CurIndex
		
		if {[lindex $s 0]=="~Folder"} return
		if {[info exists Wharf(idx)]} {
			set n [lindex $Wharf(idx) end]
			incr n
			lappend Wharf(idx) $n
		} else {
			set Wharf(idx) {0}
			set n 0
		}
		set Wharf(ico,$n) [lindex $s 1]
		set cmd [lindex $s 2]
		if {$cmd=="Folder"} {
		    set Wharf(cmd,$n) Folder
		    incr n
		    while {![eof $f] && $cmd!="~Folder"} {
 			set line [getLine $f]
			lappend Wharf(idx) $n			
			if {$line=={} || [lindex "$line" 0]!="*Wharf" || \
				[lindex "$line" 1]=="~Folder"} {
				set Wharf(cmd,$n) "EndFolder"
				set Wharf(ico,$n) ""
				return
			}
			set Wharf(ico,$n) [lindex "$line" 2]
			set Wharf(cmd,$n) [lrange $line 3 end]
			set cmd [lindex "$line" 1]
			if {$cmd!="~Folder"} {set cmd [lindex "$line" 3]}
			incr n
		    }
		} elseif {$cmd=="DropExec"} {
			set Wharf(idx) [lrange $Wharf(idx) 0 [expr [llength $Wharf(idx)]-2]]
			set Wharf(dcmd,$n) "$cmd\t[lrange $s 3 end]"
		} else {
			set Wharf(cmd,$n) "$cmd\t[lrange $s 3 end]"
		}
	}

	proc set_popup {f s} {
	    global ASMenus
		
	    if {! [info exists ASMenus(idx)]} {
		set ASMenus(idx) {}
	    }
	    lappend ASMenus(idx) $s
	    set ASMenus($s,idx) {}
	    set n 1
	    while {[lindex $s 0]!="EndPopUp" && ! [eof $f]} {
	    	set line [getLine $f]
	    	set j1 ""
		set j2 ""
		set j3 ""
		set tmp ""
		switch [set cmd [string toupper [lindex $line 0]]] {
		    EXEC { 
			scan $line "%s %\[\"\]%\[^\"\]\"%\[^\n\]" j1 j2 j3 tmp
			set ASMenus($s,$n,c) "Exec $tmp"
			set ASMenus($s,$n,t) [lindex $line 1]}
		
		    MODULE {
			scan $line "%s %\[\"\]%\[^\"\]\"%\[^\n\]" j1 j2 j3 tmp
		        set ASMenus($s,$n,c) "Module $tmp"
			set ASMenus($s,$n,t) [lindex $line 1]}
				
		    POPUP { 
		        scan $line "%s %\[\"\]%\[^\"\]\"%\[^\n\]" j1 j2 j3 tmp
		    	set ASMenus($s,$n,c) "PopUp $tmp"
			set ASMenus($s,$n,t) [lindex $line 1]}

		    #ignore nops
		    NOP {set ASMenus($s,$n,c) "Nop"
			set ASMenus($s,$n,t) [lindex [lrange $line 1 end] 0]}

		    RESTART {
			scan $line "%s %\[\"\]%\[^\"\]\"%\[^\n\]" j1 j2 j3 tmp
		        set ASMenus($s,$n,c) "Restart $tmp"
			set ASMenus($s,$n,t) [lindex $line 1]}

		    QUIT { set ASMenus($s,$n,c) "Quit"
			set ASMenus($s,$n,t) [lindex $line 1]}
				
		    TITLE { set ASMenus($s,0,c) "Title"
			set ASMenus($s,0,t) [lindex $line 1]
			continue
			}

		    ENDPOPUP {return}

		    default {
			scan $line "%s %\[\"\]%\[^\"\]\"%\[^\n\]" j1 j2 j3 tmp
		        set ASMenus($s,$n,c) "$j1 $tmp"
			set ASMenus($s,$n,t) $j3}
		}
		lappend ASMenus($s,idx) $n
		incr n
	    }
	}
	
	proc set_func {f s} {
	    global Functions

	    lappend Functions(idx) $s
	    set Functions($s) ""
	    while {! [eof $f]} {
	    	set line [getLine $f]
		if {[string toupper [lindex $line 0]]=="ENDFUNCTION"} {
			return
		}
		set Functions($s) "$Functions($s)$line\n"
	    }
	}
	
	proc set_keybind {s} {
		global KeyBind KbIndex
		
		set ind $KbIndex
		lappend KeyBind(idx) $ind
		set KeyBind($ind,cmd) [lrange $s 3 end]
		set KeyBind($ind,key) [lindex $s 0]
		set KeyBind($ind,mod) [lindex $s 2]
		set KeyBind($ind,ctx) [lindex $s 1]
		incr KbIndex
	}
	
	proc set_mousebind {s} {
		global MouseBind MbIndex
		
		set ind $MbIndex
		lappend MouseBind(idx) $ind
		set MouseBind($ind,cmd) [lrange $s 3 end]
		set MouseBind($ind,but) [lindex $s 0]
		set MouseBind($ind,mod) [lindex $s 2]
		set MouseBind($ind,ctx) [lindex $s 1]
		incr MbIndex
	}

	proc set_audio {line} {
		global ASConfig RcCur
		
		set event [lindex $line 0]
		set evn -1
		for {set i 0} {$i < $ASConfig(AuEv,count)} {incr i} {
			if {$event==$ASConfig(AuEv,$i)} {
				set evn $i
				break
			}
		}
		if {$evn<0} {
			puts "Bad Audio event name $event in line $RcCur. Ignoring..."
			return
		}
		set ASConfig(AuSnd,$evn) [lrange $line 1 end]
	}
#------------
	if [file exists $ASConfig(file)] {
		set fname [glob $ASConfig(file)]
	} else {
		set fname $ASConfig(sysfile)
	}
	if {![file exists $fname]} {
		tk_dialog .dlg "Error" ".steprc configuration file not found" {} 0 Quit
		exit 1
	}
	# prepare the progress meter
	global RcLines RcCur
	set RcCur 0	
	if {[catch {set RcLines [lindex [exec wc $fname] 0]}]} {
		proc upd_meter {} {
			#NOP
		}
	} else {
		proc upd_meter {} {
			global RcLines RcCur
			.main.mf.base.m coords 1  0 0 [expr ($RcCur*100)/$RcLines] 16
			update
		}
	}

	#unknown command list
	set ASConfig(dunno) ""
	set ASConfig(MiscMod) {}
	global KbIndex MbIndex
	set KbIndex 0
	set MbIndex 0
	#parse the thing
	set fl [open $fname r]
	while {![eof $fl]} {
	    if {[set line [getLine $fl]]=={}} continue
	    if {[info exists Tbl([set cmd [string toupper [lindex $line 0]]])]} {
	    	set index [lindex $Tbl($cmd) 2]
		#find the apropriate parser
	    	switch [lindex $Tbl($cmd) 0] {
		    c1 {set ASConfig($index) [lindex $line 1]}

		    n {if {[is_number [lindex $line 1]]} {
		    	set ASConfig($index) [lindex $line 1]}}

		    s {set ASConfig($index) [lrange $line 1 end]}

		    ib {set_iconbox [lrange $line 1 end]}

		    es {set_edges [lrange $line 1 end]}

		    er {set_edger [lrange $line 1 end]}

		    tt {set_textypes [lrange $line 1 end]}

		    tm {set_texmcols [lrange $line 1 end]}

    		    tc {set_texcols $line}

		    b {set ASConfig($index) 1}

		    B {set ASConfig($index) 0}
		    
		    ds {set_desksize [lrange $line 1 end]}

		    ws {set_style $line}

		    m {set_module [lrange $line 1 end]}

		    wg {set_wharfgeo [lrange $line 1 end]}

		    wb {set_wharf $fl [lrange $line 1 end]}

		    p {set_popup $fl [lrange $line 1 end]}
		    
		    wz {set_wharfsize [lindex $line 1] $index}
		    
		    f {set_func $fl [lindex $line 1]}
		    
		    kb {set_keybind [lrange $line 1 end]}

		    mb {set_mousebind [lrange $line 1 end]}
		    
		    au {set_audio [lrange $line 1 end]}

		    nop {;}
		}
	    } else {
	    	# some command we don't know about
		set ASConfig(dunno) "$ASConfig(dunno)$line\n"
	    }
	}
	close $fl
	unset Tbl
	global CurIndex
	set CurIndex [lindex $Wharf(idx) end]
	incr CurIndex
}
