#!/usr/local/bin/wishstep -f
#
#  Unix Control Panel - Mouse Settings
#     Copyright (c) 1996 by Ludovic Marcotte 
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA

set MSConfig(wtitle)    "Mouse Preferences"
set MSConfig(bnum)	10
set MSConfig(1,nor)	"mouset/mphand.gif"
set MSConfig(2,nor)	"mouset/mouse.gif"
set MSConfig(3,nor)	"mouset/fast1.gif"
set MSConfig(3,sel)	"mouset/fast1s.gif"
set MSConfig(4,nor)	"mouset/fast2.gif"
set MSConfig(4,sel)	"mouset/fast2s.gif"
set MSConfig(5,nor)	"mouset/fast3.gif"
set MSConfig(5,sel)	"mouset/fast3s.gif"
set MSConfig(6,nor)	"mouset/fast4.gif"
set MSConfig(6,sel)	"mouset/fast4s.gif"
set MSConfig(7,nor)	"mouset/dcd1.gif"
set MSConfig(7,sel)	"mouset/dcd1s.gif"
set MSConfig(8,nor)	"mouset/dcd2.gif"
set MSConfig(8,sel)	"mouset/dcd2s.gif"
set MSConfig(9,nor)	"mouset/dcd3.gif"
set MSConfig(9,sel)	"mouset/dcd3s.gif"
set MSConfig(10,nor)	"mouset/dcd4.gif"
set MSConfig(10,sel)	"mouset/dcd4s.gif"
# Variables that will be used to configure the mouse..
set MSConfig(mouse_spd) "" 
set MSConfig(click_delay) ""
set MSConfig(menu_button) ""
# End.


# Read the settings and assign the values to the proper variables.
proc readsettings {} {
global MSConfig
    
#    ReadString mouse_settings mouse_speed
set MSConfig(mouse_spd) [ReadString mouse_speed]

#}
# Done.

# Execute xset and write the settings to the config file
proc writesettings {keyword value} {
global MSConfig
    if {$keyword == "mouse_speed"} {
	exec xset m $value
#	WriteString $keyword $value
    }
}
#

proc module_mouset {rw w} {
global MSConfig UCPConfig MouseConfigActive

wm title $rw $MSConfig(wtitle)
set msw $w


#------- Standard Images ------- 1 to 19
for {set i 1} {$i <= $MSConfig(bnum)} {incr i} \
	{
	image create photo $w.im$i
	$w.im$i read $MSConfig($i,nor)
	}
# ---- Selected Images ------ 20 and up
for {set i 20} { $i <= [expr $MSConfig(bnum)+17]} {incr i} \
	{
	image create photo $w.im$i
	$w.im$i read $MSConfig([expr $i - 17],sel)
	} 
#-------------------------------------------------------------

frame $w.f1 -relief groove -bd 2 
frame $w.f2 -relief groove -bd 2
frame $w.f3 -relief groove -bd 2
entry $w.f2.clicktest -width 6
label $w.f1.frametitle1 -text "Mouse Speed"
label $w.f2.frametitle2 -text "Double-Click Delay"
label $w.f3.frametitle3 -text "Menu Button"
button $w.f3.left -text "Left" -width 4 -command {quit}
button $w.f3.right -text "Right" -width 4 -command {quit}
radiobutton $w.f3.r1 -text "Enabled" -variable $MSConfig(menu_button) -value enabled
radiobutton $w.f3.r2 -text "Disabled" -variable $MSConfig(menu_button) -value disabled 

for {set i 1} {$i <= $MSConfig(bnum)} {incr i} \
	{
	    if {$i == 1} \
		{label $w.f3.lab$i -image $w.im$i
	    } elseif  {$i == 2} {
		label $w.f1.lab$i -image $w.im$i
	    } elseif {3 <= $i && $i <= 6 } {
		label $w.f1.lab$i -image $w.im$i
	    } elseif {$i >= 7} {
		label $w.f2.lab$i -image $w.im$i
	    }	    
	}

# **********************************
# Arrange the Widgets 
# **********************************

proc arrange_fast {i} {
set w .main.mf.base 	
       for {set n 3} {$n <= 6} {incr n}\
       {
       		$w.f1.lab$n configure -image $w.im$n
       }
       $w.f1.lab$i configure -image $w.im[expr $i + 17]
#       writesettings mouse_speed [expr ($i - 2)]
}

proc arrange_dcd {i} {
set w .main.mf.base 
       for {set n 7} {$n <= 10} {incr n}\
       {
       		$w.f2.lab$n configure -image $w.im$n
       }
       $w.f2.lab$i configure -image $w.im[expr $i + 17]
}
 
# Bind the widgets to the proper procedure/parameter...
bind $w.f1.lab3 <ButtonPress> {arrange_fast 3}
bind $w.f1.lab4 <ButtonPress> {arrange_fast 4}
bind $w.f1.lab5 <ButtonPress> {arrange_fast 5}
bind $w.f1.lab6 <ButtonPress> {arrange_fast 6}
bind $w.f2.lab7 <ButtonPress> {arrange_dcd 7}
bind $w.f2.lab8 <ButtonPress> {arrange_dcd 8}
bind $w.f2.lab9 <ButtonPress> {arrange_dcd 9}
bind $w.f2.lab10 <ButtonPress> {arrange_dcd 10}

# Place the widgets

place $w.f1.frametitle1 -x 80 -y 1
place $w.f1.lab2 -x 2 -y 20  -in $w.f1
place $w.f1.lab3 -x 35 -y 33 -in $w.f1
place $w.f1.lab4 -x 76 -y 35 -in $w.f1
place $w.f1.lab5 -x 123 -y 34 -in $w.f1
place $w.f1.lab6 -x 170 -y 35 -in $w.f1

place $w.f2.frametitle2 -x 60 -y 1
place $w.f2.clicktest -x 155 -y 32 -in $w.f2
place $w.f2.lab7 -x 7 -y 27 -in $w.f2
place $w.f2.lab8 -x 42 -y 27 -in $w.f2
place $w.f2.lab9 -x 77 -y 27 -in $w.f2
place $w.f2.lab10 -x 112 -y 27 -in $w.f2

place $w.f3.frametitle3 -x 17 -y 1
place $w.f3.r1 -x 15 -y 25 -in $w.f3
place $w.f3.r2 -x 15 -y 50 -in $w.f3
place $w.f3.lab1 -x 0 -y 70 -in $w.f3
place $w.f3.left -x 10 -y 130 -in $w.f3
place $w.f3.right -x 65 -y 130 -in $w.f3

# Place the frames...
place $w.f1 -x 5 -y 5 -width 225 -height 80
place $w.f2 -x 5 -y 91 -width 225 -height 80  
place $w.f3 -x 235 -y 5 -width 130 -height 170
pack $w -fill both -expand y

# Read the settings and arrange the widgets..
#readsettings
#$w.f1.lab[expr $MSConfig(mouse_spd) + 2] \
#		 configure -image $w.im[expr $MSConfig(mouse_spd) + 19]

}







