.TH asfsm 0.5 "25 June 1997" asfsm
.UC
.SH NAME
\fBasfsm\fP \- the AfterStep file system monitor
.SH SYNOPSIS
.B asfsm [-b] [-f] [-i]
.SH DESCRIPTION
The \fBasfsm\fP application is a file system monitor for the AfterStep window
manager.  It displays "raised" horizontal bars representing the percent used 
of each mounted filesystem. Filesystems of zero initial block size are 
represented as "lowered" horizontal bars that span the entire window.
\fBasfsm\fP checks the filesystem usage on an interval.  Filesystems mounted 
between intervals will appear after the next scan.  Left clicking the mouse 
in a bar pops up a window displaying detailed information about the filesystem 
that the bar represents.
.SH CONFIGURATION OPTIONS
.IP "-bg"
.RS
Changes background color of the main window.
.RE
.IP "-fg"
.RS
Changes foreground color of the main window.
.RE
.IP "-bp"
.RS
Changes background pixmap of the main window. Can also be None which lets the 
background color show through.
.RE
.IP "-z"
.RS
Changes foreground color for filesystems of zero initial block size.
.RE
.IP "-pbg"
.RS
Changes background color of the popup window.
.RE
.IP "-pfg"
.RS
Changes foreground color of the popup window.
.RE
.IP "-pbd"
.RS
Changes border color of the popup window.
.RE
.IP "-pbp"
.RS
Changes background pixmap of the popup window. Can also be None which lets 
the background color show through, Transparent which makes it transparent, or 
Translucent which makes it translucent.
.RE
.IP "-i"
.RS
Changes the interval of scan in seconds. The default is every 5 seconds.
.RE
.SH INVOCATION
\fBasfsm\fP can be called from one of many ways.  The most common invocation
is the command line:
.nf

	[user@host] ~% asfsm -b green -f blue -i 3 -pbp Translucent&

.fi
Another way to call \fBasfsm\fP is from the window manager:
.nf

	*Wharf - - Swallow "asfsm"	asfsm -b green -f blue -i 3 -pbp Translucent&

.fi


This line, when placed in the \fI.steprc\fP file in the users home directory
will cause \fBasfsm\fP a
button on the \fBWharf (1)\fP button bar under the \fBafterstep (1)\fP
window manager.
.SH COPYRIGHTS
Copyright 1997, David Muse <dmuse@engr.latech.edu>. No guarantees or
warranties or anything are provided or implied in any way whatsoever.
Use this program at your own risk. Permission to use this program for
any purpose is given, as long as the copyright is kept intact.
.SH AUTHORS
David Muse <dmuse@engr.latech.edu> -- application and man page.
