.TH asmail 0.40 "6 Oct 1996" asmail
.UC
.SH NAME
\fBasmail\fP \- AfterStep Mail
.SH SYNOPSIS
.B asmail \fP[file] [options ...]\fP
.SH DESCRIPTION
The \fBasmail\fP is a "mail-checker" like xbiff, but with the Afterstep look & feel. It indicates the status of your mailbox. It can be put in the Wharf, execute program on incoming mail, execute program on mouse click, show XPM icon's, show animations and more...
.SH FILE
But default \fBasmail\fP uses ~/.asmailrc as configuration file, but if want to use another file you just specify the name on the command-line.
.RE

.SH OPTIONS
.IP "\fB-help\fP"
.RS	
Prints a help message
.RE
.IP "\fB-geometry\fP <geom>"
.RS
Specifies the geometry of the \fBasmail\fP window.
.RE
.IP "\fB-display\fP <disp>"
.RS
Specifies the display to use.
.RE
.IP "\fB-title\fP <string>"
.RS
Specifies the title string of the \fBasmail\fP window.
.RE
.IP "\fB-name\fP <string>"
.RS
Specifies the client instance, icon and title string of the \fBasmail\fP window.
.RE

.SH CONFIGURATION FILE
Here is a list of the keywords that can be used in the configuration file.
.RE
.IP "\fBNoBeep\fP"
.RS	
Do not signal when new mail is found.
.RE
.IP "\fBNoShape\fP"
.RS	
Truns off shaped window. Shaped window is often usefull if your would like to place \fBasmail\fP in your Wharf.
.RE
.IP "\fBMailFile\fP <mailfile>"
.RS
Specifies which mailfile to use. If this option is left out $MAIL will be used.
.RE
.IP "\fBUpdate\fP <sec>"
.RS
Specifies the update frequency. Default is 5 seconds.
.RE
.IP "\fBExecute\fP <program>"
.RS
Specifies the program to execute when left mousebutton click is invoked on the \fBasmail\fP window.
.RE
.IP "\fBNewMailExecute\fP <program>"
.RS
Specifies the program to execute when new mail is found.
.RE
.IP "\fBAlwaysNewMailExecute\fP"
.RS
Always execute when new mail is found. 
If this option is revomed asmail will only execute when new mail is found when the status is changed from "nomail/oldmail" to "newmail".
.RE
.IP "\fBTimeStampMode\fP"
.RS
This option is useful if you are using utilities like procmail. Asmail will change status to "New Mail" when the time-stamp of the last modification of the mailfile is changed.
.RE
.IP "\fBAnimationSpeed\fP <nomail> <oldmail> <newmail>"
.RS
Sets the delay between two images in an animation.
.RE

.IP "\fBNoMail\fP / \fBOldMail\fP / \fBNewMail\fP"

.RE
       <xpm-icon>
       <...>
.RE
.IP "\fBEnd\fP"
.RS
Assign icons and/or animations. Just list the icons in the order you want them to be shown. If you don't wnat an animation just list one icon and if you want to use the \fBasmail\fP default icons leave this option out.
.RE
.IP "\fB#\fP"
.RS
Comment.
.RE

.SH EXAMPLES
Here is an example of how to start \fBasmail\fP from the command line. It will use myconfig.asmailrc for configuration instead of ~/.asmailrc.
.nf

asmail myconfig.asmailrc &
	
.fi
Here is an example of how to start \fBasmail\fP from \fBafterstep\fP and put it in the Wharf. Place the following line in your \fI.steprc\fP file in your home directory.
.nf

*Wharf - - Swallow "asmail" asmail &

.fi

Here is an example of a configuration file.
.nf

#########################################################
# .asmailrc - asmail configuration file                 #
#########################################################

NoBeep
MailFile /var/spool/mail/per
Update 1
Execute xterm -T Pine -e pine -i &
NewMailExecute playau newmail.au &
AlwaysNewMailExecute
AnimationSpeed  10	10	5

NoMail  
	/usr/include/X11/pixmaps/nomail1.xpm	
	/usr/include/X11/pixmaps/nomail2.xpm	
	/usr/include/X11/pixmaps/nomail3.xpm	
End

OldMail  	
	/usr/include/X11/pixmaps/oldmail1.xpm	
	/usr/include/X11/pixmaps/oldmail2.xpm	
	/usr/include/X11/pixmaps/oldmail3.xpm	
End

NewMail  
	/usr/include/X11/pixmaps/newmail1.xpm	
	/usr/include/X11/pixmaps/newmail2.xpm	
	/usr/include/X11/pixmaps/newmail3.xpm	
End

.fi

.SH COPYRIGHT
This program is Copyright (c) 1996 by Per Liden. No guarantees 
or warranties are provided, use this program at your own risk. 
It may be freely copied and used as long as this copyright-notice 
is left intact.
.SH AUTHOR
Per Liden 
.RE
pt95pli@student.hk-r.se
.RE
http://www.rby.hk-r.se/~pt95pli/
.SH SPECIAL THANKS TO
Stephan K. Zitz (zitz@io.com)
.RE
Gyula Matics (mgyula@eik.bme.hu)








