/* config.l  
 * grammar for lex scanner
 * gideon le grange, 1994
 * scanner to scan radio.conf config file 
 * some say this is overkill, but i think the extendability
 * makes it worth the trouble 
 * 1994-11-21 : done
 */
 
letter  [A-Za-z0-9]
digit   [0-9] 
ws      [ \t]+
name    {letter}+
freq    {digit}+
port    0x{letter}+

%{ 
/* code to parse comes here */

#include <string.h> 
#include <stdlib.h>
#include "card.h"
#include "astuner.h"

char*   delims=" \t";
char*  token;

int     num_lines=1;

extern int currstation;

void Station(char* text)
{
  char*  name;
  int    freq;

  token=(char*)strtok(text,delims);  /* swallow "station" */
  name=(char*)strtok(NULL,delims);   /* get station name */
  sscanf((char*)strtok(NULL,delims),"%d",&freq);   /* get station frequency */
  if (used < NUMSTATIONS)
  {
      strncpy(stations[used].name, name, 4);
      if ((freq > STATION_HI) || (freq < STATION_LOW))
      {
          printf("%s : Invalid frequency in configuration file line %d\n",myname,num_lines);
	  printf("freq: %d\n", freq);
          exit(-1);
      }
      stations[used].freq=freq;
      used++;
  }
}

void DefaultF(char* text)
{
  int freq;
  
  token=(char*)strtok(text,delims);
  sscanf((char*)strtok(NULL,delims),"%d",&freq);
  currstation=freq;
  if ((currstation < STATION_LOW) || (currstation > STATION_HI))
  {
      printf("%s : Invalid default frequency in configuration file line %d\n",myname,num_lines);
      exit(-1);
  }
}

void Port(char* text)
{
  unsigned int port;
  
  token=(char*)strtok(text,delims);  /* swallow "port" */
  sscanf((char*)strtok(NULL,delims),"%x",&port);   /* get port number */
  RadioBase=port;
  if ((RadioBase!=0x30c) && (RadioBase!=0x20c))
  {
     printf("%s : Invalid base port in configuration file line %d\n",myname,num_lines);
     exit(-1);
  }
}
%}
/* now the rules */
%%

station{ws}{name}{ws}{freq}        Station(yytext);

default{ws}{freq}                  DefaultF(yytext);

port{ws}{port}                     Port(yytext);

[#\;\!][^\n]*$

\n                                 num_lines++;

{ws}

.                                  { 
                                     printf("%s : Error in config file line %d",myname,num_lines);
				   }

%%

