/*
 * Stub interface to dynamic linker routines
 * that SunOS uses but didn't ship with 4.1.
 *
 * The C library routine wcstombs in SunOS 4.1 tries to dynamically
 * load some routines using the dlsym interface, described in dlsym(3x).
 * Unfortunately SunOS 4.1 does not include the necessary library, libdl.
 *
 * The R5 Xlib uses wcstombs.  If you link dynamically, your program can
 * run even with the unresolved reference to dlsym.  However, if you
 * link statically, you will encounter this bug.  One workaround
 * is to include these stub routines when you link.
 */

/*
   extra whitespace intentional on stdc defs to bypass automatic
   prototyping
*/

#ifdef               __STDC__
void *dlopen(void)
#else
void *dlopen()
#endif
{
    return 0;
}

#ifdef               __STDC__
void *dlsym(void)
#else
void *dlsym()
#endif
{
    return 0;
}

#ifdef               __STDC__
int dlclose(void)
#else
int dlclose()
#endif
{
    return -1;
}

#ifdef                __STDC__
char *dlerror(void)
#else
char *dlerror()
#endif
{
	return ((char *) 0);
}
