/* filter.c */

#include "ml.h"

Menu edfilter_file_menu[] = {
  { NULL, "add", NUL_TERM,
      edfilter_add, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "delete", NUL_TERM,
      edfilter_delete, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "modify",  NUL_TERM,
      edfilter_modify, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "close_window",  NUL_TERM,
      edfilter_dismiss, NULL, 0, NULL, NULL, BTN_ON },
};

Menu edfilter_help_menu[] = {
  { NULL, "window_help",  NUL_TERM,
      edfilter_window_help, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "action_help",  NUL_TERM,
      edfilter_action_help, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "filter_help",  NUL_TERM,
      edfilter_filter_help, NULL, 0, NULL, NULL, BTN_ON },
};

Menu edfilter_menu[] = {
  { NULL, "file_menu",  NUL_TERM,
      NULL, edfilter_file_menu, XtNumber(edfilter_file_menu),
      NULL, NULL, BTN_ON },
  { NULL, "attach", NUL_TERM,
      edfilter_attach, NULL, 0,
      NULL, NULL, BTN_NOSELECTION },
  { NULL, "reset",  NUL_TERM,
      edfilter_reset, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "HELP_menu",  NUL_TERM,
      NULL, edfilter_help_menu, XtNumber(edfilter_help_menu), 
      NULL, NULL, BTN_ON },
};

#ifdef __STDC__
void create_edfilter_window(MainWindow *mwin)
#else
void create_edfilter_window(mwin)
     MainWindow *mwin;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Edfilter *edfilter;
  Widget form, menubar,label1, label2, label3, label4,rowcol, rowcol2, rowcol3;
  XtTranslations translations;
  Dimension width;
  char title[FILEBUFFLEN];

  if(session->edfilter == NULL) {
    edfilter = (Edfilter *) fs_get(sizeof(Edfilter));
    edfilter->is_realized = FALSE;
    session->edfilter = edfilter;
  }
  else
    edfilter = session->edfilter;

  edfilter->mwin = mwin;
  sprintf(title,"[%d]%s", mwin->serialno, MLGetLocalized(XtNstrFilters,
							 StrFilters));
  
  
  if(session->edfilter->is_realized == TRUE) {
    de_iconify(edfilter->shell);
    XtVaSetValues(edfilter->shell, XtNtitle, title, NULL);
    return;
  }

  edfilter->op = (Attach_Operation *) fs_get(sizeof(Attach_Operation));
  edfilter->op->mailbox = TRUE;
  edfilter->op->active = TRUE;

  edfilter->selection = 0L;
  edfilter->button_state = BTN_ON;
  edfilter->current = NULL;
  edfilter->representation = REP_ASCENDING;


  XtSetArg(args[n], XmNtitle, title); n ++;
  XtSetArg (args[n], XmNdeleteResponse, XmDO_NOTHING); n++;      
  edfilter->shell = XtCreatePopupShell("filter", topLevelShellWidgetClass, 
				       mwin->shell, args, n);
  AddDestroyCallback (edfilter->shell);
  n = 0;

  setup_editres(edfilter->shell);

  if(filt_icon != (Pixmap) None)
    XtVaSetValues(edfilter->shell,
		  XmNiconPixmap,filt_icon,
		  NULL);

  form = XmCreateForm(edfilter->shell, "form", args, n ); n = 0;

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form, "menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, edfilter_menu, 
		 XtNumber(edfilter_menu),
		 edfilter->button_state, 
		 (XtPointer) edfilter, ROOTMENULEVEL);
  edfilter->name =
    create_text_field(form, menubar, 
		      "name", NULL, 0, NULL, NULL);

  XtAddCallback(edfilter->name, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_nospace_edit, NULL);

  edfilter->action =
    create_text_field(form, edfilter->name, 
		      "action", 
		      preferences.default_action, 0, NULL, NULL);

  XtSetArg(args[n], XmNadjustMargin, FALSE); n ++;
  XtSetArg(args[n], XmNmarginWidth, 0);
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, edfilter->action);      n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM);   n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);   n ++;
  XtSetArg(args[n], XmNradioBehavior,  TRUE);             n ++;
  XtSetArg(args[n], XmNradioAlwaysOne, TRUE);             n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);        n ++;
  
  rowcol = XtCreateWidget("rowcol",
			  xmRowColumnWidgetClass,
			  form, args, n );
  n = 0;
  XtManageChild(rowcol);

  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  label1 = XmCreateLabel(rowcol,"sort_lbl",args,n);    n = 0;
  XtManageChild(label1);


  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNset, TRUE);                        n ++;
  XtSetArg(args[n], XmNborderWidth, 0);                   n ++;
  edfilter->radio1 = XmCreateToggleButton(rowcol, "normal_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio1);

  XtAddCallback(edfilter->radio1, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_sort_select, 
		rep_to_sortstr(REP_ASCENDING));


  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio2 = XmCreateToggleButton(rowcol, "reverse_toggle",
			      args, n); n = 0;
  XtManageChild(edfilter->radio2);

  XtAddCallback(edfilter->radio2, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_sort_select, 
		rep_to_sortstr(REP_DESCENDING));

  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio3 = XmCreateToggleButton(rowcol, "subject_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio3);

  XtAddCallback(edfilter->radio3, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_sort_select, 
		rep_to_sortstr(REP_SORT_SUBJECT));

  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio4 = XmCreateToggleButton(rowcol, "sender_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio4);

  XtAddCallback(edfilter->radio4, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_sort_select, 
		rep_to_sortstr(REP_SORT_SENDER));




  XtSetArg(args[n], XmNadjustMargin, FALSE);              n ++;
  XtSetArg(args[n], XmNmarginWidth, 0);                   n ++;
  XtSetArg(args[n], XmNborderWidth, 0);                   n ++;
  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, rowcol);                n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM);   n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);   n ++;
  XtSetArg(args[n], XmNradioBehavior,  TRUE);             n ++;
  XtSetArg(args[n], XmNradioAlwaysOne, TRUE);             n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);        n ++;
  
  rowcol2 = XtCreateWidget("rowcol2",
			  xmRowColumnWidgetClass,
			  form, args, n );
  n = 0;
  XtManageChild(rowcol2);



  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  label2 = XmCreateLabel(rowcol2,"apply_lbl",args,n);    n = 0;
  XtManageChild(label2);

  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNset, TRUE);                        n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio5 = XmCreateToggleButton(rowcol2, "mailfilt_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio5);

  XtAddCallback(edfilter->radio5, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_apply_select, 
		"mail");


  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio6 = XmCreateToggleButton(rowcol2, "viewfilt_toggle",
			      args, n); n = 0;
  XtManageChild(edfilter->radio6);

  XtAddCallback(edfilter->radio6, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_apply_select, 
		"view");




  XtSetArg(args[n], XmNadjustMargin, FALSE);              n ++;
  XtSetArg(args[n], XmNmarginWidth, 0);                   n ++;
  XtSetArg(args[n], XmNborderWidth, 0);                   n ++;
  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, rowcol2);                n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM);    n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);   n ++;
  XtSetArg(args[n], XmNradioBehavior,  TRUE);             n ++;
  XtSetArg(args[n], XmNradioAlwaysOne, TRUE);             n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);        n ++;
  
  rowcol3 = XtCreateWidget("rowcol3",
			  xmRowColumnWidgetClass,
			  form, args, n );
  n = 0;
  XtManageChild(rowcol3);


  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  label3 = XmCreateLabel(rowcol3,"applyas_lbl",args,n);    n = 0;
  XtManageChild(label3);


  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio7 = XmCreateToggleButton(rowcol3, "oncefilt_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio7);

  XtAddCallback(edfilter->radio7, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_apply_select, 
		"once");

  XtSetArg(args[n], XmNtraversalOn, FALSE);               n ++;
  XtSetArg(args[n], XmNset, TRUE);                        n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  edfilter->radio8 = XmCreateToggleButton(rowcol3, "contfilt_toggle",
					  args, n); n = 0;
  XtManageChild(edfilter->radio8);

  XtAddCallback(edfilter->radio8, XmNvalueChangedCallback, 
		(XtCallbackProc) edfilter_apply_select, 
		"cont");




  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, rowcol3);                      n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;

  label4 = XmCreateLabel(form,"filter_lbl",args,n);    n = 0;
  XtManageChild(label4);

  XtSetArg(args[n], XmNeditable, TRUE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);            n ++;
  XtSetArg(args[n], XmNwordWrap, TRUE);                         n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                   n ++; 
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );               n ++;

  edfilter->text =
    XmCreateScrolledText(form, "filter_text", args, n);        n = 0;
  
  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(edfilter->text, translations);
  translations = XtParseTranslationTable(GLOBAL_filters_pop_translations);
  XtOverrideTranslations(edfilter->text, translations);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, label4);                      n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;
  XtSetValues(XtParent(edfilter->text), args, n);               n = 0;
  XtManageChild(edfilter->text);

  XtAddCallback(edfilter->text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);             n ++;
  XtSetArg(args[n], XmNlistSizePolicy,         XmCONSTANT);           n ++;
  XtSetArg(args[n], XmNselectionPolicy,        XmSINGLE_SELECT);      n ++;
  edfilter->list = XmCreateScrolledList(form,"list",args,n); n = 0;

  XtAddCallback(edfilter->list, XmNsingleSelectionCallback, 
		(XtCallbackProc) edfilter_select, edfilter);
  
  XtAddCallback(edfilter->list, XmNdefaultActionCallback, 
		(XtCallbackProc) edfilter_accept, edfilter);

  translations = XtParseTranslationTable(GLOBAL_filters_pop_translations);
  XtOverrideTranslations(edfilter->list, translations);

  XtSetArg(args[n], XmNtopAttachment,          XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget,              edfilter->text);        n ++;
  XtSetArg(args[n], XmNleftAttachment,         XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNrightAttachment,        XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNbottomAttachment,       XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(edfilter->list), args, n);                      n = 0;
  stuff_edfilter_list(edfilter,FALSE,NULL);

  XtAddCallback(edfilter->shell, XmNpopdownCallback, 
		(XtCallbackProc) edfilter_destroy, edfilter);

  XtManageChild(edfilter->list);
  XtManageChild(form);
  XtManageChild(edfilter->shell);
  XtPopup(edfilter->shell,XtGrabNone);
  edfilter->is_realized = TRUE;
  return;
}


#ifdef __STDC__
void edfilter_sort_select(Widget w, XtPointer call_data, 
			  XmToggleButtonCallbackStruct *xp)
#else
void edfilter_sort_select(w,call_data,xp)
     Widget w;
     XtPointer call_data;
     XmToggleButtonCallbackStruct *xp;
#endif
{
  if(xp->set == TRUE)
    session->edfilter->representation = sortstr_to_rep((char *) call_data);
  return;
}


#ifdef __STDC__
void edfilter_apply_select(Widget w, XtPointer call_data, 
			  XmToggleButtonCallbackStruct *xp)
#else
void edfilter_apply_select(w,call_data,xp)
     Widget w;
     XtPointer call_data;
     XmToggleButtonCallbackStruct *xp;
#endif
{
  if(xp->set == TRUE) {
    if((strcmp(call_data,"mail")) == STRMATCH)
      session->edfilter->op->mailbox = TRUE;

    if((strcmp(call_data,"view")) == STRMATCH)
      session->edfilter->op->mailbox = FALSE;

    if((strcmp(call_data,"once")) == STRMATCH)
      session->edfilter->op->active = FALSE;

    if((strcmp(call_data,"cont")) == STRMATCH)
      session->edfilter->op->active = TRUE;
  }
  return;
}







#ifdef __STDC__
void edfilter_reset(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_reset(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  XmListDeselectAllItems(edfilter->list);
  edfilter->current = NULL;
  edfilter->selection = 0L;
  XmToggleButtonSetState(edfilter->radio1, TRUE, TRUE);
  XmTextSetString(edfilter->name,EMPTYSTR);
  XmTextSetString(edfilter->action,EMPTYSTR);
  XmTextSetString(edfilter->text,EMPTYSTR);
  edfilter->button_state |= BTN_NOSELECTION;
  edfilter->button_state &= ~(BTN_SELECTION);
  check_buttons(edfilter_menu,XtNumber(edfilter_menu),
		NULL, edfilter->button_state);
  return;
}


#ifdef __STDC__
void edfilter_destroy(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_destroy(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  XtDestroyWidget(edfilter->shell);
  edfilter->selection = 0L;
  edfilter->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void edfilter_window_help(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_window_help(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  help(edfilter->shell, EDFILTWINHELPFILE);
  return;
}

#ifdef __STDC__
void edfilter_action_help(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_action_help(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  help(edfilter->shell, VIEWACTIONHELPFILE);
  return;
}

#ifdef __STDC__
void edfilter_filter_help(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_filter_help(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  help(edfilter->shell, EDFILTERHELPFILE);
  return;
}


#ifdef __STDC__
int edfilter_compare(const void *f1, const void * f2)
#else
int edfilter_compare(f1,f2)
     const void *f1;
     const void *f2;
#endif
{
  Filter **flt1 = (Filter **) f1;
  Filter **flt2 = (Filter **) f2;

  return(strcmp((*(flt1))->name,(*(flt2))->name));
}


#ifdef __STDC__
void edfilter_sort(Edfilter *edfilter)
#else
void edfilter_sort(edfilter)
     Edfilter *edfilter;
#endif
{
  Filter **sort;
  Filter *info;
  int n = 0;
  int total = 0;

  for(info = session->filters; info; info = info->next)
    total ++;

  if(total < 2)
    return;

  sort = (Filter **) fs_get(total * sizeof(Filter *));

  for(info = session->filters; info; info = info->next) {
    sort[n] = info; 
    n ++;
  }
  qsort((char *) sort, total, sizeof(Filter **), edfilter_compare);

  for(n = 0; n < total; n ++) {
    info = sort[n];
    if(n == 0) {
      session->filters = info;
      info->prev = NULL;
      info->next = sort[n + 1];
    }
    else {
      info->prev = sort[n - 1];
      if(n == (total - 1))
	info->next = NULL;
      else
	info->next = sort[n + 1];
    }
  }

  fs_give((void **) &sort);
  return;
}


#ifdef __STDC__
void stuff_edfilter_list(Edfilter *edfilter, Boolean update, Filter *active)
#else
void stuff_edfilter_list(edfilter,update,active)
     Edfilter *edfilter;
     Boolean update;
     Filter *active;
#endif
{
  Filter *filter;
  XmString xstr;
  int n = 0;
  Boolean keep_active = FALSE;

  edfilter_sort(edfilter);

  if(update) {
    XmListDeselectAllItems(edfilter->list);
    XmListDeleteAllItems(edfilter->list);
  }

  for(filter = session->filters; filter; filter = filter->next) {
    filter->number = (++n);
    xstr = XmStringCreateSimple(filter->name);
    XmListAddItemUnselected(edfilter->list,xstr,0);
    XmStringFree(xstr);

    if((active != NULL) && (filter == active)) {
      XmListSelectPos(edfilter->list,filter->number,FALSE);
      edfilter->selection = filter->number;
      keep_active = TRUE;
      edfilter->button_state &= ~(BTN_NOSELECTION);
      edfilter->button_state |= BTN_NOSELECTION;
    }
  }
  if(keep_active == FALSE) {
    edfilter->button_state |= BTN_NOSELECTION;
    edfilter->button_state &= ~(BTN_SELECTION);
  }
  else
    edfilter_context_switch(edfilter,edfilter->current,active);

  check_buttons(edfilter_menu,XtNumber(edfilter_menu),
		NULL, edfilter->button_state);
  return;
}

#ifdef __STDC__
void edfilter_select(Widget w, Edfilter *edfilter, XmListCallbackStruct *xp)
#else
void edfilter_select(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XmListCallbackStruct *xp;
#endif
{
  Filter *filter;
  
  for(filter = session->filters; filter; filter = filter->next) {
    if(filter->number == xp->item_position) {
      if(filter->number == edfilter->selection) {
	XmListSelectPos(edfilter->list,edfilter->selection,FALSE);
	break;
      }
      else {
	edfilter->selection = filter->number;
	edfilter_context_switch(edfilter,edfilter->current,filter);
	break;
      }
    }
  }
  return;
}

#ifdef __STDC__
Boolean duplicate_filter_name(char *s)
#else
Boolean duplicate_filter_name(s)
     char *s;
#endif
{
  Filter *filter;

  for(filter = session->filters; filter; filter = filter->next) {
    if((strcmp(s,filter->name)) == STRMATCH)
      return(TRUE);
  }

  if((strcmp(s,MLGetLocalized(XtNstrAll,StrAll))) == STRMATCH)
    return(TRUE);

  return(FALSE);

}

#ifdef __STDC__
void edfilter_add(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_add(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{

  Filter *filter = new_filter();
  Filter *prev = NULL;

  filter->filter_type = FILTER_TYPE_USER;

  filter->name = GetTextField(edfilter->name);
  if((filter->name == NULL)  
     || (*filter->name == NUL_TERM)) {
    free_filter(filter);
    mm_log(MLGetLocalized(XtNmsgNoFilterName,MsgNoFilterName), WARN);
    return;
  }

  if((duplicate_filter_name(filter->name)) == TRUE) {
    mm_log(MLGetLocalized(XtNmsgDuplicateFilter,MsgDuplicateFilter),WARN);
    free_filter(filter);
    return;
  }

  filter->action = GetTextField(edfilter->action);
  filter->text = GetTextField(edfilter->text);
  if((filter->text == NULL) || (*filter->text == NUL_TERM)) {
    mm_log(MLGetLocalized(XtNmsgNoFilterDef,MsgNoFilterDef), WARN);
    free_filter(filter);
    return;
  }
  filter->representation = edfilter->representation;

  if(session->filters)
    for(prev = session->filters; prev->next; prev = prev->next)
      ;

  if(prev == NULL) {
    session->filters = filter;
    filter->prev = NULL;
  }
  else {
    filter->prev = prev;
    prev->next = filter;
  }

  save_defaults();
  stuff_edfilter_list(edfilter,TRUE,filter);
  return;
}


#ifdef __STDC__
void edfilter_modify(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_modify(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  Lview *lview;
  parse_errors errors;
  char errmsg[FILEBUFFLEN];
  char *temp_txt;

  if(edfilter->current == NULL)
    return;

  if(edfilter->current->name) 
    fs_give((void **) &edfilter->current->name);
  if(edfilter->current->action)
    fs_give((void **) &edfilter->current->action);
  if(edfilter->current->text)
    fs_give((void **) &edfilter->current->text);

  edfilter->current->representation = edfilter->representation;
  edfilter->current->name   = GetTextField(edfilter->name);
  edfilter->current->action = GetTextField(edfilter->action);
  temp_txt                  = GetTextField(edfilter->text);

  errors = lv_parse_filter(edfilter->current->name, temp_txt,
			   (LEAF **) &edfilter->current->search_tree,
			   &edfilter->current->text,
			   errmsg);

  cut_down_the_tree(edfilter->current->search_tree);
  edfilter->current->search_tree = NULL;

  if(errors != parse_success) {
    edfilter->current->text = temp_txt;
    mm_log(errmsg,WARN);
    return;
  }

  fs_give((void **) &temp_txt);

  for(lview = edfilter->mwin->lview; lview; lview = lview->prev) {
    if((lview->filter)  
       && ((lview->filter->filter_type == FILTER_TYPE_USER)
	   || lview->filter->filter_type == FILTER_TYPE_ONESHOT))
      if(strcmp(lview->filter->name,edfilter->current->name) == STRMATCH) {
	if(lview->filter->action)
	  fs_give((void **) &lview->filter->action);
	lview->filter->action = cpystr(edfilter->current->action);
	lview->filter->representation = edfilter->current->representation;
	if(lview->filter->text)
	  fs_give((void **) &lview->filter->text);
	temp_txt = cpystr(edfilter->current->text);
	cut_down_the_tree(lview->filter->search_tree);
	lview->filter->search_tree = NULL;
	(void) lv_parse_filter(lview->filter->name, temp_txt,
			       (LEAF **) &lview->filter->search_tree,
			       &lview->filter->text,
			       errmsg);
	update_logical_views(lview->mailbox,TRUE);
      }
  }

  save_defaults();
  stuff_edfilter_list(edfilter,TRUE,edfilter->current);
  return;
}


#ifdef __STDC__
void edfilter_delete(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_delete(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  Filter *filter;

  if(edfilter->current == NULL)
    return;

  if((edfilter->current->filter_type != FILTER_TYPE_USER)
     && (edfilter->current->filter_type != FILTER_TYPE_ONESHOT))
    return;

  if(preferences.confirmDestroy == TRUE)
    if((ml_confirm(edfilter->shell,MLGetLocalized(XtNmsgDestroyFilter,
						  MsgDestroyFilter),
		   CONFIRM_OK_CANCEL)) == FALSE)
      return;
						  


  for(filter = session->filters; filter; filter = filter->next) {
    if(filter == edfilter->current) {
      if(filter == session->filters) {
	session->filters = filter->next;
	if(filter->next)
	  filter->next->prev = NULL;
      }
      else {
	if(filter->next)
	  filter->next->prev = filter->prev;
	if(filter->prev)
	  filter->prev->next = filter->next;
      }
      free_filter(filter);
      break;
    }
  }

  edfilter_reset(w,edfilter,xp);
  save_defaults();
  stuff_edfilter_list(edfilter,TRUE,NULL);
  return;
}


#ifdef __STDC__
void edfilter_accept(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_accept(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  return;
}

#ifdef __STDC__
void edfilter_dismiss(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_dismiss(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  XtRemoveCallback(edfilter->shell, XmNpopdownCallback, 
		   (XtCallbackProc) edfilter_destroy, edfilter);
  XtPopdown(edfilter->shell);
  XtDestroyWidget(edfilter->shell);
  edfilter->selection = 0L;
  edfilter->is_realized = FALSE;
  return;
}



#ifdef __STDC__
void edfilter_context_switch(Edfilter *edfilter, Filter *old, Filter *new)
#else
void edfilter_context_switch(edfilter,old,new)
     Edfilter *edfilter;
     Filter *old;
     Filter *new;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;

  edfilter->current = new;

  XmTextSetString(edfilter->name,new->name);
  XmTextSetString(edfilter->action,new->action);
  XmTextSetString(edfilter->text,new->text);

  switch(new->representation) {
  case REP_DESCENDING:
    XmToggleButtonSetState(edfilter->radio2, TRUE, TRUE);
    break;
  case REP_SORT_SUBJECT:
    XmToggleButtonSetState(edfilter->radio3, TRUE, TRUE);
    break;
  case REP_SORT_SENDER:
    XmToggleButtonSetState(edfilter->radio4, TRUE, TRUE);
    break;
  case REP_ASCENDING:
  default:
    XmToggleButtonSetState(edfilter->radio1, TRUE, TRUE);
    break;
  }

  if(new->filter_type == FILTER_TYPE_USER) 
    XtSetArg(args[n], XmNeditable, TRUE); 
  else
    XtSetArg(args[n], XmNeditable, FALSE);
  n ++;
  XtSetValues(edfilter->text, args, n);
  XtSetValues(edfilter->name, args, n);
  n = 0;

  if(edfilter->selection) {
    edfilter->button_state |= BTN_SELECTION;
    edfilter->button_state &= ~(BTN_NOSELECTION);
  }

  check_buttons(edfilter_menu,XtNumber(edfilter_menu),
		NULL, edfilter->button_state);
  return;
}


#ifdef __STDC__
Boolean filter_has_changed(Edfilter *edfilter)
#else
Boolean filter_has_changed(edfilter)
     Edfilter *edfilter;
#endif
{
  char *name;
  char *action;
  char *text;

  Boolean different = FALSE;

  name   = GetTextField(edfilter->name);
  action = GetTextField(edfilter->action);
  text   = GetTextField(edfilter->text);
  if(edfilter->representation != edfilter->current->representation)
    different = TRUE;
  if(strcmp(name,edfilter->current->name) != STRMATCH)
    different = TRUE;
  if(strcmp(action,edfilter->current->action) != STRMATCH)
    different = TRUE;
  if(strcmp(text,edfilter->current->text) != STRMATCH)
    different = TRUE;

  fs_give((void **) &name);
  fs_give((void **) &action);
  fs_give((void **) &text);

  return (different);
}

#ifdef __STDC__
void edfilter_attach(Widget w, Edfilter *edfilter, XtPointer xp)
#else
void edfilter_attach(w,edfilter,xp)
     Widget w;
     Edfilter *edfilter;
     XtPointer xp;
#endif
{
  Lview *lview, *parent;
  Filter *filter, *newfilter;
  parse_errors errors;
  char errmsg[FILEBUFFLEN];
  char *temp_txt;

  if((! edfilter->selection) || (edfilter->current == NULL) 
     || (edfilter->op == NULL))
    return;

  if((edfilter->mwin->lview == NULL) || (edfilter->mwin->destroyed == TRUE))
    return;

  if((filter_has_changed(edfilter)) == TRUE)
    mm_log(MLGetLocalized(XtNmsgFilterNotSaved,MsgFilterNotSaved), WARN);

  filter = new_filter();

  filter->name = GetTextField(edfilter->name);
  temp_txt = GetTextField(edfilter->text);
  filter->action = GetTextField(edfilter->action);
  filter->representation = edfilter->representation;

  errors = lv_parse_filter(filter->name, temp_txt,
			   (LEAF **) &filter->search_tree,
			   &filter->text,
			   errmsg);

  if(errors != parse_success) {
    free_filter(filter);
    fs_give((void **) &temp_txt);
    mm_log(errmsg,WARN);
    return;
  }

  lview = new_lview();

  if(edfilter->op->active == FALSE) {
    filter->filter_type = FILTER_TYPE_ONESHOT;
    if(edfilter->op->mailbox == TRUE)
      lview->parent = 
	get_all_lview(edfilter->mwin->current->mailbox->mailstream);
    else 
      lview->parent = edfilter->mwin->current;
  }
  else {
    filter->filter_type = FILTER_TYPE_USER;
    if(edfilter->op->mailbox == TRUE)
      lview->parent = 
	get_all_lview(edfilter->mwin->current->mailbox->mailstream);
    else 
      lview->parent = edfilter->mwin->current;
  }

  lview->level = lview->parent->level + 1;

  lview->filter = filter;
  create_lview(edfilter->mwin,lview,FALSE);
  stuff_lview_list(edfilter->mwin,TRUE,FALSE);
  return;
}



#ifdef __STDC__
void filters_pop(Widget w, XtPointer xp)
#else
void filters_pop(w,xp)
     Widget w;
     XtPointer xp;
#endif
{
  edfilter_dismiss(w,session->edfilter,NULL);
  return;
}








