/* icon.c */ 

#include "ml.h"

Pixmap ml_icon, 
       read_icon, 
       compose_icon, 
       view_icon, 
       list_icon, 
       addr_icon, 
       note_icon, 
       help_icon, 
       filt_icon,
       edit_icon,
       mbox_icon,
       pirate_icon;

#define mli_width 48
#define mli_height 48
static unsigned char mli_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0x3f, 0xc0, 0x03, 0x04, 0xfc, 0xff, 0x7f, 0xf0, 0x0f, 0x0e, 0xfe, 0xff,
   0xff, 0xe0, 0x07, 0x1f, 0xff, 0xff, 0xff, 0xc0, 0x03, 0x1f, 0xff, 0xff,
   0xff, 0x80, 0x01, 0x1f, 0xff, 0xff, 0xff, 0x88, 0x11, 0x1f, 0xff, 0xff,
   0xff, 0x18, 0x18, 0x1f, 0xff, 0xff, 0xff, 0x38, 0x1c, 0x1f, 0xff, 0xff,
   0xff, 0x38, 0x1c, 0x1f, 0xff, 0xff, 0xff, 0x78, 0x1e, 0x1f, 0xff, 0xff,
   0xff, 0xf8, 0x1f, 0x1f, 0xff, 0xff, 0xff, 0xf8, 0x1f, 0x1f, 0xff, 0xfd,
   0xff, 0xf8, 0x1f, 0x1f, 0xff, 0xfc, 0xff, 0xf8, 0x1f, 0x1f, 0x00, 0xfc,
   0x7f, 0xf0, 0x0f, 0x1e, 0x00, 0xfc, 0x3f, 0xe0, 0x07, 0x1c, 0x00, 0xfc,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};

#define viewi_width 48
#define viewi_height 48
static unsigned char viewi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0xff, 0x1f,
   0x00, 0x00, 0x02, 0x00, 0x00, 0x10, 0x00, 0x00, 0xb2, 0x01, 0x00, 0x17,
   0x00, 0xfe, 0xff, 0xff, 0x7f, 0x15, 0x00, 0x02, 0x00, 0x00, 0x40, 0x15,
   0x00, 0xda, 0x00, 0x00, 0x5c, 0x17, 0xf8, 0xff, 0xff, 0xff, 0x54, 0x10,
   0x08, 0x00, 0x00, 0x80, 0x54, 0x10, 0xe8, 0x0d, 0xc0, 0xb9, 0x5c, 0x10,
   0x88, 0x07, 0x00, 0xa8, 0x40, 0x10, 0x68, 0x1e, 0xc0, 0xa9, 0x40, 0x10,
   0x08, 0x00, 0x00, 0xb8, 0x40, 0x10, 0x08, 0x00, 0x00, 0x80, 0xc0, 0x1f,
   0x08, 0x00, 0x00, 0x80, 0x40, 0x00, 0x08, 0xf0, 0x7d, 0x80, 0x40, 0x00,
   0x08, 0x00, 0x00, 0x80, 0x40, 0x00, 0x08, 0xf0, 0x3f, 0x80, 0x40, 0x00,
   0x08, 0x00, 0x00, 0x80, 0x7f, 0x00, 0x08, 0xf0, 0xc7, 0x83, 0x00, 0x00,
   0x08, 0x00, 0x00, 0x80, 0x00, 0x00, 0x08, 0x00, 0x00, 0x80, 0x00, 0x00,
   0xf8, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

#define readi_width 48
#define readi_height 48
static unsigned char readi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0x04, 0x80, 0x25, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x7c, 0x00, 0x34, 0x00, 0x20, 0x80, 0xff, 0x03, 0x04, 0x00, 0x20,
   0xe0, 0x00, 0x0e, 0xe4, 0xdc, 0x23, 0x38, 0x00, 0x38, 0x04, 0x00, 0x20,
   0x00, 0xfe, 0x40, 0xb4, 0xdd, 0x26, 0x80, 0x7d, 0x03, 0x04, 0x00, 0x20,
   0x70, 0xfe, 0x1c, 0x74, 0xb7, 0x25, 0x0c, 0xef, 0x61, 0x04, 0x00, 0x20,
   0x02, 0xc7, 0x81, 0xe4, 0xf6, 0x22, 0x0c, 0xef, 0x61, 0x04, 0x00, 0x20,
   0x70, 0xfe, 0x1c, 0xb4, 0xdb, 0x25, 0x80, 0x7d, 0x03, 0x04, 0x00, 0x20,
   0x00, 0xfe, 0x00, 0x74, 0x77, 0x23, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0xb4, 0x9b, 0x21, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0x04, 0xc0, 0x23, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

#define composei_width 48
#define composei_height 48
static unsigned char composei_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x20, 0x00, 0x00, 0x04, 0x80, 0x25, 0x50, 0x00, 0x00, 0x04, 0x00, 0x20,
   0xa0, 0x00, 0x00, 0x34, 0x00, 0x20, 0xc0, 0x01, 0x00, 0x04, 0x00, 0x20,
   0x80, 0x03, 0x00, 0xe4, 0xdc, 0x23, 0x00, 0x07, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x0e, 0x00, 0xb4, 0xdd, 0x26, 0x00, 0x1c, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x38, 0x00, 0x74, 0xb7, 0x25, 0x00, 0x70, 0x00, 0x04, 0x00, 0x20,
   0x00, 0xe0, 0x00, 0xe4, 0xf6, 0x22, 0x00, 0xc0, 0x01, 0x04, 0x00, 0x20,
   0x00, 0x80, 0x03, 0xb4, 0xdb, 0x25, 0x00, 0x00, 0x07, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x0e, 0x74, 0x77, 0x23, 0x00, 0x00, 0x1c, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x38, 0xb4, 0x9b, 0x21, 0x00, 0x00, 0x30, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x40, 0x04, 0xc0, 0x23, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#define listi_width 48
#define listi_height 48
static unsigned char listi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0xf0, 0x03, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x00, 0xc0, 0xff, 0x3f,
   0x38, 0x0f, 0x00, 0x40, 0x00, 0x20, 0x1c, 0x1e, 0x00, 0x40, 0xff, 0x2f,
   0x1c, 0x3c, 0x00, 0x40, 0x00, 0x20, 0x0c, 0x38, 0x80, 0x40, 0xff, 0x2f,
   0x00, 0x3c, 0x00, 0x41, 0x00, 0x20, 0x00, 0x1e, 0x00, 0x43, 0xff, 0x2f,
   0x00, 0x0f, 0xff, 0x47, 0x00, 0x20, 0x80, 0x07, 0x00, 0x43, 0xff, 0x2f,
   0xc0, 0x03, 0x00, 0x41, 0x00, 0x20, 0xe0, 0x01, 0x80, 0x40, 0xff, 0x2f,
   0xe0, 0x00, 0x00, 0x40, 0x00, 0x20, 0xe0, 0x00, 0x00, 0x40, 0xff, 0x2f,
   0xe0, 0x00, 0x00, 0x40, 0x00, 0x20, 0xe0, 0x00, 0x00, 0x40, 0xff, 0x2f,
   0x00, 0x00, 0x00, 0x40, 0x00, 0x20, 0x00, 0x00, 0x00, 0x40, 0xff, 0x2f,
   0xe0, 0x00, 0x00, 0x40, 0x00, 0x20, 0xf0, 0x01, 0x00, 0x40, 0xff, 0x2f,
   0xf0, 0x01, 0x00, 0x40, 0x00, 0x20, 0xf0, 0x01, 0x00, 0xc0, 0xff, 0x3f,
   0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#define filteri_width 48
#define filteri_height 48
static unsigned char filteri_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00,
   0x00, 0xc0, 0x0e, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x1f, 0x00, 0x00, 0x00,
   0x00, 0xc0, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x60, 0x7e, 0x00, 0x00, 0x00,
   0x00, 0x10, 0xfe, 0x01, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x03, 0x00, 0x00,
   0x00, 0x10, 0xfe, 0x0f, 0x20, 0x00, 0x00, 0x60, 0xfe, 0x3f, 0xc0, 0x00,
   0x00, 0xc0, 0xfe, 0x7f, 0x80, 0x01, 0xfc, 0xff, 0xff, 0xff, 0xff, 0x03,
   0x00, 0xc0, 0xfe, 0x7f, 0x80, 0x01, 0x00, 0x60, 0xfe, 0x3f, 0xc0, 0x00,
   0x00, 0x10, 0xfe, 0x0f, 0x20, 0x00, 0x00, 0x00, 0xfe, 0x03, 0x00, 0x00,
   0x00, 0x10, 0xfe, 0x01, 0x00, 0x00, 0x00, 0x60, 0x7e, 0x00, 0x00, 0x00,
   0x00, 0xc0, 0x3e, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x1f, 0x00, 0x00, 0x00,
   0x00, 0xc0, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00,
   0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#define piratei_width 48
#define piratei_height 48
static unsigned char piratei_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x1f, 0x00, 0x00,
   0x00, 0x00, 0x9c, 0x1c, 0x00, 0x00, 0x00, 0x00, 0xdc, 0x1d, 0x00, 0x00,
   0x00, 0x00, 0xfc, 0x1f, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00,
   0x00, 0x00, 0x18, 0x0c, 0x00, 0x00, 0x80, 0x03, 0xf0, 0x07, 0xe0, 0x00,
   0xc0, 0x03, 0xe0, 0x03, 0xe0, 0x01, 0xc0, 0x0f, 0xc0, 0x01, 0xfc, 0x01,
   0x80, 0x7f, 0x00, 0x80, 0xef, 0x00, 0x00, 0xe0, 0x03, 0xf0, 0x01, 0x00,
   0x00, 0x00, 0x1f, 0x3e, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x00, 0x00,
   0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x3f, 0x00, 0x00,
   0x00, 0xc0, 0x07, 0xf8, 0x01, 0x00, 0x80, 0xf9, 0x00, 0xc0, 0xcf, 0x00,
   0xc0, 0x1f, 0x00, 0x00, 0xfe, 0x01, 0xc0, 0x03, 0x00, 0x00, 0xf0, 0x01,
   0xc0, 0x03, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#define addri_width 48
#define addri_height 48
static unsigned char addri_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0xf0, 0x01, 0x00, 0x00, 0x00, 0x80, 0xff, 0xff, 0x00, 0x00,
   0x00, 0x80, 0x00, 0x80, 0x07, 0x00, 0x00, 0xf0, 0x01, 0x80, 0x0f, 0x00,
   0x00, 0xfe, 0xff, 0x8f, 0x08, 0x00, 0x00, 0x02, 0x00, 0x88, 0x0f, 0x00,
   0x00, 0xf2, 0x07, 0xc8, 0x1f, 0x00, 0x00, 0x03, 0x00, 0xf8, 0x7f, 0x00,
   0x00, 0xc3, 0x7f, 0xf8, 0x7f, 0x00, 0x80, 0x03, 0x00, 0xf8, 0xfd, 0x00,
   0x80, 0xe3, 0x3f, 0x78, 0xf0, 0x00, 0xc0, 0x03, 0x00, 0x7c, 0xf2, 0x01,
   0xc0, 0xff, 0xff, 0x3f, 0xe7, 0x01, 0xc0, 0x03, 0x00, 0x7c, 0xf2, 0x01,
   0x80, 0x01, 0x00, 0x7a, 0xf0, 0x00, 0x80, 0x00, 0x00, 0xfa, 0xfd, 0x00,
   0x40, 0x00, 0x00, 0xf1, 0x7f, 0x00, 0x20, 0x00, 0x80, 0xf8, 0x7f, 0x00,
   0x10, 0x00, 0x80, 0xc7, 0x1f, 0x00, 0xf0, 0xff, 0x7f, 0x00, 0x07, 0x00,
   0x00, 0xc0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#define notei_width 48
#define notei_height 48
static unsigned char notei_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x12, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x32, 0x00, 0x00, 0xe0, 0x78, 0x00,
   0xfc, 0x00, 0xf0, 0x13, 0xe0, 0x01, 0xf0, 0x03, 0x1c, 0x6e, 0x03, 0x02,
   0xc0, 0x8f, 0x03, 0x04, 0x14, 0x01, 0x00, 0x3f, 0x50, 0x72, 0x80, 0x04,
   0x00, 0xfc, 0x10, 0x01, 0x44, 0x02, 0x00, 0xf0, 0x81, 0x32, 0x20, 0x01,
   0x00, 0xc8, 0x43, 0x84, 0x90, 0x00, 0x00, 0x04, 0x23, 0x80, 0x48, 0x00,
   0x00, 0xf2, 0x11, 0x11, 0x24, 0x00, 0x00, 0x01, 0x09, 0x00, 0x12, 0x00,
   0x80, 0x7c, 0xc4, 0x07, 0x09, 0x00, 0x40, 0xc7, 0x3e, 0x9c, 0x04, 0x00,
   0xe0, 0x91, 0xc7, 0x71, 0x02, 0x00, 0x60, 0xba, 0x16, 0x2a, 0x01, 0x00,
   0xa0, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};



#define editi_width 48
#define editi_height 48
static unsigned char editi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x20, 0x00, 0x00, 0x04, 0x00, 0x20, 0x50, 0x00, 0x00, 0x04, 0x00, 0x20,
   0xa0, 0x00, 0x00, 0x24, 0x08, 0x20, 0xc0, 0x01, 0x00, 0x44, 0x04, 0x20,
   0x80, 0x03, 0x00, 0x84, 0x02, 0x20, 0x00, 0x07, 0x00, 0x04, 0x01, 0x20,
   0x00, 0x0e, 0x00, 0x84, 0x02, 0x20, 0x00, 0x1c, 0x00, 0x44, 0x24, 0x20,
   0x00, 0x38, 0x00, 0x24, 0x60, 0x20, 0x00, 0x70, 0x00, 0x04, 0xc0, 0x20,
   0x00, 0xe0, 0xf0, 0xff, 0xff, 0x21, 0x00, 0xc0, 0x01, 0x04, 0xc0, 0x20,
   0x00, 0x80, 0x03, 0x04, 0x60, 0x20, 0x00, 0x00, 0x07, 0x04, 0x20, 0x20,
   0x00, 0x00, 0x0e, 0x04, 0x00, 0x20, 0x00, 0x00, 0x1c, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x38, 0x04, 0x00, 0x20, 0x00, 0x00, 0x30, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x40, 0x04, 0x00, 0x20, 0x00, 0x00, 0x00, 0x04, 0x00, 0x20,
   0x00, 0x00, 0x00, 0xfc, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

#define mboxi_width 48
#define mboxi_height 48
static unsigned char mboxi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0xf0, 0x03, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x07, 0xf0, 0x07, 0x00, 0x00,
   0x38, 0x0f, 0xf0, 0x07, 0x00, 0x00, 0x1c, 0x1e, 0xf0, 0x07, 0x1c, 0x00,
   0x1c, 0x3c, 0xf0, 0x07, 0x7f, 0x00, 0x0c, 0x38, 0xf0, 0xc7, 0xff, 0x01,
   0x00, 0x3c, 0xf0, 0xc7, 0xff, 0x01, 0x00, 0x1e, 0x00, 0xe4, 0xff, 0x03,
   0x00, 0x0f, 0x00, 0xe4, 0xff, 0x03, 0x80, 0x07, 0x00, 0xf4, 0xe3, 0x07,
   0xc0, 0x03, 0x00, 0xf4, 0xc9, 0x07, 0xe0, 0x01, 0x00, 0xf4, 0xff, 0x07,
   0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07, 0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07,
   0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07, 0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07,
   0x00, 0x00, 0x00, 0xf4, 0xff, 0x07, 0x00, 0x00, 0x00, 0xf4, 0xff, 0x07,
   0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07, 0xf0, 0x01, 0x00, 0xf4, 0xff, 0x07,
   0xf0, 0x01, 0x00, 0xf4, 0xff, 0x07, 0xf0, 0x01, 0x00, 0xf4, 0xff, 0x07,
   0xe0, 0x00, 0x00, 0xf4, 0xff, 0x07, 0x00, 0x00, 0x00, 0xf4, 0xff, 0x07};

#define questi_width 48
#define questi_height 48
static unsigned char questi_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0xf0, 0x00, 0x0c, 0xf0, 0xff,
   0x07, 0xf8, 0x01, 0x1e, 0xf8, 0xff, 0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff,
   0x0f, 0xfc, 0x03, 0x3f, 0xfc, 0xff, 0x0f, 0xf0, 0x01, 0x3f, 0xfc, 0xff,
   0x0f, 0x60, 0x00, 0x3f, 0xfc, 0xff, 0x0f, 0x61, 0x08, 0x3f, 0xfc, 0xff,
   0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff, 0x0f, 0x03, 0x0c, 0x3f, 0xfc, 0xff,
   0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff, 0x0f, 0x0f, 0x0e, 0x3f, 0xfc, 0xff,
   0x0f, 0x9f, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xff,
   0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xdf, 0x0f, 0xff, 0x0f, 0x3f, 0xfc, 0xcf,
   0x0f, 0xff, 0x0f, 0x3f, 0x00, 0xc0, 0x07, 0xfe, 0x07, 0x3e, 0x00, 0xc0,
   0x03, 0xfc, 0x03, 0x3c, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0xf0, 0x01, 0x7c, 0x00, 0x3e, 0x00, 0xf8, 0x07, 0xfe, 0x01, 0xff, 0x00,
   0x38, 0x0f, 0xce, 0x03, 0xe7, 0x01, 0x18, 0x0e, 0x86, 0x03, 0xc3, 0x01,
   0x00, 0x1c, 0x00, 0x07, 0x80, 0x03, 0x00, 0x18, 0x00, 0x06, 0x00, 0x03,
   0x00, 0x1c, 0x00, 0x07, 0x80, 0x03, 0x00, 0x1e, 0x80, 0x07, 0xc0, 0x03,
   0x00, 0x0f, 0xc0, 0x03, 0xe0, 0x01, 0x80, 0x07, 0xe0, 0x01, 0xf0, 0x00,
   0xc0, 0x03, 0xf0, 0x00, 0x78, 0x00, 0xe0, 0x01, 0x78, 0x00, 0x3c, 0x00,
   0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00, 0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00,
   0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00, 0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00,
   0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00, 0xf0, 0x01, 0x7c, 0x00, 0x3e, 0x00,
   0xf0, 0x01, 0x7c, 0x00, 0x3e, 0x00, 0xf0, 0x01, 0x7c, 0x00, 0x3e, 0x00,
   0xe0, 0x00, 0x38, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


#ifdef __STDC__
void make_icons(void)
#else
void make_icons()
#endif
{

  ml_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) mli_bits,
				  mli_width, mli_height);


  view_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) viewi_bits,
				  viewi_width, viewi_height);


  read_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) readi_bits,
				  readi_width, readi_height);


  compose_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) composei_bits,
				  composei_width, composei_height);

  list_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) listi_bits,
				  listi_width, listi_height);


  filt_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) filteri_bits,
				  filteri_width, filteri_height);

  pirate_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) piratei_bits,
				  piratei_width, piratei_height);

  mbox_icon = XCreateBitmapFromData(display,
				    RootWindow(display,DefaultScreen(display)),
				  (char *) mboxi_bits,
				  mboxi_width, mboxi_height);


  addr_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) addri_bits,
				  addri_width, addri_height);

  note_icon = XCreateBitmapFromData(display,
				  RootWindow(display,DefaultScreen(display)),
				  (char *) notei_bits,
				  notei_width, notei_height);

  help_icon = XCreateBitmapFromData(display,
				    RootWindow(display,DefaultScreen(display)),
				    (char *) questi_bits,
				    questi_width, questi_height);

  edit_icon = XCreateBitmapFromData(display,
				    RootWindow(display,DefaultScreen(display)),
				    (char *) editi_bits,
				    editi_width, editi_height);
 
 
  return;
}

