#include <stdio.h>

#include <Mrm/MrmAppl.h>

static Widget sTooltipPopup = NULL;
static Widget sFrame = NULL;
static Widget sLabel = NULL;
static XmFontList sFontList;

#define BORDER 2

#ifdef __STDC__
void MLPopdownTooltip (void)
#else
void MLPopdownTooltip ()
#endif
{
    XtPopdown (sTooltipPopup);
    return;
}

#ifdef __STDC__
void MLInitializeTooltip (Display *display, char *className)
#else
void MLInitializeTooltip (display, className)
Display *display;
char *className;
#endif
{
    sTooltipPopup = XtVaAppCreateShell ("tooltip", className,                   /* This will have no window management controls. */
                                        applicationShellWidgetClass,
                                        display,
                                        XmNoverrideRedirect, True,
                                        NULL);
    sFrame = (Widget) XmCreateFrame (sTooltipPopup, "frame", NULL, 0);
    XtVaSetValues (sFrame, XmNshadowThickness, 0,
                   XmNborderWidth, 1,
                   XmNmarginWidth, BORDER,
                   XmNmarginHeight, BORDER, NULL);
    sLabel = (Widget) XmCreateLabel (sFrame, "label", NULL, 0);
    XtVaGetValues (sLabel,                                                      /* Get font sizing info for this string. */
                   XmNfontList, &sFontList,
                   NULL);
    XtManageChild (sFrame);
    XtManageChild (sLabel);
    return;
}

#ifdef __STDC__
void MLPopupTooltip (Widget button)
#else
void MLPopupTooltip (button)
Widget button;
#endif
{
    XmString labelString = NULL;
    Dimension labelWidth = 0;
    Dimension labelHeight = 0;
    Dimension height = 0;
    Position root_x = 0;
    Position root_y = 0;

    XtVaGetValues (button, XmNlabelString, &labelString,
                   XmNheight, &height, NULL);
    XtVaSetValues (sLabel, XmNlabelString, labelString, NULL);
    labelWidth  = XmStringWidth  (sFontList, labelString);
    labelHeight = XmStringHeight (sFontList, labelString);
    XtTranslateCoords (button, (Position) 0, (Position) 0,
                       &root_x, &root_y);
    XtVaSetValues (sTooltipPopup,
                   XmNx,      root_x,
                   XmNy,      root_y + height,
                   XmNwidth,  labelWidth + (BORDER * 2 + 2),
                   XmNheight, labelHeight + (BORDER + 4),
                   NULL);
    XtAddCallback (button, XmNdestroyCallback, MLPopdownTooltip, NULL);
    XtPopup (sTooltipPopup, XtGrabNone);
}
