/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/*	$Id: choose_folder.c,v 1.26 1996/06/24 13:11:03 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

FD_Choose_Folder *choose;
static int ready = 0;
static char wrkfolder[MAX_FOLD_NAME_LEN] = INBOX;
#define	MAX_PUP_FOLDERS	32

void
choose_browse(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
choose_dbl(obj, param)
FL_OBJECT *obj;
long param;
{
fl_trigger_object(choose->Ready_Button);
}

void
New_Folder_Call(obj, param)
FL_OBJECT *obj;
long param;
{
char *str, *p;
int i;
struct _mail_folder *fld;

fl_deactivate_form(choose->Choose_Folder);
str=(char *)fl_show_input("Enter new folder name:","");
if (strlen(str) < 1)
	goto efold;

str=rem_tr_space(str);
p = str;

while (*p != '\0') {
	if (!isgraph(*p)) {
		display_msg(MSG_WARN, "create", "Invalid character in folder name");
	goto efold;
			}
	p++;
		}

if (get_folder_by_name(str)) {
	display_msg(MSG_WARN, "create", "folder %s already exists", str);
	goto efold;  }

if (!(fld = open_folder(str))) {
	display_msg(MSG_WARN, "create", "Can not create folder %s", str);
	goto efold; }

fld->close(fld);

fl_clear_browser(choose->Folder_Browse);
for (i = 0; i < folders_num; i++) 
	fl_add_browser_line(choose->Folder_Browse, mailbox[i]->name(mailbox[i]));
efold: redraw_fld_win();

fl_activate_form(choose->Choose_Folder);
}

void
choose_init()
{
choose = create_form_Choose_Folder();
}

struct _mail_folder *
choose_folder()
{
int i, wrk;
struct _mail_folder *fld;
FL_OBJECT *obj;

if (ready) {
        XRaiseWindow(fl_display, choose->Choose_Folder->window);
        display_msg(MSG_WARN, "choose folder", "Dialog is currently in use, close it and open again");
	return NULL; }

ready = 1;

 fl_clear_browser(choose->Folder_Browse);
 wrk = 1;
 for (i = 0; i < folders_num; i++) {
	if (!strcmp(wrkfolder, mailbox[i]->name(mailbox[i])))
		wrk = i + 1;
	fl_add_browser_line(choose->Folder_Browse, mailbox[i]->name(mailbox[i]));
				}

 fl_set_browser_fontsize(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderFSize", FL_DEFAULT_SIZE));
 fl_set_browser_fontstyle(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderFStyle", FL_NORMAL_STYLE));
 fl_set_object_color(choose->Folder_Browse, b_getcfg_int(conf_name, "ChooseFolderBgCol", FL_TOP_BCOL), b_getcfg_int(conf_name, "ChooseFolderFgCol", FL_YELLOW));

 fl_select_browser_line(choose->Folder_Browse, wrk);
 fl_set_browser_topline(choose->Folder_Browse, wrk);

 fl_set_browser_dblclick_callback(choose->Folder_Browse, choose_dbl, 0);

 fl_show_form(choose->Choose_Folder,FL_PLACE_MOUSE, FL_TRANSIENT, "Choose Folder");

 while (ready == 1) 	{
  obj = fl_do_only_forms();

  if (obj == choose->Ready_Button)
	ready = 2;
  else
  if (obj == choose->Cancel_Button)
	ready = 3;
			}

 i = fl_get_browser(choose->Folder_Browse);

 fl_hide_form(choose->Choose_Folder);

 if (ready == 2) {
	ready = 0;
	if (i == 0)
		return NULL;

 	fld = get_folder_by_index(i - 1);
	if (fld)
		strcpy(wrkfolder, fld->name(fld));

	return fld;
		}

 ready = 0;
 return NULL;
}

struct _mail_folder *
pup_choose_folder(form)
FL_FORM *form;
{
int fpup, i;

  fpup = fl_newpup(form ? form->window : main_form->window);
  fl_addtopup(fpup, "Folders %t");
  i = 0;
  for (i = 0; i< folders_num;i++) {
	fl_addtopup(fpup, mailbox[i]->name(mailbox[i]));
	if (i > MAX_PUP_FOLDERS)
		break;
                                  }

  i = fl_dopup(fpup);
  fl_freepup(fpup);
  if (i <= 0)
	return NULL;
  i--;

  return get_folder_by_index(i);
}

