/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: config.c,v 1.20 1996/05/05 16:54:51 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

static int ready = 0;
static FD_Config_Form *config_obj;

void Int_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 int_conf();
 fl_activate_form(config_obj->Config_Form);
}

void REP_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 reply_conf();
 fl_activate_form(config_obj->Config_Form);
}

void MIME_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 mime_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Misc_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 misc_conf();
 fl_activate_form(config_obj->Config_Form);
}

void App_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 set_el_size();
 fl_activate_form(config_obj->Config_Form);
}

void Faces_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 faces_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Timers_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 timers_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Inc_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 inc_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Sort_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 sort_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Edit_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 edit_conf();
 fl_activate_form(config_obj->Config_Form);
}

void View_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 view_conf();
 fl_activate_form(config_obj->Config_Form);
}

void POP_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 pop_conf();
 fl_activate_form(config_obj->Config_Form);
}

void SMTP_Conf_Call(FL_OBJECT *obj, long param)
{
 fl_deactivate_form(config_obj->Config_Form);
 smtp_conf();
 fl_activate_form(config_obj->Config_Form);
}

void Load_Conf_Call(FL_OBJECT *obj, long param)
{
if (b_loadcfg(conf_name) < 0)
  display_msg(MSG_WARN, "Configuration Load failed!", "%s", conf_name);
}

void Save_Conf_Call(FL_OBJECT *obj, long param)
{
if (b_savecfg(0) < 0)
  display_msg(MSG_WARN, "Configuration Save failed!", "%s", conf_name);
}

void
xfm_config()
{ 
 if (ready) {
	XRaiseWindow(fl_display, config_obj->Config_Form->window);
        return; }

 if (busy)
	return;

 ready = 1;
 busy = 1;

 config_obj = create_form_Config_Form();
 fl_show_form(config_obj->Config_Form, FL_PLACE_CENTER, FL_TRANSIENT, "Configure");

conf_wait:
 if (fl_do_only_forms() != config_obj->Done_Conf)
	goto conf_wait;

 b_savecfg(1);

 fl_hide_form(config_obj->Config_Form);
 fl_free_form(config_obj->Config_Form);
 fl_free(config_obj);
 ready = 0;
 busy = 0;
 return;
}

