/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: help.c,v 1.14 1996/05/14 16:53:23 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>
#include "help.h"

static char *chapters[] = {
"%Start",		/* 0  */
"%Overview",		/* 1  */
"%Folders",		/* 2  */
"%Messages",		/* 3  */
"%ButtonPad",		/* 4  */
"%MainMenu",		/* 5  */
"%AddressBook",		/* 6  */
"%Signature",		/* 7  */
"%Config",		/* 8  */
"%Rules",		/* 9  */
"%Viewmsg",		/* 10 */
"%Editmsg",		/* 11 */
"%attach",		/* 12 */
"%Search",		/* 13 */
"%Config-Misc",		/* 14 */
"%Config-Appearance",	/* 15 */
"%Config-Receive",	/* 16 */
"%Config-Display",	/* 17 */
"%Config-View",		/* 18 */
"%Config-Edit",		/* 19 */
"%Config-POP",		/* 20 */
"%Config-SPOP",		/* 21 */
"%Config-Send",		/* 22 */
"%Config-Timers",	/* 23 */
"%Config-Faces",	/* 24 */
"%Config-MIME",		/* 25 */
"%Config-repfwd",	/* 26 */
"%Config-Int",		/* 27 */
NULL
};

#define	TOTAL_CHAPTERS	27

static int ready = 0;
FD_Help_Form *help_obj;

void
cb_help_button(obj, param)
FL_OBJECT *obj;
long param;
{
  if (!obj || (param < 0) ||
	(param > TOTAL_CHAPTERS))
	return;

  help(chapters[param]);

  return;
}

void
help(chapter)
char *chapter;
{
int i;
int chapter_line = 0;
int line_count = 0, redisp = 0;

 if (ready) {
	fl_activate_form(help_obj->Help_Form);
	XRaiseWindow(fl_display, help_obj->Help_Form->window);
	redisp = 1; }

 ready = 1;

 if (!redisp)
	help_obj = create_form_Help_Form();

 i = 0;
 while (strcmp(help_txt[i], "%END")) {

	if (help_txt[i][0] == '%') {
	 if (chapter && !strcmp(chapter, help_txt[i])) {
		chapter_line = line_count;
	 	if (redisp)
			break;
							}
	 i++;
	 continue;
				}

	if (!redisp) 	{
	if (strlen(help_txt[i]) < 1)
	 fl_add_browser_line(help_obj->Help_Browser, " ");
	else
	 fl_add_browser_line(help_obj->Help_Browser, help_txt[i]);
			}

	line_count++;
	i++;
				     }

	fl_set_browser_topline(help_obj->Help_Browser, chapter_line+1);

	if (redisp)
		return;

 fl_set_initial_placement(help_obj->Help_Form, main_form->x, main_form->y, 500, 300);
 fl_set_form_minsize(help_obj->Help_Form, 400, 200);
 fl_set_form_maxsize(help_obj->Help_Form, 700, 500);

 fl_show_form(help_obj->Help_Form, FL_PLACE_FREE, FL_TRANSIENT, "Help for XFmail");

 return;
}

void Done_Help_Call(FL_OBJECT *obj, long param)
{
 if (!ready)
	return;

 fl_hide_form(help_obj->Help_Form);
 fl_free_form(help_obj->Help_Form);
 fl_free(help_obj);
 help_obj = NULL;

 ready = 0;
 return;
}

