/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: inc.c,v 1.15 1996/04/21 07:37:39 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

static FD_In_Conf *inc_obj;
static FD_Timers *timers_obj;
static int ready = 0;

void Inc_inp_Call(FL_OBJECT *obj, long param)
{
}

void Inc_Count_Call(FL_OBJECT *obj, long param)
{
}

void Inc_Play_Call(FL_OBJECT *obj, long param)
{
 play_sound((char *)fl_get_input(obj), 100);
}

void Inc_Start_Call(FL_OBJECT *obj, long param)
{
}

void Inc_From_Spool_Call(FL_OBJECT *obj, long param)
{
}

void Inc_Icon_Call(FL_OBJECT *obj, long param)
{
}

void Inc_From_POP_Call(FL_OBJECT *obj, long param)
{
if (fl_get_button(inc_obj->Inc_From_POP))
	fl_show_message("POP access", "Do not forget to configure POP server", "via Config/POP menu");
}

void
inc_init()
{
 inc_obj = create_form_In_Conf();
}

void
inc_conf() 
{
char spool[255];

 if (ready)
        return;

 ready = 1;

 sprintf(spool, "%s/%s", _PATH_MAILDIR, getenv("USER"));
 fl_set_input(inc_obj->Inc_Inp, b_getcfg_str(conf_name, "spool", spool));

 fl_set_button(inc_obj->Inc_Start, b_getcfg_int(conf_name,"inconstart", 0));

 fl_set_button(inc_obj->Inc_Beep, b_getcfg_int(conf_name,"beep", 1));
 fl_set_input(inc_obj->Inc_Play, b_getcfg_str(conf_name, "play", ""));

 fl_set_button(inc_obj->Inc_From_POP,b_getcfg_int(conf_name, "popretr", 0));
 fl_set_button(inc_obj->Inc_From_Spool,b_getcfg_int(conf_name, "spoolretr", 1));

 fl_set_button(inc_obj->Misc_SAddr, b_getcfg_int(conf_name,"saveaddr",0));

 fl_show_form(inc_obj->In_Conf, FL_PLACE_CENTER, FL_TRANSIENT, "Incorporate");
 fl_do_only_forms();

 b_putcfg_int(conf_name, "inconstart", fl_get_button(inc_obj->Inc_Start));
 b_putcfg_int(conf_name, "beep", fl_get_button(inc_obj->Inc_Beep));
 b_putcfg_str(conf_name, "play", (char *)fl_get_input(inc_obj->Inc_Play));
 b_putcfg_str(conf_name, "spool", (char *)fl_get_input(inc_obj->Inc_Inp));

 b_putcfg_int(conf_name, "popretr", fl_get_button(inc_obj->Inc_From_POP));
 b_putcfg_int(conf_name, "spoolretr", fl_get_button(inc_obj->Inc_From_Spool));

 b_putcfg_int(conf_name, "saveaddr", fl_get_button(inc_obj->Misc_SAddr));

 fl_hide_form(inc_obj->In_Conf);

 ready = 0;
 return;         

}

void
timers_conf()
{
int i;

 if (ready)
        return;

 ready = 1;

 timers_obj = create_form_Timers();

 fl_set_counter_bounds(timers_obj->Inc_Count, 0, 60);
 fl_set_counter_precision(timers_obj->Inc_Count, 1);
 fl_set_counter_step(timers_obj->Inc_Count, 0.5, 5);
 fl_set_counter_value(timers_obj->Inc_Count, (double)((double)b_getcfg_int(conf_name,"inctime",180)/(double)60));

 fl_set_counter_bounds(timers_obj->Inc_Send, 0, 60);
 fl_set_counter_precision(timers_obj->Inc_Send, 1);
 fl_set_counter_step(timers_obj->Inc_Send, 0.5, 5);
 fl_set_counter_value(timers_obj->Inc_Send, (double)((double)b_getcfg_int(conf_name,"sendtime",0)/(double)60));

 fl_set_counter_bounds(timers_obj->Timer_Trash, 0, 48);
 fl_set_counter_precision(timers_obj->Timer_Trash, 1);
 fl_set_counter_step(timers_obj->Timer_Trash, 0.5, 5);
 fl_set_counter_value(timers_obj->Timer_Trash, (double)((double)b_getcfg_int(conf_name,"trashtime",0)/(double)60));

 fl_set_button(timers_obj->Inc_Icon, b_getcfg_int(conf_name,"incwhenicon", 0));

 fl_show_form(timers_obj->Timers, FL_PLACE_CENTER, FL_TRANSIENT, "Timers");
 fl_do_only_forms();

 b_putcfg_int(conf_name, "inctime", (int)(fl_get_counter_value(timers_obj->Inc_Count) * 60));
 b_putcfg_int(conf_name, "sendtime", (int)(fl_get_counter_value(timers_obj->Inc_Send) * 60));
 b_putcfg_int(conf_name, "trashtime", (int)(fl_get_counter_value(timers_obj->Timer_Trash) * 60));

 fl_set_timer(inc_timer, b_getcfg_int(conf_name,"inctime",180));

 i = b_getcfg_int(conf_name,"sendtime",0);
 if (i)
	i++;
 fl_set_timer(send_timer, i);

 i = b_getcfg_int(conf_name,"trashtime",0);
 if (i)
	i += 2;
 fl_set_timer(trash_timer, i);

 b_putcfg_int(conf_name, "incwhenicon", fl_get_button(timers_obj->Inc_Icon));

 fl_hide_form(timers_obj->Timers);
 fl_free_form(timers_obj->Timers);
 fl_free(timers_obj);
 timers_obj = NULL;

 ready = 0;
 return;         

}
