/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: mime_conf.c,v 1.10 1995/11/03 15:19:24 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <choose_folder.h>

static FD_Intern *int_obj;
static int ready = 0;

void
Int_Call(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
int_conf() 
{
int k, chline;
char chdescr[32];

 if (ready)
        return;

 ready = 1;

 int_obj = create_form_Intern();

 k = 0;
 chline = -1;
 while (supp_charsets[k].charset_code != CHAR_UNKNOWN)  {
        if (is_charset_alias(supp_charsets[k].charset_name)) {
                k++;
                continue;
                }

	sprintf(chdescr, "%s (%s)", supp_charsets[k].charset_name, supp_charsets[k].charset_descr);
	fl_addto_choice(int_obj->Int_ChSet, chdescr);
	if (def_charset == k)
		chline = fl_get_choice_maxitems(int_obj->Int_ChSet);
	k++;
							}

 if (chline == -1) {
	def_charset = DEFAULT_CHARSET;
	fl_set_choice(int_obj->Int_ChSet, 1);
		}
 else
	fl_set_choice(int_obj->Int_ChSet, chline);

 switch (supp_encodings[def_encoding].c_trans_enc) 	{
   case CE_7BIT:
	fl_set_button(int_obj->Int_7bit, 1);
   break;

   case CE_8BIT:
	fl_set_button(int_obj->Int_8bit, 1);
   break;

   case CE_QPRT:
	fl_set_button(int_obj->Int_qprt, 1);
   break;

   default:
	fl_set_button(int_obj->Int_8bit, 1);
	def_encoding = DEFAULT_ENCODING;
   break;
							}

 fl_show_form(int_obj->Intern, FL_PLACE_CENTER, FL_TRANSIENT, "International");

 fl_do_forms();

 k = 0;
 chline = 0;
 while (supp_charsets[k].charset_code != CHAR_UNKNOWN)  {
        if (is_charset_alias(supp_charsets[k].charset_name)) {
                k++;
                continue;
                }

	chline++;
	if (chline == fl_get_choice(int_obj->Int_ChSet)) {
		def_charset = k;
		b_putcfg_int(conf_name, "charset", k);
		break;
							}
	k++;
								}

 if (fl_get_button(int_obj->Int_7bit))
	chline = CE_7BIT;
 else
 if (fl_get_button(int_obj->Int_qprt))
	chline = CE_QPRT;
 else
	chline = CE_8BIT;

 k = 0;
 while (supp_encodings[k].c_trans_enc != CE_UNSUPPORTED) {
	if (supp_encodings[k].c_trans_enc == chline) {
		def_encoding = k;
		b_putcfg_int(conf_name, "encoding", k);
		break;
							}
	k++;
							 }

 fl_hide_form(int_obj->Intern);
 fl_free_form(int_obj->Intern);
 fl_free(int_obj);
 int_obj = NULL;

 ready = 0;
 return;         

}

