/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: log.c,v 1.8 1996/04/08 14:30:25 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

#define	MAX_LOG	127

static FD_Log *log_obj = NULL;
static int ready = 0;
static int log_lines = 0;

void
Log_Win_Call(obj, param)
FL_OBJECT *obj;
long param;
{
}

void
log_str(str)
char *str;
{
int topline, screenline;

 if (!log_obj)
	return;

 if (!str)
	return;

 if ((strlen(str) < 1) || (strlen(str) > 200))
	return;

 if (log_lines > MAX_LOG) {
	fl_clear_browser(log_obj->Log_Win);
	log_lines = 0;
			}

 fl_add_browser_line(log_obj->Log_Win, str);

 log_lines++;
 topline = fl_get_browser_topline(log_obj->Log_Win);
 screenline = fl_get_browser_screenlines(log_obj->Log_Win);

 if ((topline + screenline) <= log_lines)
	fl_set_browser_topline(log_obj->Log_Win, log_lines - screenline + 1);

 return;
}

int
log_close(form, data)
FL_FORM *form;
void *data; 
{
 log_win();
 return FL_IGNORE;
}

void
log_init()
{
 log_obj = create_form_Log();
 fl_set_form_atclose(log_obj->Log, log_close, NULL);
 fl_set_form_minsize(log_obj->Log, 300, 100);
}

void
log_win()
{
 if (ready) {
	fl_hide_form(log_obj->Log);
/*
	fl_free_form(log_obj->Log);
	fl_free(log_obj);
	log_obj = NULL;
*/
	ready = 0;
	fl_set_menu_item_mode(menu_misc, 6, FL_PUP_BOX);

        return;
	}

 ready = 1;
 fl_set_menu_item_mode(menu_misc, 6, FL_PUP_CHECK);

 if (log_obj == NULL) {
	log_obj = create_form_Log();
	fl_set_form_atclose(log_obj->Log, log_close, NULL);
	fl_set_form_minsize(log_obj->Log, 300, 100);
			}

 fl_show_form(log_obj->Log, FL_PLACE_FREE_CENTER, FL_TRANSIENT, "Log window");

 return;
}
