/*Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: msg.c,v 1.167 1996/06/30 13:49:33 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>
#define	MSG_XPM
#include <X11/xpm.h>
#include <pixmaps.h>


#define MAX_MSG_FORMS		7
#define	MAX_ADDR_NUM		32

/* NO internal editor (yet?) */
#define MAX_EDITABLE_LINES	50
#define MAX_EDITABLE_SIZE	6400

#define MAX_VIEWABLE_LINES	4096
#define MAX_VIEWABLE_SIZE	65535

struct msg_form {
	struct _mail_msg	*me_msg;
	FL_FORM			*me_form;
	FL_OBJECT		*me_from,
				*me_to,
				*me_to_list,
				*me_to_type,
				*me_subj,
				*me_text,
				*me_find,
				*me_pixmap,
				*me_bitmap,
				*me_date,
				*me_mime;
#define me_sender	me_to
	int			me_flags;
#define	MF_VIEW		0x01
#define MF_HEADER	0x02
#define	MF_CHANGED	0x04
	u_long			tofft;
};

static struct msg_form		*mf_arr[MAX_MSG_FORMS];
static int			mf_x,mf_y;
static int			num_cascade = 0;
int menuind;
int ttips = -1;

void end_msg();
void destruct_msg();
char *form_to_msg();
void ext_edit_msg(int num);
void ext_edit_exit(struct _proc_info *pinfo);
void ext_view_msg(int num, int asis);
void display_msg_text();
char *compose_msg_text(struct msg_form *mf, int update);
int update_msg(int id);
void cb_mime(FL_OBJECT *obj, long num);
void cb_addr_addto(FL_OBJECT *obj, long num);
void cb_mbutton_exit_edit(FL_OBJECT *obj, long num);
void cb_spell_button(FL_OBJECT *obj, long num);
void release_orig(int id);

void
msg_form_init()
{
int i;
	for (i=0;i<MAX_MSG_FORMS;i++) {
		mf_arr[i] = NULL;
	}
	sscanf(b_getcfg_str(conf_name, "msgformsize", "800 600"), "%d%d",
								&mf_x,&mf_y);
}

void
msg_form_shutdown()
{
char	buf[20];
int i;

	sprintf(buf,"%d %d",mf_x,mf_y);
	b_putcfg_str(conf_name, "msgformsize", buf);

	for (i=0;i<MAX_MSG_FORMS;i++) {
		if (mf_arr[i])
			end_msg(i);
	}
}

void
switch_ttips()
{
 switch (ttips) {
  case -2:
	ttips = 1;
  break;

  case 1:
	ttips = -2;
  break;

		}
}

int
post_handler(ob,event,mx,my,key,xev)
FL_OBJECT *ob;
int event;
FL_Coord mx;
FL_Coord my;
int key;
void *xev;
{

  if (ob->u_vdata == NULL)
	return 0;

  if (ttips == -1)
	ttips = b_getcfg_int(conf_name, "tooltips", 1);

  if (ttips <= 0)
	return 0;

  switch(event) {
   case FL_ENTER:
	fl_show_oneliner(ob->u_vdata, ob->form->x + ob->x,
		ob->form->y + ob->y + ob->h + 5);
   break;

   default:
    if (event != FL_MOTION)
	fl_hide_oneliner();
   break;
		  }

  return 0;
}

int
cb_size(form,xevent)
	FL_FORM		*form;
	void		*xevent;
{
	mf_x = form->w;
	mf_y = form->h;

	return 0;
}

int
cb_edit(form,xevent)
	FL_FORM		*form;
	void		*xevent;
{
	XEvent 		*xev;
	int		keysym;
	struct	msg_form	*mf;

	xev=(XEvent *)xevent;

	if (xev->type != KeyPress && 
	    xev->type != KeyRelease)
		return 0;

	if (form->focusobj->u_ldata >= MAX_MSG_FORMS)
		return 0;

	mf = mf_arr[form->focusobj->u_ldata];
	if (mf == NULL)
		return 0;

	keysym=XLookupKeysym(&(xev->xkey),0);
      	switch(keysym)  {

	  case XK_Return:
	    if (mf->me_to == form->focusobj) {
		cb_addr_addto(mf->me_to, mf->me_to->u_ldata);
		return 1; }
	  return 0;

	  default:
	  return 0;
			}
}

int
cb_view(form,xevent)
	FL_FORM		*form;
	void		*xevent;
{
	XEvent 		*xev;
	int		keysym;
	struct	msg_form	*mf;

	xev=(XEvent *)xevent;

	if ((xev->type == ButtonPress) || (xev->type == ButtonRelease)) {
		if (xev->xbutton.button == 2)
			return 1;
		else
			return 0;		}

	if (xev->type != KeyPress && 
	    xev->type != KeyRelease)
		return 1;

#if defined(sun) || defined(_AIX)
	if ((xev->xbutton.state & Mod1Mask) ||
		(xev->xbutton.state & Mod4Mask))
#else
	if (xev->xbutton.state & Mod1Mask)
#endif
		return 0;

	if (form->focusobj->u_ldata >= MAX_MSG_FORMS)
		return 0;

	mf = mf_arr[form->focusobj->u_ldata];
	if (mf == NULL)
		return 0;

	if (mf->me_find == form->focusobj)
		return 0;

	keysym=XLookupKeysym(&(xev->xkey),0);
      	switch(keysym) {
		case XK_Up:
		case XK_Down:
		case XK_Left:
		case XK_Right:
		case XK_Home:
		case XK_End:
#if defined(sun) || defined(_AIX) || defined(HP)
                case XK_Prior:
                case XK_Next:
#else
                case XK_Page_Up:
                case XK_Page_Down:
#endif
		return 0;

       		default:
		return 1;
      	}
}

void
cb_find(obj, num)
	FL_OBJECT       *obj;
	int num;
{
struct	msg_form	*mf_ptr;
int start_line;
int total_lines;
const char *cur_line;
const char *search;
int i;
static char pexp[64] = "";

#ifdef HS_REGEX
int regerr;
int regflags;
regex_t rx;
#endif

	mf_ptr = mf_arr[num];

	fl_set_object_focus(mf_ptr->me_form, mf_ptr->me_find);

	search = fl_get_input(mf_ptr->me_find);

	if ((strlen(search) < 1) || (strlen(search) >= 64))
		return;

#ifdef HS_REGEX
        regflags = REG_NOSUB | REG_EXTENDED;

        if ((regerr = regcomp(&rx, search, regflags))) {
                regfree(&rx);
		return;
                     }
#endif

	start_line = fl_get_browser(mf_ptr->me_text);
	if (start_line >= 1)
		start_line++;

	if (start_line == 0)
		start_line = 1;

	total_lines = fl_get_browser_maxline(mf_ptr->me_text);

look:	for (i = start_line; i <= total_lines; i++) {
		cur_line = fl_get_browser_line(mf_ptr->me_text, i);
		if (strlen(cur_line) < 1)
			continue;
#ifdef HS_REGEX
		if (regexec(&rx, cur_line, 0, 0, 0) == 0)
#else
		if (strstr(cur_line, search))
#endif
			{
			fl_select_browser_line(mf_ptr->me_text, i);
			fl_set_browser_topline(mf_ptr->me_text, i);
#ifdef HS_REGEX
			regfree(&rx);
#endif
			strcpy(pexp, search);
			return;
			}
							}
	if (start_line > 1) {
		total_lines = start_line - 1;
		start_line = 1;
		goto look;  }

#ifdef HS_REGEX
	regfree(&rx);
#endif
	fl_set_input(mf_ptr->me_find, pexp);
	fl_select_browser_line(mf_ptr->me_text, 1);
	fl_set_browser_topline(mf_ptr->me_text, 1);
}

void
cb_txtedit(obj, num)
	FL_OBJECT       *obj;
	int num;
{
  mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_browser(obj, num)
	FL_OBJECT       *obj;
	int num;
{
}

void
cb_browser_dbl(obj, num)
	FL_OBJECT       *obj;
	int num;
{
struct	msg_form	*mf_ptr;
char buf[255];

int line_num = fl_get_browser(obj);

	mf_ptr = mf_arr[num];

	strcpy(buf, fl_get_browser_line(obj, line_num));
	if (buf[0] == '@')
		fl_set_input(mf_ptr->me_find, buf + 3);
	else
		fl_set_input(mf_ptr->me_find, buf);
}

void
cb_conf_delivery(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= C_DELIVERY;
 else
	mf_arr[num]->me_msg->flags &= ~C_DELIVERY;
}

void
cb_conf_read(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= C_READ;
 else
	mf_arr[num]->me_msg->flags &= ~C_READ;
}

void
cb_urgent(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
 if (!mf_arr[num])
	return;

 if (fl_get_button(obj))
	mf_arr[num]->me_msg->flags |= URGENT;
 else
	mf_arr[num]->me_msg->flags &= ~URGENT;
}

void
cb_addr_add(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct _mail_addr	*adr;
struct	msg_form	*mf_ptr;
int			type = TO_TYPE , line, max_line;
char			tstr[10],*bstr, *p, *prefix;

	fl_deactivate_form(mf_arr[num]->me_form);
	adr=addr_book(&type);
	fl_activate_form(mf_arr[num]->me_form);
	if (adr == NULL)
		return;

	mf_ptr = mf_arr[num];

	prefix = "To: "; 
	switch (type) {
		case TO_TYPE:
			prefix = "To: ";
			sprintf(tstr, "Cc: ");
			break;
		case CC_TYPE:
			prefix = "Cc: ";
			sprintf(tstr,"Bcc:");
			break;
		case BCC_TYPE:
			prefix = "Bcc:";
			sprintf(tstr,"XXXX");
			break;
	}

	max_line = fl_get_browser_maxline(mf_ptr->me_to_list);

	for (line=1; line<=max_line; line++) {
		bstr=(char *)fl_get_browser_line(mf_ptr->me_to_list,line);
		if (bstr!=NULL && !strncmp(bstr, tstr, 4)) 
			break;
	}

	if (max_line < 1 || line > max_line)
	 {
	  while (adr)   {
		p = get_charset_addr_line(prefix, adr, NULL);
 		fl_add_browser_line(mf_ptr->me_to_list, p);
		adr = adr->next_addr;
			}
	 }
	else
	 {
	  while (adr)   {
		p = get_charset_addr_line(prefix, adr, NULL);
 		fl_insert_browser_line(mf_ptr->me_to_list, line, p);
		adr = adr->next_addr;
			}
	 }

	fl_select_browser_line(mf_ptr->me_to_list, 1);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_addr_addto(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
struct	msg_form	*mf_ptr;
struct _mail_addr	*ma;
char			*addr, *prefix, *tstr, *bstr;
int			line, lines;

	if (!fl_keysym_pressed(XK_Return))
		return;

	mf_ptr = mf_arr[num];

	if (!mf_ptr->me_to->focus)
		return;

	addr = (char *)fl_get_input(mf_ptr->me_to);

	if (strlen(addr) < 1)
		return;

	if ((ma = get_address(addr)) == NULL)
		return;

	discard_address(ma->next_addr);
	ma->next_addr = NULL;

	lines = fl_get_browser_maxline(mf_ptr->me_to_list);

	if (lines > MAX_ADDR_NUM) {
		discard_address(ma);
		return; }

	prefix = NULL;
	switch (fl_get_choice(mf_ptr->me_to_type)) {
	  case 1:
		prefix = "To: ";
		tstr = "Cc: ";
	  break;

	  case 2:
		prefix = "Cc: ";
		tstr = "Bcc:";
	  break;

	  case 3:
		prefix = "Bcc:";
		tstr = "XXXX";
	  break;

	  default:
		discard_address(ma);
		return;
	  break;
						   }

	for (line=1; line<=lines; line++) {
		bstr=(char *)fl_get_browser_line(mf_ptr->me_to_list,line);
		if (bstr!=NULL && !strncmp(bstr, tstr, 4)) 
			break;
	}

	if (lines < 1 || line > lines)
 		fl_add_browser_line(mf_ptr->me_to_list, get_charset_addr_line(prefix, ma, &lines));
	else
		fl_insert_browser_line(mf_ptr->me_to_list, line, get_charset_addr_line(prefix, ma, &lines));

	fl_select_browser_line(mf_ptr->me_to_list, 1);
	discard_address(ma);
	fl_set_input(mf_ptr->me_to, "");
	fl_set_object_focus(mf_ptr->me_form, mf_ptr->me_text);
	fl_set_input_cursorpos(mf_ptr->me_text, 0, 0);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_addr_list(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
}

void
cb_addr_list_dbl(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
int lnum;
char *bstr;
struct _mail_addr *ma;

  lnum=fl_get_browser(obj);

  bstr = (char *)fl_get_browser_line(obj, lnum);
  if (strlen(bstr) < 6)
	return;

  bstr += 4;
  if ((ma = get_address(bstr)) == NULL)
	return;

  discard_address(ma->next_addr);
  ma->next_addr = NULL;

  if (display_msg(MSG_QUEST, NULL, "Append to address book?")) 	{
	add_book(ma, 1);
	save_book();
								}

  discard_address(ma);

  return;
}

void
cb_addr_modify(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct _mail_addr	*adr;
struct	msg_form	*mf_ptr;
int			type = TO_TYPE , line, max_line;
char			tstr[10],*bstr,*bstr_c, *p;

	mf_ptr = mf_arr[num];

	max_line = fl_get_browser_maxline(mf_ptr->me_to_list);

	for (line = 1; line <= max_line; line++)
		if (fl_isselected_browser_line(mf_ptr->me_to_list, line))
			break;

	if (line > max_line)
		return;

	bstr = (char *)fl_get_browser_line(mf_ptr->me_to_list, line);
	bstr_c = bstr+4;

	if (!strncmp(bstr,"To: ",4))
		type = TO_TYPE;
	if (!strncmp(bstr,"Cc: ",4))
		type = CC_TYPE;
	if (!strncmp(bstr,"Bcc:",4))
		type = BCC_TYPE;

	

	fl_deactivate_form(mf_arr[num]->me_form);
	adr=mod_addr(bstr_c, &type);
	fl_activate_form(mf_arr[num]->me_form);
	if (adr == NULL)
		return;

	p = NULL;
	switch (type) {
		case TO_TYPE:
			p = get_charset_addr_line("To: ", adr, NULL);
			sprintf(tstr, "Cc: ");
			break;
		case CC_TYPE:
			p = get_charset_addr_line("Cc: ", adr, NULL);
			sprintf(tstr,"Bcc:");
			break;
		case BCC_TYPE:
			p = get_charset_addr_line("Bcc:", adr, NULL);
			sprintf(tstr,"XXXX");
			break;
	}

	fl_delete_browser_line(mf_ptr->me_to_list, line);
	max_line --;


	for (line=1; line<=max_line; line++) {
		bstr=(char *)fl_get_browser_line(mf_ptr->me_to_list,line);
		if (bstr!=NULL && !strncmp(bstr, tstr, 4)) 
			break;
	}

	if (max_line < 1 || line > max_line)
 		fl_add_browser_line(mf_ptr->me_to_list, p);
	else
		fl_insert_browser_line(mf_ptr->me_to_list, line, p);

	fl_select_browser_line(mf_ptr->me_to_list, line);
	mf_ptr->me_flags |= MF_CHANGED;
	return;
}

void
cb_addr_del(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf_ptr;
int			line, max_line;

	mf_ptr = mf_arr[num];
	max_line = fl_get_browser_maxline(mf_ptr->me_to_list);

	for (line = 1; line <= max_line; line++)
		if (fl_isselected_browser_line(mf_ptr->me_to_list, line))
			break;

	if (line > max_line)
		return;

	fl_delete_browser_line(mf_ptr->me_to_list, line);
	fl_select_browser_line(mf_ptr->me_to_list, 1);
	mf_ptr->me_flags |= MF_CHANGED;

	return;
}

void
cb_msg_help(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
	switch (n) {
		case 1:
			if (mf->me_flags & MF_VIEW)
			  help("%Viewmsg");
			else
			  help("%Editmsg");
		break;
		   }
}

void
cb_msg_tools(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
	switch (n) {
		case 1: 	/* Spell checking */
			display_msg(MSG_WARN, "SPELL", "Sorry this feature is not implemented yet");
		break;
		   }
}

void
cb_msg_edit(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;
const char *fname;
FILE *afd;
struct stat sb;
char *tfile;

	mf = mf_arr[num];

	n = fl_get_menu(obj);

	if (!mf)
		return;

	if (!mf->me_msg)
		return;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	mf->me_flags |= MF_CHANGED;

	switch (n) {
		case 1: 	/* Insert file */
			fl_set_fselector_title("Choose file to insert");
			if (!(fname = fl_show_file_selector("Insert file","","","")))
				break;

			tfile = form_to_msg(num, 0);
			add_file_to_msg(tfile, (char *)fname);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 2: 	/* Uuencode file */
			if (mf->me_msg->mime) 	{
			 if ((mf->me_msg->mime->encoding->c_trans_enc == CE_QPRT) ||
				(mf->me_msg->mime->encoding->c_trans_enc == CE_BASE64))	
				display_msg(MSG_WARN, "uuencode", "uuencoding is not recommended with BASE64\nor quoted-printable message encoding\nsome e-mail clients may have problems with decoding of this message");
						}
			fl_set_fselector_title("Choose file to uuencode");
			if (!(fname = fl_show_file_selector("Uuencode file","","","")))
				break;

			tfile = form_to_msg(num, 0);
			uuencode(tfile, (char *)fname);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 3:		/* Save to file */
			fl_set_fselector_title("Choose file to save");
			if (!(fname = fl_show_file_selector("Save as","","","")))
				break;

			compose_msg_text(mf, 1);

                        if (stat(mf->me_msg->get_file(mf->me_msg), &sb) == -1) {
                                display_msg(MSG_WARN, "stat", "Failed to stat %s", mf->me_msg->get_file(mf->me_msg));
                                break; }

                        if (fastcopy(mf->me_msg->get_file(mf->me_msg), (char *)fname, &sb) == 1)
                                display_msg(MSG_WARN, "copy", "Failed to copy");
		break;

		case 4:		/* Append to file */
			fl_set_fselector_title("Choose file to append");
			if (!(fname = fl_show_file_selector("Append to","","","")))
				break;

			compose_msg_text(mf, 1);

                        if (!(afd = fopen(fname, "a"))) {
                                display_msg(MSG_WARN, "add", "Can not open %s", fname);
                                break; }

                        print_message(mf->me_msg, afd, 0);
                        fclose(afd);
		break;

		case 5:		/* Sign Message */
			tfile = form_to_msg(num, 0);
			add_signature_to_msg(mf->me_msg, tfile); 
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 6:		/* Quote original */
			if ((mf->me_msg->data != MSG_DAT_ORIG) ||
				(mf->me_msg->pdata == NULL)) {
				display_msg(MSG_WARN, "Insert original", "Nothing to insert");
				break;
						}

			tfile = form_to_msg(num, 0);
	  		insert_orig(tfile, (struct _mail_msg *)mf->me_msg->pdata, 0);
			update_mime(mf->me_msg);
			update_msg(num);
		break;

		case 7:		/* run external spellchecker */
			cb_spell_button(NULL, num);
		break;

		default:
		break;
		   }

	fl_activate_form(mf->me_form);
	set_cursor(mf->me_form, 0);

}

void
cb_mime_list(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form	*mf;
XEvent *xev;
int apup;

	xev = (XEvent *)fl_last_event();
	mf = mf_arr[num];

	if ((xev->type == ButtonPress) || (xev->type == ButtonRelease)) {
	if ((mf->me_flags & MF_VIEW) && (xev->xbutton.state & Button3Mask)) {
	 apup = fl_defpup(mf->me_form->window, "Attachment%t|Save|View|Print");
	 menuind = fl_dopup(apup);
	 cb_mime(NULL, num);
	 fl_freepup(apup);
									    }
									}
}

void
cb_mime_list_dbl(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct _mime_msg *mime;
struct _mail_msg *msg;
struct msg_form	*mf;
int x,n;

	mf = mf_arr[num];
	msg = mf->me_msg;
	mime = NULL;

	if (!(mf->me_flags & MF_VIEW))
		return;

	x = n = fl_get_browser(obj);

	mime = msg->mime;
	while (n && mime) {
	  if (!(mime->flags == ATTACHMENT)) {
	  	mime = mime->mime_next;
		continue;		    }
	  n--;
	  if (!n)
		break;

	  mime = mime->mime_next;
			  }

	if (!mime)
		return;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	view_part(msg, mime);
	set_cursor(mf->me_form, 0);
	fl_activate_form(mf->me_form);

	return;
}

void
cb_mime(obj, num)
	FL_OBJECT	*obj;
	long		num;
{
struct _mime_msg *mime, *mime1;
struct _mail_msg *msg;
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];
	msg = mf->me_msg;
	mime = NULL;

	for (n = 1;n <= fl_get_browser_maxline(mf->me_mime); n++) {
	 if (fl_isselected_browser_line(mf->me_mime, n)) {
		mime = msg->mime;
		while (n && mime) {
		  if (!(mime->flags == ATTACHMENT)) {
		  	mime = mime->mime_next;
			continue;		    }
		  n--;
		  if (!n)
			break;

		  mime = mime->mime_next;
				  }
	 break;
							  }
								  }

	if (obj == NULL)
		n = menuind;
	else
		n = fl_get_menu(obj);

	if (!mime && (n != 4))
		return;

	switch (n) 	{
	  case 1:	/* Save attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		save_part(msg, mime, NULL, 0);
		set_cursor(mf->me_form, 0);
		fl_activate_form(mf->me_form);
	  break;

	  case 2:	/* View attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		view_part(msg, mime);
		set_cursor(mf->me_form, 0);
		fl_activate_form(mf->me_form);
	  break;

	  case 3:	/* Print attachment */
		set_cursor(mf->me_form, XC_watch);
		if (mime->mailcap->print)
		   (*mime->mailcap->print)(msg, mime);
		else
		   display_msg(MSG_WARN, "Don't know how to print", "%s/%s", mime->mailcap->type_text, mime->mailcap->subtype_text);
		set_cursor(mf->me_form, 0);
	  break;

	  case 4:	/* Add attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		mime1 = compose_attachment();
		if (mime1 != NULL) {
		 form_to_msg(num, 0);
		 fl_check_only_forms();
		 mime1->mime_next = msg->mime;
		 msg->mime = mime1;
		 if (update_mime(msg) == -1)
			display_msg(MSG_WARN, "MIME", "Mime update failed");

		 update_msg(num);
				}
		set_cursor(mf->me_form, 0);
		mf->me_flags |= MF_CHANGED;
		fl_activate_form(mf->me_form);
	  break;

	  case 5:	/* Delete attachment */
		fl_deactivate_form(mf->me_form);
		set_cursor(mf->me_form, XC_watch);
		form_to_msg(num, 0);
		mime->flags &= ~ATTACHMENT;
		update_mime(msg);
		update_msg(num);
		set_cursor(mf->me_form, 0);
		mf->me_flags |= MF_CHANGED;
		fl_activate_form(mf->me_form);
	  break;

	  default:
	  break;

			}
}

void
cb_msg_message(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;
FILE *afd;
struct stat sb;
const char *fname;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
	switch (n) {
		case 1: /* Reply to sender */
			fl_deactivate_form(mf->me_form);
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_reply_msg(mf->me_msg, 0));
			redraw_fld(outbox);
			redraw_fld_line(mf->me_msg->folder);
		break;

		case 2: /* Reply to all */
			fl_deactivate_form(mf->me_form);
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_reply_msg(mf->me_msg, 1));
			redraw_fld(outbox);
			redraw_fld_line(mf->me_msg->folder);
		break;

		case 3: /* Forward */
        		set_cursor(mf->me_form, XC_watch); 
			edit_msg(get_fwd_msg(mf->me_msg));
			redraw_fld(outbox);
        		set_cursor(mf->me_form, 0); 
		break;

		case 4: 
			mf->me_msg->flags &= ~LOCKED;
			fl_deactivate_form(mf->me_form);
			mf->me_msg = move_message(mf->me_msg, NULL);
			fl_activate_form(mf->me_form);
			if (mf->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
				update_msg(num);
			else
				end_msg(num);
		break;

		case 5:
			mf->me_msg->flags &= ~LOCKED;
			mf->me_msg = delete_msg(mf_arr[num]->me_msg);
			if (mf->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
				update_msg(num);
			else
				end_msg(num);
		break;

		case 6: /* Show header */
			if (mf->me_flags & MF_HEADER) {
				mf->me_flags &= ~MF_HEADER;
				fl_set_menu_item_mode(obj, 6, FL_PUP_BOX);
			} else {
				mf->me_flags |= MF_HEADER;
				fl_set_menu_item_mode(obj, 6, FL_PUP_CHECK);
			}
			fl_freeze_form(mf->me_form);
			display_msg_text(mf);
			fl_unfreeze_form(mf->me_form);
			break;
		case 7: /* Save from field */
			add_book(mf->me_msg->header->From, 1);
			save_book();
			break;

		case 8: /* Save to file */
			if (!mf->me_msg)
				break;

			fl_set_fselector_title("Choose file to save as");
			if (!(fname = fl_show_file_selector("Save as","","","")))
                                break;

                        if (stat(mf->me_msg->get_file(mf->me_msg), &sb) == -1) {
                                display_msg(MSG_WARN, "stat", "Failed to stat %s", mf->me_msg->get_file(mf->me_msg));
                                break; }

                        if (fastcopy(mf->me_msg->get_file(mf->me_msg), (char *)fname, &sb) == 1)
                                display_msg(MSG_WARN, "copy", "Failed to copy");

				break;

		case 9: /* Append to file */
			if (!mf->me_msg)
				break;

			fl_set_fselector_title("Choose file to append");
			if (!(fname = fl_show_file_selector("Append to","","","")))
                                break;

                        if (!(afd = fopen(fname, "a"))) {
                                display_msg(MSG_WARN, "add", "Can not open %s", fname);
                                break; }

                        print_message(mf->me_msg, afd, 0);
                        fclose(afd);

			break;

		case 10: /* Uudecode */
			if (!mf->me_msg)
				break;

			uudecode(mf->me_msg);
			break;

		case 11: /* Save all addresses */
			add_msg_addr(mf->me_msg);
			save_book();
			break;

		case 12: /* Print */
        		set_cursor(mf->me_form, XC_watch); 
			lpr_message(mf->me_msg);
			set_cursor(mf->me_form, 0);
			break;

		default:
			break;
	}
}


void
cb_msg_file_view(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
int			n;

	mf = mf_arr[num];

	n = fl_get_menu(obj);
        switch(n) {
		case 1:
			end_msg(num);
	}
}

void
cb_msg_file_edit(obj, num)
	FL_OBJECT	*obj;
	int		num;
{
struct msg_form		*mf;
struct _mail_msg	*msg;
char			*tfile;
int			n;

	mf = mf_arr[num];
	if (mf == NULL)
		return;

	msg = mf_arr[num]->me_msg;
	if (msg == NULL)
		return;

	n = fl_get_menu(obj);
        switch(n) {
		case 1: /* Send */
			if (!(msg->flags & SIGNED) &&
				(b_getcfg_int(conf_name, "sattach", 2) == 3)) {
			  tfile = form_to_msg(num, 0);
			  add_signature_to_msg(mf->me_msg, tfile); 
			  update_mime(mf->me_msg);
									      }
			else
			  form_to_msg(num, 1);

			msg->flags &= ~LOCKED;
			release_orig(num);
		 	set_cursor(mf->me_form, XC_watch);
			my_deactivate();
			if (send_message(msg) == -1) {
		 		set_cursor(mf->me_form, 0);
				display_msg(MSG_WARN, "send", "Failed to send");
				msg->flags |= LOCKED;
				my_activate();
				break; }
			my_activate();

			redraw_fld(outbox);
		 	set_cursor(mf->me_form, 0);

			mf_arr[num]->me_msg = NULL;	
       			end_msg(num);

			break;

		case 2:
			cb_mbutton_exit_edit(NULL, num);
			break;
	}
}

void
cb_attach_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mime_msg *mime;
struct _mail_msg *msg;
struct msg_form  *mf;

	mf = mf_arr[num];
	msg = mf->me_msg;

	fl_deactivate_form(mf->me_form);
	set_cursor(mf->me_form, XC_watch);
	mime = compose_attachment();
	if (mime != NULL) {
	 form_to_msg(num, 0);
	 fl_check_only_forms();
	 mime->mime_next = msg->mime;
	 msg->mime = mime;
	 if (update_mime(msg) == -1)
		display_msg(MSG_WARN, "MIME", "Mime update failed");

	 update_msg(num);
			}
	set_cursor(mf->me_form, 0);
	mf->me_flags |= MF_CHANGED;
	fl_activate_form(mf->me_form);

	return;
}

void
cb_spell_button(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;
struct _proc_info pinfo;
char command[255];
char *e;
int i;
int added = 0;

 tfile = form_to_msg(num, 0);
 if (!tfile)
	return;

 e = b_getcfg_str(conf_name, "extspell", "/usr/bin/X11/xterm -e /usr/local/bin/ispell");
 command[0] = '\0';
 for (i = 0; i < strlen(e); i++) {
  if ((e[i] == '$') && (e[i] == 'f')) {
	added = 1;
	strcat(command, tfile); }
  else 	{
	command[strlen(command) + 1] = '\0';
	command[strlen(command)] = e[i];
	}
				}

 if (!added) {
	strcat(command, " ");
	strcat(command, tfile);
	added = 1;
		}

 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(tfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_edit_exit;
 pinfo.ifd = -1;

 fl_deactivate_form(mf_arr[num]->me_form);
 mf_arr[num]->me_flags |= MF_CHANGED;
 if (exec_child(command, &pinfo) == -1)
	ext_edit_exit(&pinfo);

 return;
}

void
cb_mbutton_insorig(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;

	if ((mf_arr[num]->me_msg->data != MSG_DAT_ORIG) ||
		(mf_arr[num]->me_msg->pdata == NULL)) {
		display_msg(MSG_WARN, "Insert original", "Nothing to insert");
		return;
						}

	tfile = form_to_msg(num, 0);
	if (fl_get_button_numb(obj) == 3)
	  insert_orig(tfile, (struct _mail_msg *)mf_arr[num]->me_msg->pdata, 1);
	else
	  insert_orig(tfile, (struct _mail_msg *)mf_arr[num]->me_msg->pdata, 0);
	update_mime(mf_arr[num]->me_msg);
	update_msg(num);
	mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_view(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
  if (fl_get_button_numb(obj) == 3)
	ext_view_msg(num, 1);
  else
	ext_view_msg(num, 0);
}

void
cb_mbutton_print(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	if (!mf_arr[num])
		return;

        set_cursor(mf_arr[num]->me_form, XC_watch); 
        lpr_message(mf_arr[num]->me_msg);
        set_cursor(mf_arr[num]->me_form, 0);
}

void
cb_mbutton_edit(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	ext_edit_msg(num);
}

void
cb_mbutton_sign(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
char *tfile;

 tfile = form_to_msg(num, 0);
 if (fl_get_button_numb(obj) == 3)
	signform = mf_arr[num]->me_form;
 else
	signform = NULL;
 add_signature_to_msg(mf_arr[num]->me_msg, tfile); 
 signform = NULL;
 update_mime(mf_arr[num]->me_msg);
 update_msg(num);
 mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_insert(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
const char *fname;
char *tfile;

 fl_set_fselector_title("Choose file to insert");
 if (!(fname = fl_show_file_selector("Insert file","","","")))
	return;

 tfile = form_to_msg(num, 0);
 add_file_to_msg(tfile, (char *)fname);
 update_mime(mf_arr[num]->me_msg);
 update_msg(num);
 mf_arr[num]->me_flags |= MF_CHANGED;
}

void
cb_mbutton_reply(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	fl_deactivate_form(mf_arr[num]->me_form);
       	set_cursor(mf_arr[num]->me_form, XC_watch); 
	if (fl_get_button_numb(obj) == 3)
	 edit_msg(get_reply_msg(mf_arr[num]->me_msg, 0));
	else
	 edit_msg(get_reply_msg(mf_arr[num]->me_msg, 1));
	redraw_fld(outbox);
}

void
cb_mbutton_forward(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	edit_msg(get_fwd_msg(mf_arr[num]->me_msg));
	redraw_fld(outbox);
}

void
cb_mbutton_move(obj, num)
        FL_OBJECT               *obj;
        long                    num;
{
struct _mail_msg *msg;
struct _mail_folder *fld;

	if (fl_get_button_numb(obj) == 3) {
		if ((fld = pup_choose_folder(mf_arr[num]->me_form)) == NULL)
			return;
					  }
	else
		fld = NULL;

	mf_arr[num]->me_msg->flags &= ~LOCKED;

	fl_deactivate_form(mf_arr[num]->me_form);
	msg = move_message(mf_arr[num]->me_msg, fld);
	fl_activate_form(mf_arr[num]->me_form);

	if (msg)
		msg->flags |= LOCKED;

	if (msg == mf_arr[num]->me_msg)
		return;

	mf_arr[num]->me_msg = msg;

	if (mf_arr[num]->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
		update_msg(num); 
	else 
		end_msg(num);

	return;
}


void
cb_mbutton_delete(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	mf_arr[num]->me_msg->flags &= ~LOCKED;
	if (mf_arr[num]->me_msg->flags & M_TEMP) {
		trash->move(mf_arr[num]->me_msg, trash);
		mf_arr[num]->me_msg = NULL;
						}
	else
		mf_arr[num]->me_msg = delete_msg(mf_arr[num]->me_msg);

	if (mf_arr[num]->me_msg && !b_getcfg_int(conf_name,"viewexit",0))
		update_msg(num);
	else
		end_msg(num);
}

void
cb_mbutton_np(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mail_msg	*msg;
int mnum = obj->u_ldata;

	if (!mf_arr[mnum])
		return;
	
	msg = mf_arr[mnum]->me_msg;
	if (!msg)
		return;

	fl_set_object_callback(obj,NULL,num);

	switch(num) {
		case 1:
			msg = prev_msg(1, msg);
			break;
		case 2:
			msg = prev_msg(0, msg);
			break;
		case 3:
			msg = next_msg(0, msg);
			break;
		case 4:
			msg = next_msg(1, msg);
			break;
			
	}

	if (msg) {
		mf_arr[obj->u_ldata]->me_msg->flags &= ~LOCKED;
		msg->free_text(mf_arr[obj->u_ldata]->me_msg);
		mf_arr[obj->u_ldata]->me_msg->update(mf_arr[obj->u_ldata]->me_msg);
		redraw_msg(mf_arr[obj->u_ldata]->me_msg);
	
		mf_arr[obj->u_ldata]->me_msg = msg;
		update_msg(obj->u_ldata);
		redraw_fld_line(mf_arr[obj->u_ldata]->me_msg->folder);
	}

	fl_set_object_callback(obj,cb_mbutton_np,num);
}


void
cb_mbutton_exit_view(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
	fl_set_object_callback(obj,NULL,0);
       	end_msg(num);
}

void
cb_mbutton_exit_edit(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
int	res;
struct _mail_msg *msg;

	if (mf_arr[num] == NULL)
		return;

	if (obj)
		fl_set_object_callback(obj,NULL,0);

	msg = mf_arr[num]->me_msg;

	if (msg->folder != outbox) {
		if ((mf_arr[num]->me_flags & MF_CHANGED) &&
			fl_show_question("Save changes?", NULL, NULL))
			form_to_msg(num, 1);

		end_msg(num);
		redraw_msg(msg);
		return;				}

		fl_set_choices_shortcut("Yy#y", "Nn#n", "Cc#c");
		if (!(mf_arr[num]->me_flags & MF_CHANGED))
		   res = 2;
		else
		   res = fl_show_choice("Changes were made to this message.",
			       "Do you want to save as draft?","",3,
				"Yes","No","Cancel");

		if (res == 3) {
			if (obj)
			   fl_set_object_callback(obj,cb_mbutton_exit_edit,num);
			return;
		}


		msg->flags &= ~LOCKED;

		if (res == 2) {
			msg->flags |= DELETED;

        		end_msg(num);
			redraw_fld(outbox);
			return;
		}

		form_to_msg(num, 1);
		msg->flags |= MOVED;

        	end_msg(num);
		redraw_fld(outbox);
}

int
close_edit_form(form, data)
FL_FORM *form;
void *data;
{
FL_OBJECT *obj = (FL_OBJECT *)data;

 if (!form->deactivated)
	cb_mbutton_exit_edit(obj, obj->u_ldata);

 return FL_IGNORE;
}

int
close_view_form(form, data)
FL_FORM *form;
void *data;
{
FL_OBJECT *obj = (FL_OBJECT *)data;

 if (!form->deactivated)
	cb_mbutton_exit_view(obj, obj->u_ldata);

 return FL_IGNORE;
}

void
cb_mbutton_send(obj, num)
	FL_OBJECT		*obj;
	long			num;
{
struct _mail_msg *msg;
struct _mail_folder *fld;
char *tfile;

	if (mf_arr[num] == NULL)
		return;

	msg = mf_arr[num]->me_msg;
	if (msg == NULL)
		return;

	fld = msg->folder;

	if (!(msg->flags & SIGNED) &&
		(b_getcfg_int(conf_name, "sattach", 2) == 3)) {
	  tfile = form_to_msg(num, 0);
	  add_signature_to_msg(msg, tfile); 
	  update_mime(msg);
							      }
	else
	  form_to_msg(num, 1);

	msg->flags &= ~LOCKED;

	set_cursor(mf_arr[num]->me_form, XC_watch);
	my_deactivate();
	release_orig(num);
	if (send_message(msg) == -1) {
		set_cursor(mf_arr[num]->me_form, 0);
		display_msg(MSG_WARN, "send", "Failed to send");
		msg->flags |= LOCKED;
		my_activate();
		return; }
	my_activate();
	set_cursor(mf_arr[num]->me_form, 0);

	redraw_fld(outbox);
	redraw_fld(fld);

	mf_arr[num]->me_msg = NULL;	
       	end_msg(num);
}


struct msg_form *
create_msg_form(msg_f,num)
  	struct msg_form		*msg_f;
	int			num;
{
  FL_FORM   		*form;
  FL_OBJECT 		*obj;
  int menubox_bottom = 1;
  int menus_y_offset = menubox_bottom + 5;
  int buttons_y_bottom = menubox_bottom + 36;
  int box_y_bottom = buttons_y_bottom + 40;
  int box_y_height = 120;
  int browserbottom = 200;
  int browserheight = 335;
  XWMHints *xwmh;

  form = fl_bgn_form(FL_NO_BOX, 805, 605);
  msg_f->me_form = form;
  
  obj = fl_add_box(FL_FLAT_BOX,0,0,805,605,"");
  obj->u_ldata = num;

  obj = fl_add_box(FL_UP_BOX,1,menubox_bottom,804,29,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,0);

  obj = fl_add_menu(FL_PULLDOWN_MENU,5,menus_y_offset,30,20,"File");
  obj->u_ldata = num;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);
    fl_set_object_resize(obj,FL_RESIZE_NONE);
    fl_set_object_gravity(obj,NorthWestGravity,0);

  if (msg_f->me_flags & MF_VIEW) {
    fl_set_menu(obj,"Exit (Alt+X)");
    fl_set_object_callback(obj,cb_msg_file_view,num);
    fl_set_menu_item_shortcut(obj, 1, "Xx#xQq#q");
  } else {
    fl_set_menu(obj,"Send (Ctrl+S)|Exit (Ctrl+X)");
    fl_set_object_callback(obj,cb_msg_file_edit,num);
    fl_set_menu_item_shortcut(obj, 1, "Ss#s");
    fl_set_menu_item_shortcut(obj, 2, "Xx#xQq#q");
  }

  obj = fl_add_menu(FL_PULLDOWN_MENU,755,menus_y_offset,40,20,"Help");
  obj->u_ldata = num;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT);
   fl_set_menu(obj,"Contents");
   fl_set_menu_item_shortcut(obj, 1, "Cc#c");
   fl_set_object_callback(obj,cb_msg_help,num);
   fl_set_object_resize(obj,FL_RESIZE_X);
   fl_set_object_gravity(obj,NorthGravity,EastGravity);

  obj = fl_add_menu(FL_PULLDOWN_MENU,155,menus_y_offset,140,20,"Attachment");
  obj->u_ldata = num;
  fl_set_object_boxtype(obj,FL_FLAT_BOX);
  fl_set_object_lalign(obj,FL_ALIGN_LEFT);
  fl_set_object_callback(obj,cb_mime,num);
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthGravity,EastGravity);

  if (msg_f->me_flags & MF_VIEW) {
   	fl_set_object_shortcut(obj, "#A", 1);
    	fl_set_menu(obj,"Save|View|Print");
	fl_set_menu_item_shortcut(obj, 1, "Ss#s");
	fl_set_menu_item_shortcut(obj, 2, "Vv#v");
	fl_set_menu_item_shortcut(obj, 3, "Pp#p");

	obj = fl_add_menu(FL_PULLDOWN_MENU,60,menus_y_offset,60,20,"Message");
	obj->u_ldata = num;
	    	fl_set_object_boxtype(obj,FL_FLAT_BOX);
	    	fl_set_object_lalign(obj,FL_ALIGN_LEFT);
		fl_set_object_resize(obj,FL_RESIZE_NONE);
		fl_set_object_gravity(obj,NorthWestGravity,0);
   		fl_set_object_shortcut(obj, "#G", 1);
    	fl_set_menu(obj,"Reply to Sender|Reply to All (Alt+R)|Forward (Alt+F)%l|Move to Folder (Alt+M)|Delete (Alt+D)%l|Show Header|Save From Field%l|Save to File|Append to File|Uudecode|Save All Addr|Print (Alt+P)");
	fl_set_menu_item_shortcut(obj, 1, "Tt#t");
	fl_set_menu_item_shortcut(obj, 2, "Rr#r");
	fl_set_menu_item_shortcut(obj, 3, "Ff#f");
	fl_set_menu_item_shortcut(obj, 4, "Mm#m");
	fl_set_menu_item_shortcut(obj, 5, "Dd#d");
	fl_set_menu_item_shortcut(obj, 6, "Hh#h");
	fl_set_menu_item_shortcut(obj, 7, "Ll#l");
	fl_set_menu_item_shortcut(obj, 8, "Ss#s");
	fl_set_menu_item_shortcut(obj, 9, "Aa#a");
	fl_set_menu_item_shortcut(obj,10, "Uu#u");
	fl_set_menu_item_shortcut(obj,11, "Vv#v");
	fl_set_menu_item_shortcut(obj,12, "Pp#p");

	if (b_getcfg_int(conf_name, "sheader", 0))
	  fl_set_menu_item_mode(obj, 6, FL_PUP_CHECK);
	else
	  fl_set_menu_item_mode(obj, 6, FL_PUP_BOX);

        fl_set_object_callback(obj,cb_msg_message,num);
  } else {
    	fl_set_menu(obj,"Add (Alt+T) %x4|Delete %x5");
	fl_set_menu_item_shortcut(obj, 1, "Aa#a");
	fl_set_menu_item_shortcut(obj, 2, "Dd#d");

  	obj = fl_add_menu(FL_PULLDOWN_MENU,60,menus_y_offset,40,20,"Edit");
  	obj->u_ldata = num;
    		fl_set_object_boxtype(obj,FL_FLAT_BOX);
    		fl_set_object_lalign(obj,FL_ALIGN_LEFT);
		fl_set_object_resize(obj,FL_RESIZE_NONE);
		fl_set_object_gravity(obj,NorthWestGravity,0);
    	fl_set_menu(obj,"Insert file (Alt+I)|Uuencode file|Save to File|Append to File%l|Sign Message (Alt+S)|Quote original (Alt+Q)|Spelling check (Alt+P)");
        fl_set_object_callback(obj,cb_msg_edit,num);

	fl_set_menu_item_shortcut(obj, 1, "Ii#i");
	fl_set_menu_item_shortcut(obj, 2, "Uu#u");
	fl_set_menu_item_shortcut(obj, 3, "Ss#s");
	fl_set_menu_item_shortcut(obj, 4, "Aa#a");
	fl_set_menu_item_shortcut(obj, 5, "Ss#s");
	fl_set_menu_item_shortcut(obj, 6, "Qq#q");
	fl_set_menu_item_shortcut(obj, 6, "Pp#p");
 
  }

  obj = fl_add_box(FL_FRAME_BOX,10,box_y_bottom,785,box_y_height,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,EastGravity);

  obj = fl_add_text(FL_NORMAL_TEXT,120,box_y_bottom+4,40,20,"Date:");
  obj->u_ldata = num;
  fl_set_object_boxtype(obj,FL_FLAT_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);

  obj = fl_add_text(FL_NORMAL_TEXT,160,box_y_bottom+4,300,20,"");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  msg_f->me_date = obj;
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  obj = fl_add_text(FL_NORMAL_TEXT,205,box_y_bottom+22,100,18,"From:");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  obj = fl_add_input(FL_NORMAL_INPUT,90,box_y_bottom+39,345,25,"");
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  obj->u_ldata = num;
  msg_f->me_from = obj;
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
  fl_set_object_callback(obj,cb_txtedit,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);

  obj = fl_add_text(FL_NORMAL_TEXT,20,box_y_bottom+68,77,18,"Subject:");
  obj->u_ldata = num;
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  msg_f->me_subj = obj = fl_add_input(FL_NORMAL_INPUT,90,box_y_bottom+64,345,25,"");
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_txtedit,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);

  if (msg_f->me_flags & MF_VIEW) {
	obj = fl_add_text(FL_NORMAL_TEXT,550,box_y_bottom+22,100,18,"Sender:");
	obj->u_ldata = num;
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
	fl_set_object_boxtype(obj,FL_FLAT_BOX);
	fl_set_object_lalign(obj,FL_ALIGN_LEFT);

  	obj = fl_add_input(FL_NORMAL_INPUT,445,box_y_bottom+39,340,25,"");
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
    	fl_set_object_lalign(obj,FL_ALIGN_TOP);
  	obj->u_ldata = num;
	msg_f->me_to = obj;
	fl_set_object_callback(obj,cb_txtedit,num);
  } else {
  	obj = fl_add_choice(FL_NORMAL_CHOICE,445,box_y_bottom+40,30,23,"");
	fl_set_object_boxtype(obj,FL_UP_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
	msg_f->me_to_type = obj;

  	obj = fl_add_input(FL_NORMAL_INPUT,475,box_y_bottom+40,310,23,"");
	fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  	obj->u_ldata = num;
	fl_set_object_callback(obj, cb_addr_addto, num);
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	msg_f->me_to = obj;

  	obj = fl_add_text(FL_NORMAL_TEXT,70,box_y_bottom+90,60,25,"Confirm:");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
	fl_set_object_boxtype(obj,FL_NO_BOX);
  	obj->u_ldata = num;

	obj = fl_add_roundbutton(FL_PUSH_BUTTON,130, box_y_bottom+90, 25, 25, "Delivery");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_conf_delivery,num);

	obj = fl_add_roundbutton(FL_PUSH_BUTTON,230, box_y_bottom+90, 25, 25, "Read");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_conf_read,num);

	obj = fl_add_checkbutton(FL_PUSH_BUTTON,330, box_y_bottom+90, 25, 25, "Urgent");
	fl_set_object_resize(obj,FL_RESIZE_NONE);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_urgent,num);
  }

  obj = fl_add_browser(FL_HOLD_BROWSER,445,box_y_bottom+65,340,50,"");
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_addr_list,num);
  fl_set_browser_dblclick_callback(obj,cb_addr_list_dbl,num);
  msg_f->me_to_list = obj;

  if (!(msg_f->me_flags & MF_VIEW)) {
  	obj = fl_add_button(FL_NORMAL_BUTTON,445,box_y_bottom+5,80,25,"Address");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,0);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_add,num);
	fl_set_button_shortcut(obj, "#A", 0);

  	obj = fl_add_button(FL_NORMAL_BUTTON,535,box_y_bottom+5,165,25,"Modify");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthWestGravity,EastGravity);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_modify,num);

  	obj = fl_add_button(FL_NORMAL_BUTTON,705,box_y_bottom+5,80,25,"Delete");
        fl_set_object_resize(obj,FL_RESIZE_X);
	fl_set_object_gravity(obj,NorthGravity, EastGravity);
  	obj->u_ldata = num;
    	fl_set_object_callback(obj,cb_addr_del,num);
  }

  obj = fl_add_bitmap(FL_NORMAL_BITMAP,27,box_y_bottom+7,54,54,"");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  fl_set_object_color(obj,FL_WHITE, FL_WHITE);
  obj->u_ldata = num;
  msg_f->me_bitmap = obj;

  obj = fl_add_pixmap(FL_NORMAL_PIXMAP,27,box_y_bottom+7,54,54,"");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,NorthWestGravity,0);
  fl_set_object_color(obj,FL_WHITE, FL_WHITE);
  obj->u_ldata = num;
  msg_f->me_pixmap = obj;

  if (msg_f->me_flags &  MF_VIEW) 
	obj = fl_add_browser(FL_HOLD_BROWSER,10,536,785,35,"");
  else
	obj = fl_add_browser(FL_HOLD_BROWSER,10,566,785,35,"");

  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,SouthWestGravity,SouthEastGravity);
  fl_set_object_color(obj,b_getcfg_int(conf_name, "ViewBgCol", FL_TOP_BCOL), FL_YELLOW);
  fl_set_object_lcol(obj, b_getcfg_int(conf_name, "ViewFgCol", FL_BLACK));
  msg_f->me_mime = obj;
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_mime_list,num);
  fl_set_browser_dblclick_callback(obj,cb_mime_list_dbl,num);

  if (msg_f->me_flags &  MF_VIEW) {

  obj = fl_add_button(FL_NORMAL_BUTTON,10,572,35,27,"@2->");
  fl_set_object_resize(obj,FL_RESIZE_NONE);
  fl_set_object_gravity(obj,SouthWestGravity,SouthWestGravity);
  obj->u_ldata = num;
  fl_set_object_callback(obj,cb_find,num);

  msg_f->me_find = obj = fl_add_input(FL_NORMAL_INPUT,45,572,750,27,"");
  fl_set_object_resize(obj,FL_RESIZE_X);
  fl_set_object_gravity(obj,SouthWestGravity,SouthEastGravity);
  obj->u_ldata = num;
  fl_set_input_color(obj, FL_WHITE, FL_BLUE);
  fl_set_object_color(obj, FL_BLACK, FL_BLACK);
  fl_set_object_callback(obj,cb_find,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);

  obj = fl_add_browser(FL_HOLD_BROWSER,10,browserbottom,785,browserheight,"");
  fl_set_object_resize(obj,FL_RESIZE_ALL);
  fl_set_object_gravity(obj,NorthWestGravity,SouthEastGravity);
  fl_set_object_color(obj,b_getcfg_int(conf_name, "ViewBgCol", FL_TOP_BCOL), FL_YELLOW);
  fl_set_object_lcol(obj, b_getcfg_int(conf_name, "ViewFgCol", FL_BLACK));

  fl_set_object_callback(obj,cb_browser,num);
  fl_set_browser_dblclick_callback(obj,cb_browser_dbl,num);

	 			} else {
  msg_f->me_find = NULL;
  obj = fl_add_input(FL_MULTILINE_INPUT,10,browserbottom ,785,browserheight + 30,"");
  fl_set_object_resize(obj,FL_RESIZE_ALL);
  fl_set_object_gravity(obj,NorthWestGravity,SouthEastGravity);
  fl_set_input_color(obj, b_getcfg_int(conf_name, "EditFgCol", FL_BLACK), b_getcfg_int(conf_name, "EditFgCol", FL_BLACK));
  fl_set_object_color(obj, b_getcfg_int(conf_name, "EditBgCol", FL_TOP_BCOL), b_getcfg_int(conf_name, "EditBgCol", FL_TOP_BCOL));
  fl_set_object_callback(obj,cb_txtedit,num);
  fl_set_input_return(obj, FL_RETURN_ALWAYS);
					}

  obj->u_ldata = num;
  msg_f->me_text = obj;

/* begin the hack - VIEW */

  if (msg_f->me_flags &  MF_VIEW) {
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,20,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  obj->u_ldata = num;
	  obj->u_vdata = "Close view";
	  fl_set_pixmapbutton_data(obj,exit_xpm);
	  fl_set_object_callback(obj,cb_mbutton_exit_view,num);
	  fl_set_button_shortcut(obj, "#X", 0);
	  fl_set_object_posthandler(obj, post_handler);

	  fl_set_form_atclose(form, close_view_form, obj);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,73,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Previous unread message";
		     fl_set_pixmapbutton_data(obj,prevu_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,1);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,110,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Previous message";
		     fl_set_pixmapbutton_data(obj,prev_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,2);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,151,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Next message";
		     fl_set_pixmapbutton_data(obj,next_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,3);
		     fl_set_button_shortcut(obj, "#N", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,191,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Next unread message";
		     fl_set_pixmapbutton_data(obj,nextu_xpm);
		     fl_set_object_callback(obj,cb_mbutton_np,4);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,240,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Reply to message";
		     fl_set_pixmapbutton_data(obj,reply_xpm);
		     fl_set_object_callback(obj,cb_mbutton_reply,num);
		     fl_set_button_shortcut(obj, "#R", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,285,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Forward message";
		     fl_set_pixmapbutton_data(obj,forward_xpm);
		     fl_set_object_callback(obj,cb_mbutton_forward,num);
		     fl_set_button_shortcut(obj, "#F", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,330,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Move to another folder";
		     fl_set_pixmapbutton_data(obj,move_xpm);
		     fl_set_object_callback(obj,cb_mbutton_move,num);
		     fl_set_button_shortcut(obj, "#M", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,375,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Delete";
		     fl_set_pixmapbutton_data(obj,delete_xpm);
		     fl_set_object_callback(obj,cb_mbutton_delete,num);
		     fl_set_button_shortcut(obj, "#D", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,420,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "External viewer";
		     fl_set_pixmapbutton_data(obj,view_xpm);
		     fl_set_object_callback(obj,cb_mbutton_view,num);
		     fl_set_button_shortcut(obj, "#V", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,465,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Print";
		     fl_set_pixmapbutton_data(obj,print_xpm);
		     fl_set_object_callback(obj,cb_mbutton_print,num);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,510,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Help";
		     fl_set_pixmapbutton_data(obj,help_xpm);
		     fl_set_object_callback(obj,cb_help_button,10);
		     fl_set_button_shortcut(obj, "#H", 0);
  /* NEW EMAIL */
  } else {
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,65,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Send";
		     fl_set_pixmapbutton_data(obj,send_xpm);
		     fl_set_object_callback(obj,cb_mbutton_send,num);
		     fl_set_button_shortcut(obj, "^S", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,20,buttons_y_bottom-5,41,41,""); /* Ok! */
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Finish edit";
		     fl_set_pixmapbutton_data(obj,exit_xpm);
		     fl_set_object_callback(obj,cb_mbutton_exit_edit,num);
		     fl_set_button_shortcut(obj, "^X", 0);

	  fl_set_form_atclose(form, close_edit_form, obj);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,110,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Insert file";
		     fl_set_pixmapbutton_data(obj,insert_xpm);
		     fl_set_object_callback(obj,cb_mbutton_insert,num);
		     fl_set_button_shortcut(obj, "#I", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,155,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Include original";
		     fl_set_pixmapbutton_data(obj,insorig_xpm);
		     fl_set_object_callback(obj,cb_mbutton_insorig,num);
		     fl_set_button_shortcut(obj, "#Q", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,200,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Add signature";
		     fl_set_pixmapbutton_data(obj,sign_xpm);
		     fl_set_object_callback(obj,cb_mbutton_sign,num);
		     fl_set_button_shortcut(obj, "#S", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,245,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "External editor";
		     fl_set_pixmapbutton_data(obj,edit_xpm);
		     fl_set_object_callback(obj,cb_mbutton_edit,num);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,290,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Spell check";
		     fl_set_pixmapbutton_data(obj,spell_xpm);
		     fl_set_object_callback(obj,cb_spell_button,num);
		     fl_set_button_shortcut(obj, "#P", 0);
	
	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,335,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Attach";
		     fl_set_pixmapbutton_data(obj,attach_xpm);
		     fl_set_object_callback(obj,cb_attach_button,num);
		     fl_set_button_shortcut(obj, "#T", 0);

	  obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,380,buttons_y_bottom-5,41,41,"");
          fl_set_object_resize(obj,FL_RESIZE_NONE);
	  fl_set_object_gravity(obj,NorthWestGravity,0);
	  fl_set_object_posthandler(obj, post_handler);
	  obj->u_ldata = num;
	  obj->u_vdata = "Help";
		     fl_set_pixmapbutton_data(obj,help_xpm);
		     fl_set_object_callback(obj,cb_help_button,11);
		     fl_set_button_shortcut(obj, "#H", 0);
  }


  fl_end_form();
  fl_set_form_minsize(form, 600, 300);
  num_cascade = num % 12;
  fl_set_initial_placement(form, 150+50*num_cascade,100+50*num_cascade
							, mf_x, mf_y);

  if (msg_f->me_flags &  MF_VIEW) {
	fl_register_raw_callback(form,PointerMotionMask|KeyPressMask|ButtonPressMask,cb_view);
	fl_show_form(form,FL_PLACE_FREE,FL_FULLBORDER,"MSGView");
				  }
  else	 {
	fl_register_raw_callback(form,KeyPressMask, cb_edit);
	fl_addto_choice(msg_f->me_to_type, "To");
	fl_addto_choice(msg_f->me_to_type, "Cc");
	fl_addto_choice(msg_f->me_to_type, "Bcc");
	fl_set_choice(msg_f->me_to_type, 1);
	fl_show_form(form,FL_PLACE_FREE,FL_FULLBORDER,"MSGEdit");
	}

  fl_register_raw_callback(form,PointerMotionMask|EnterWindowMask,cb_size);

  if ((xwmh=XAllocWMHints()) != NULL)   {
	xwmh->icon_pixmap = icon_MailEdit;
	xwmh->flags = IconPixmapHint;
	XSetWMHints(fl_display, form->window, xwmh);
	XFree(xwmh);
					}

  return msg_f;
}


int
view_msg(msg)
	struct	_mail_msg		*msg;
{
struct msg_form		*mf_ptr;
int			i,id;

	if (msg == NULL)
		return 4;

	if (msg->flags & LOCKED) {
	  for (i=0;i<MAX_MSG_FORMS;i++) {
		if ((mf_arr[i] != NULL) && (mf_arr[i]->me_msg == msg))
		 XMapRaised(fl_display, mf_arr[i]->me_form->window);
					}
		return 1;
				}

	for (i=0;i<MAX_MSG_FORMS;i++) {
		if (mf_arr[i]==NULL)
			break;	      }

	if (i==MAX_MSG_FORMS)
		return 2;
	id=i;

  	if ((mf_ptr = malloc(sizeof(struct msg_form)))==NULL) {
		display_msg(MSG_FATAL, "view", "malloc failed");
		exit(1); }

	mf_arr[id] = mf_ptr;

	mf_ptr->me_form = NULL;
	mf_ptr->me_from = mf_ptr->me_to = NULL;
	mf_ptr->me_to_list = mf_ptr->me_to_type = mf_ptr->me_subj = NULL;
	mf_ptr->me_text = mf_ptr->me_pixmap = mf_ptr->me_bitmap = NULL;
	mf_ptr->me_date = mf_ptr->me_mime = NULL;

	mf_ptr->me_flags = MF_VIEW;
	mf_ptr->tofft = 0L;
	
	mf_ptr->me_msg = msg;
	switch_ttips();
	create_msg_form(mf_ptr,id,mf_x,mf_y);

	if (b_getcfg_int(conf_name, "sheader", 0))
	  mf_ptr->me_flags |= MF_HEADER;

	update_msg(id);
	switch_ttips();

	return 0;
}

int
edit_msg(msg)
	struct	_mail_msg		*msg;
{
struct msg_form		*mf_ptr;
int			i,id;

	if (msg == NULL)
		return 4;

	if (msg->flags & LOCKED) {
	  for (i=0;i<MAX_MSG_FORMS;i++) {
		if ((mf_arr[i] != NULL) && (mf_arr[i]->me_msg == msg))
		 XMapRaised(fl_display, mf_arr[i]->me_form->window);
					}
		return 1;	}

	for (i = 0;i<MAX_MSG_FORMS;i++) 
		if (mf_arr[i] == NULL)
			break;

	if (i == MAX_MSG_FORMS)
		return 2;
	id = i;

  	if ((mf_ptr = malloc(sizeof(struct msg_form)))==NULL) {
		display_msg(MSG_FATAL, "view", "malloc failed");
		exit(1); }

	mf_arr[id] = mf_ptr;

	mf_ptr->me_form = NULL;
	mf_ptr->me_from = mf_ptr->me_to = NULL;
	mf_ptr->me_to_list = mf_ptr->me_to_type = mf_ptr->me_subj = NULL;
	mf_ptr->me_text = mf_ptr->me_pixmap = mf_ptr->me_bitmap = NULL;
	mf_ptr->me_date = mf_ptr->me_mime = NULL;

        mf_ptr->me_flags = 0;
	mf_ptr->tofft = 0L;
	
	mf_ptr->me_msg = msg;
	switch_ttips();
	create_msg_form(mf_ptr,id,mf_x,mf_y);

	update_msg(id);
	switch_ttips();

	return 0;
}

int
update_msg(id)
	int	id;
{
static int		ftype;
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*to_p;
struct _head_field	*hf;
char			str[255];
char			*face;

	mf_ptr = mf_arr[id];
	if (!mf_ptr)
		return -1;

	msg = mf_ptr->me_msg;
	if (!msg)
		return -1;

	fl_freeze_form(mf_ptr->me_form);

	strftime(str,40,"%c", localtime(&msg->header->snt_time));
	fl_set_object_label(mf_ptr->me_date, ((hf = find_field(msg, "Date")) || (hf = find_field(msg, "X-RDate")) ) ? hf->f_line : str);

	ftype = 0;
	face = NULL;
	if ((mf_ptr->me_flags & MF_VIEW) && b_getcfg_int(conf_name, "usefaces", 0))
	{
#ifdef	FACES
	if ((face = get_msg_face(msg)) != NULL) {
		fl_hide_object(mf_ptr->me_pixmap);
		fl_show_object(mf_ptr->me_bitmap);
		fl_set_bitmap_data(mf_ptr->me_bitmap, 48, 48, face);
						}
	else
#endif
	  if ((face = find_face(msg->header->From, &ftype)) != NULL) {
	  switch(ftype) {
		case FACE_XPM:
		fl_hide_object(mf_ptr->me_bitmap);
		fl_free_pixmap_pixmap(mf_ptr->me_pixmap);
		fl_set_pixmap_file(mf_ptr->me_pixmap, face);
		fl_show_object(mf_ptr->me_pixmap);
		break;

		case FACE_XBM:
		fl_hide_object(mf_ptr->me_pixmap);
		fl_set_bitmap_file(mf_ptr->me_bitmap, face);
		fl_show_object(mf_ptr->me_bitmap);
		break;

		default:
		break;
			}
								}	
	}

	if (!face) {
	fl_hide_object(mf_ptr->me_bitmap);
	if (mf_ptr->me_flags & MF_VIEW)
		fl_free_pixmap_pixmap(mf_ptr->me_pixmap);
	if (msg->flags & UNREAD)
		fl_set_pixmap_data(mf_ptr->me_pixmap, icon_mail_xpm);
	else
		fl_set_pixmap_data(mf_ptr->me_pixmap, icon_nomail_xpm);
	fl_show_object(mf_ptr->me_pixmap);
		}


	ftype = -1;
	fl_set_input(mf_ptr->me_from,get_charset_addr_line(NULL, msg->header->From, &ftype));
	if (ftype >= 0) {
		fl_set_object_lstyle(mf_ptr->me_from, supp_charsets[ftype].font_style);
		fl_set_object_lsize(mf_ptr->me_from, supp_charsets[ftype].font_size);
		}
	else 	{
		fl_set_object_lstyle(mf_ptr->me_from, supp_charsets[def_charset].font_style);
		fl_set_object_lsize(mf_ptr->me_from, supp_charsets[def_charset].font_size);
		}

	if (mf_ptr->me_flags & MF_VIEW) {
		fl_set_input(mf_ptr->me_find, "");

		if (msg->header->Sender) {
			fl_show_object(mf_ptr->me_sender);
	ftype = -1;
	fl_set_input(mf_ptr->me_sender,get_charset_addr_line(NULL, msg->header->Sender, &ftype));
	if (ftype >= 0) {
		fl_set_object_lstyle(mf_ptr->me_sender, supp_charsets[ftype].font_style);
		fl_set_object_lsize(mf_ptr->me_sender, supp_charsets[ftype].font_size);
		}
	else 	{
		fl_set_object_lstyle(mf_ptr->me_sender, supp_charsets[def_charset].font_style);
		fl_set_object_lsize(mf_ptr->me_sender, supp_charsets[def_charset].font_size);
		}
		} else
			fl_hide_object(mf_ptr->me_sender);
	}

	fl_clear_browser(mf_ptr->me_to_list);

	for (to_p = msg->header->To; to_p; to_p = to_p->next_addr)
		fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("To: ", to_p, NULL));

	for (to_p = msg->header->Cc; to_p; to_p = to_p->next_addr)
		fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("Cc: ", to_p, NULL));

	for (to_p = msg->header->Bcc; to_p; to_p = to_p->next_addr)
		fl_add_browser_line(mf_ptr->me_to_list,get_charset_addr_line("Bcc:", to_p, NULL));

	fl_select_browser_line(mf_ptr->me_to_list, 1);

	ftype = -1;
  	if (msg->header->Subject) {
		strncpy(str, rfc1522_decode(msg->header->Subject, &ftype), 64);
		str[64] = '\0';
		fl_set_input(mf_ptr->me_subj, str);
		if (ftype) {
	        fl_set_object_lsize(mf_ptr->me_subj, supp_charsets[ftype].font_size);
	        fl_set_object_lstyle(mf_ptr->me_subj, supp_charsets[ftype].font_style);
			}
	}
  	else	{
		fl_set_input(mf_ptr->me_subj, "");

		if (mf_ptr->me_flags & MF_VIEW)
	 	  strcpy(str,"*No Subject*");
		else
	 	  strcpy(str,"*New Mail*");
		}

	if (ftype == -1) {
	        fl_set_object_lsize(mf_ptr->me_subj, supp_charsets[def_charset].font_size);
	        fl_set_object_lstyle(mf_ptr->me_subj, supp_charsets[def_charset].font_style);
			}

	fl_set_input_cursorpos(mf_ptr->me_subj, 0, 0);
	fl_set_input_cursorpos(mf_ptr->me_from, 0, 0);
	fl_set_input_cursorpos(mf_ptr->me_sender, 0, 0);

	fl_set_form_title(mf_ptr->me_form, str);
	XSetIconName(fl_display,mf_ptr->me_form->window,str);

	if ( (msg->flags & UNREAD) && 
	   ( (hf = find_field(msg, XFRECEIPT)) ||
		(hf = find_field(msg, "X-Chameleon-Return-To")) )     )
	 {
	   if (mf_ptr->me_flags & MF_VIEW)
		fl_clear_browser(mf_ptr->me_text);
	   else
		fl_set_input(mf_ptr->me_text, "");

	   fl_clear_browser(mf_ptr->me_mime);

	   fl_unfreeze_form(mf_ptr->me_form);
	   switch(b_getcfg_int(conf_name, "vconfirm", 1)) {
	    case 2:
		if (display_msg(MSG_QUEST, "Confirm reading", "Send confirmation to %s?", hf->f_line))	{
			fl_deactivate_all_forms();
			set_cursor(mf_ptr->me_form, XC_watch);
			read_confirm(msg);
			set_cursor(mf_ptr->me_form, 0);
			fl_activate_all_forms();
			}
	    break;

	    case 3:
	    break;

	    case 1:
	    default:
		fl_deactivate_all_forms();
		set_cursor(mf_ptr->me_form, XC_watch);
		read_confirm(msg);
		set_cursor(mf_ptr->me_form, 0);
		fl_activate_all_forms();
	    break;
							  }
	   fl_freeze_form(mf_ptr->me_form);
	 }

	display_msg_text(mf_ptr);

	msg->flags |= LOCKED;

	if (msg->flags & UNREAD) {
	msg->flags &= ~UNREAD;
	if (msg->folder && msg->folder->unread_num)
		msg->folder->unread_num--;
	update_title();
				  }

	fl_unfreeze_form(mf_ptr->me_form);
	redraw_msg(msg);
	return 0;
}

void
release_orig(id)
int id;
{
int i, released;

	  released = 0;
	  if (mf_arr[id] && mf_arr[id]->me_msg &&
		(mf_arr[id]->me_msg->data == MSG_DAT_ORIG) &&
		mf_arr[id]->me_msg->pdata) {
	    for (i=0;i<MAX_MSG_FORMS;i++) {
		if (mf_arr[i] && (mf_arr[i]->me_msg ==
			(struct _mail_msg *)mf_arr[id]->me_msg->pdata)) {
		set_cursor(mf_arr[i]->me_form, 0);
		fl_activate_form(mf_arr[i]->me_form);
		released = 1;
		break;
									}
					  }
	    if (!released) {
	      ((struct _mail_msg *)mf_arr[id]->me_msg->pdata)->flags &= ~LOCKED;
	      redraw_msg((struct _mail_msg *)mf_arr[id]->me_msg->pdata);
	      mf_arr[id]->me_msg->data = MSG_DAT_EMPTY;
	      mf_arr[id]->me_msg->pdata = NULL;
			   }
					   }

	return;
}

void
end_msg(id)
	int	id;
{
struct _mail_folder *fld;

	if (mf_arr[id] == NULL)
		return;
	
	switch_ttips();
	if (mf_arr[id]->me_msg) {
	  fld = mf_arr[id]->me_msg->folder;
	  release_orig(id);
	  mf_arr[id]->me_msg->flags &= ~LOCKED;
	  mf_arr[id]->me_msg->update(mf_arr[id]->me_msg);
	  redraw_msg(mf_arr[id]->me_msg);

	  if (mf_arr[id]->me_msg->flags & M_TEMP)	    {
		mf_arr[id]->me_msg->flags &= ~M_TEMP;
		mf_arr[id]->me_msg->delete(mf_arr[id]->me_msg);
		mf_arr[id]->me_msg = NULL;
					    }
	  else
	  if ((mf_arr[id]->me_msg->flags & DELETED) &&
		mf_arr[id]->me_msg->folder) {
		mf_arr[id]->me_msg->flags &= ~DELETED;
		mf_arr[id]->me_msg->delete(mf_arr[id]->me_msg);
		mf_arr[id]->me_msg = NULL;
		redraw_fld(trash);
		redraw_fld(fld);
					    }
	  else
	  if ((mf_arr[id]->me_msg->flags & MOVED) &&
		mf_arr[id]->me_msg->folder) {
		mf_arr[id]->me_msg->flags &= ~MOVED;
		draft->move(mf_arr[id]->me_msg, draft);
		mf_arr[id]->me_msg = NULL;
		redraw_fld(draft);
		redraw_fld(fld);
					    }
				}

	destruct_msg(mf_arr[id]);
	mf_arr[id] = NULL;
	switch_ttips();
}

void
destruct_msg(mf)
	struct msg_form			*mf;
{
	fl_hide_form(mf->me_form);
	fl_free_form(mf->me_form);
	free(mf);
}

char *
form_to_msg(num, update)
	int		num;
	int		update;
{
struct msg_form		*mf_ptr;
struct _mail_msg	*msg;
struct _mail_addr	*to,*to_p;
char			*adr,*adr_p;
int			line,max_line;

	mf_ptr = mf_arr[num];
	if (mf_ptr == NULL)
		return NULL;

	msg = mf_ptr->me_msg;
	if (msg == NULL)
		return NULL;

	adr = (char *)fl_get_input(mf_ptr->me_subj);
	if (msg->header->Subject)
		free(msg->header->Subject);
	msg->header->Subject = strlen(adr) ? strdup(adr) : NULL;

	discard_address(msg->header->From);
	msg->header->From=get_address((char *)fl_get_input(mf_ptr->me_from));
	discard_address(msg->header->From->next_addr);
	msg->header->From->next_addr = NULL;

	discard_address(msg->header->To);
	adr = (char *)fl_get_input(mf_ptr->me_to);
	if (adr && (strlen(adr) > 1) &&
		(fl_get_choice(mf_ptr->me_to_type) == 1))
		msg->header->To = get_address(adr);
	else
		msg->header->To = NULL;
	fl_set_input(mf_ptr->me_to, "");

	discard_address(msg->header->Cc);
	msg->header->Cc = NULL;

	discard_address(msg->header->Bcc);
	msg->header->Bcc = NULL;

	max_line = fl_get_browser_maxline(mf_ptr->me_to_list);
	for (line = 1; line <= max_line; line++) {
		adr_p = (char *)fl_get_browser_line(mf_ptr->me_to_list, line);
		if (adr_p == NULL)
			break;

		adr = adr_p + 4;
		to = NULL;
		if (!strncmp(adr_p,"To: ",4))
			to = msg->header->To;
		if (!strncmp(adr_p,"Cc: ",4))
			to = msg->header->Cc;
		if (!strncmp(adr_p,"Bcc:",4))
			to = msg->header->Bcc;

		to_p = to;
		to = get_address(adr);
		if (to)
			to->next_addr = to_p;
		else
			to = to_p;

		if (!strncmp(adr_p,"To: ",4)) {
			msg->header->To = to;
		}
		if (!strncmp(adr_p,"Cc: ",4)) {
			msg->header->Cc = to;
		}
		if (!strncmp(adr_p,"Bcc:",4)) {
			msg->header->Bcc = to;
		}
	}

 return compose_msg_text(mf_ptr, update);
}

void
ext_view_exit(pinfo)
struct _proc_info *pinfo;
{
struct msg_form *mf;

  if (!pinfo)
	return;

  unlink((char *)pinfo->u_data);
  free(pinfo->u_data);
  mf = mf_arr[pinfo->ul_data];
  if (mf)
	fl_activate_form(mf->me_form);
}

void
ext_view_msg(num, asis)
int num, asis;
{
struct msg_form *mf;
struct _mail_msg *msg;
struct _mime_msg *mime;
struct _proc_info pinfo;
char command[255];
char mfile[64];
char buf[255];
FILE *m_tmp, *mmfd;
char *e, *p;
int i;
int added = 0;
 
 mf = mf_arr[num];

 if (!mf || !(mf->me_flags & MF_VIEW))
	return;

 if ((msg = mf->me_msg) == NULL)
	return;

 strcpy(mfile, get_temp_file("extview"));
 if ((m_tmp = fopen(mfile, "w")) == NULL) {
        display_msg(MSG_WARN, "ext view", "Can not open file %s", mfile);
        return; }

 if (!(mmfd = fopen(msg->get_file(mf->me_msg), "r"))) {
	display_msg(MSG_WARN, "Can not open message file", "%s", mf->me_msg->get_file(mf->me_msg));
 	fclose(m_tmp);
	return; }

 if (mf->me_flags & MF_HEADER)  {
   while(fgets(buf, 255, mmfd) && (strlen(buf) > 1))
 	fputs(buf, m_tmp);

   fputs("\n", m_tmp);
				}
 else
 	fseek(mmfd, msg->header->header_len, SEEK_SET);

 if (asis) {
 while(fgets(buf, 255, mmfd))
 	fputs(buf, m_tmp);
 } else {
 mime = get_text_part(msg);

 if (mime == NULL) {
	mime = msg->mime;
	while (mime) {
		if ((mime->flags & PREAMBLE) ||
			(mime->flags & EPILOG))
			break;
		mime = mime->mime_next;
		     }
		 }

 if (mime == NULL) {
  fclose(m_tmp);
  fclose(mmfd);
  display_msg(MSG_WARN, "ext editor", "Empty message");
  return;
		   }

 fseek(mmfd, mime->m_start, SEEK_SET);
 if (mime->boundary && (mime->flags & TEXT_PART)) {
	 while(fgets(buf, 255, mmfd)) {
	   if (strlen(buf) <= 1)
		break;
				      }	
						 }

 (*mime->encoding->ce_dec)(NULL, &i);
 while ((ftell(mmfd) < mime->m_end) && fgets(buf, 255, mmfd)) {
	if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
		continue;
 	fputs(p, m_tmp);
							      }
 p = (*mime->encoding->ce_dec)(NULL, &i);
 if (p && (strlen(p) > 1))
 	fputs(p, m_tmp);
	}

 fclose(m_tmp);
 fclose(mmfd);

 e = b_getcfg_str(conf_name, "extview", "/usr/bin/X11/xedit");
 command[0] = '\0';
 for (i = 0; i < strlen(e); i++) {
  if ((e[i] == '$') && (e[i] == 'f')) {
	added = 1;
	strcat(command, mfile); }
  else 	{
	command[strlen(command) + 1] = '\0';
	command[strlen(command)] = e[i];
	}
				}

 if (!added) {
	strcat(command, " ");
	strcat(command, mfile);
	added = 1;
		}

 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(mfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_view_exit;
 pinfo.ifd = -1;

 fl_deactivate_form(mf->me_form);
 if (exec_child(command, &pinfo) == -1)
	ext_view_exit(&pinfo);

 return;
}

void
ext_edit_exit(pinfo)
struct _proc_info *pinfo;
{
struct msg_form *mf;

  if (!pinfo)
	return;

  mf = mf_arr[pinfo->ul_data];
  if (!mf)
	return;

  fl_activate_form(mf->me_form);

  update_mime(mf->me_msg);

  fl_freeze_form(mf->me_form);
  display_msg_text(mf);
  fl_unfreeze_form(mf->me_form);

  free(pinfo->u_data);
}

void
ext_edit_msg(num)
int num;
{
struct msg_form *mf;
struct _proc_info pinfo;
char command[255];
char *mfile;
char *e;
int i;
int added = 0;
 
 mf = mf_arr[num];

 if (!mf || (mf->me_flags & MF_VIEW))
	return;

 mfile = compose_msg_text(mf, 0);
 if (!mfile)
	return;

 e = b_getcfg_str(conf_name, "extedit", "/usr/bin/X11/xedit");
 command[0] = '\0';
 for (i = 0; i < strlen(e); i++) {
  if ((e[i] == '$') && (e[i] == 'f')) {
	added = 1;
	strcat(command, mfile); }
  else 	{
	command[strlen(command) + 1] = '\0';
	command[strlen(command)] = e[i];
	}
				}

 if (!added) {
	strcat(command, " ");
	strcat(command, mfile);
	added = 1;
		}

 pinfo.wait = WAIT_ASYNC;
 pinfo.u_data = strdup(mfile);
 pinfo.ul_data = num;
 pinfo.handle = ext_edit_exit;
 pinfo.ifd = -1;

 fl_deactivate_form(mf->me_form);
 if (exec_child(command, &pinfo) == -1)
	ext_edit_exit(&pinfo);

 return;
}

int
view_line(obj, buf, nl, len, wrap, color)
FL_OBJECT *obj;
char *buf;
int *nl;
u_long *len;
int wrap;
char *color;
{
char buf1[255];
char *p, *a;
char add1[256];
char *add;

	add = add1 + 1;
	add1[0] = ' ';

	if ((p = strrchr(buf, '\n')) != NULL)
		*p = '\0';

	p = buf;

	if (*p == '\0') {
		fl_add_browser_line(obj, " ");
		*len += 1;
		*nl += 1;
		return 0;
		}

	  while(p) {

		if (strlen(p) > wrap) {
		   *len += wrap;
		   strncpy(add, p, wrap);
		   add[wrap] = '\0';
		   p += wrap;	} else {
		   *len += strlen(buf);
		   strcpy(add, p);
		   p = NULL; }

		(*nl)++;
		if (*nl >= MAX_VIEWABLE_LINES) {
			display_msg(MSG_STAT, NULL, "Too many lines in message. Use external viewer");
			return -1; }

		if (*len >= MAX_VIEWABLE_SIZE) {
		 display_msg(MSG_STAT, NULL, "Message is too big, use external viewer to look at it");
		 return -1; }

		if (add[0] == '@') 
			a = add1;
		else 
			a = add;


		if (color) {
			if (isdigit(a[0]))
			  sprintf(buf1, "%s %s", color,  a);
			else
			  sprintf(buf1, "%s%s", color,  a);
			     }
		else
			strcpy(buf1, a);

		fl_add_browser_line(obj, buf1);

			}
 return 0;
}

void
display_msg_text(mf)
struct msg_form *mf;
{
char buf[255];
char prefix[17];
u_long len;
int nl, markincl, col;
int wrap;
struct _mime_msg *mime;
int i;
char *p, *p1;
struct _mail_msg *msg;
int msize;
char mdescr[128];
char mtype[64];
char *mname;
struct _head_field	*hf;
FILE *mfd = NULL;

 if (!mf)
	return;

 if (!mf->me_msg)
	return;

 msg = mf->me_msg;

 fl_clear_browser(mf->me_mime);

 if (mf->me_flags & MF_VIEW)
	fl_clear_browser(mf->me_text);
 else
	fl_set_input(mf->me_text, "");

 if (msg->flags & H_ONLY) {
		fl_unfreeze_form(mf->me_form);
		if (display_msg(MSG_QUEST, "Message body resides on the POP server", "Do you want to retrieve it?")) 	{
			my_deactivate();
			set_cursor(mf->me_form, XC_watch);
			pop_getfull_msg(msg);
			set_cursor(mf->me_form, 0);
			my_activate();
			fl_freeze_form(mf->me_form);
					}
		else 	{
			fl_freeze_form(mf->me_form);
			return;
			}
			 	}

 if (msg->mime == NULL)
	mime_scan(msg);

 mime = msg->mime;

 i = 0;
 while (mime) {
  if (mime->flags != ATTACHMENT) {
  	mime = mime->mime_next;
	continue; }

  i++;
  sprintf(mtype, "%s/%s", mime->mailcap->type_text, mime->mailcap->subtype_text);
  msize = 0;
  mname = NULL;
  if ((hf = find_mime_field(mime, MIME_C_TYPE)) != NULL) {
	mname = get_fld_param(hf, "SizeOnDisk");
	if (mname)
     	  msize = atoi(mname);	
	mname = get_fld_param(hf, "name");		 }

  if (mname == NULL) 	{
  if ((hf = find_mime_field(mime, MIME_C_DISP)) != NULL) 
	mname = get_fld_param(hf, "filename");
			}

  if (mname) {
	if (msize > 0)
		sprintf(mdescr, "%-12.12s %7d %-43s", mname , msize , mime->c_descr ? mime->c_descr : "");
	else
		sprintf(mdescr, "%-12.12s %-50s", mname , mime->c_descr ? mime->c_descr : "");
	     }
  else
	sprintf(mdescr, "%-63s", mime->c_descr ? mime->c_descr : "");

  sprintf(buf, "%d %-22.22s %-10.10s %-10.10s %-63s", i, mtype, mime->encoding->encoding_name, mime->charset->charset_name, mdescr);
  fl_add_browser_line(mf->me_mime, buf);

  mime = mime->mime_next;
			}

  fl_select_browser_line(mf->me_mime, 1);

#ifndef MMAP_MSG

 if ((mfd = fopen(msg->get_file(mf->me_msg), "r")) == NULL) {
	display_msg(MSG_WARN, "Can not open message file", "%s", msg->get_file(mf->me_msg));
	return; }
#else
 msg->get_text(msg);

 mmpos = 0;
 mmlen = msg->msg_len;
 mmsg = msg->msg_body;

#endif

 len = 0;
 nl = 0;

if (mf->me_flags & MF_VIEW) {

	wrap = b_getcfg_int(conf_name, "viewrap", 80);
	strncpy(prefix, b_getcfg_str(conf_name, "prefix", ">"), 16);
	markincl = b_getcfg_int(conf_name,  "markincl", 0);

	mime = get_text_part(msg);

	if (mime == NULL) {
		mime = msg->mime;
		while (mime) {
			if (mime->flags & PREAMBLE)
				break;
			if (mime->flags & EPILOG)
				break;
			mime = mime->mime_next;
			     }
			 }

	if (mime && mime->charset && 
		(mime->charset->charset_code != CHAR_UNKNOWN)) {

	  fl_set_browser_fontstyle(mf->me_text, mime->charset->font_style);
	  fl_set_browser_fontsize(mf->me_text, mime->charset->font_size);

	  fl_set_object_lsize(mf->me_find, mime->charset->font_size);
	  fl_set_browser_fontsize(mf->me_mime, mime->charset->font_size);

	  fl_set_object_lstyle(mf->me_find, mime->charset->font_style);
	  fl_set_browser_fontstyle(mf->me_mime, mime->charset->font_style);
								}
	else 	{
	  fl_set_object_lsize(mf->me_find, supp_charsets[DEFAULT_CHARSET].font_size);
	  fl_set_browser_fontsize(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_size);
	  fl_set_browser_fontsize(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_size);

	  fl_set_object_lstyle(mf->me_find, supp_charsets[DEFAULT_CHARSET].font_style);
	  fl_set_browser_fontstyle(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_style);
	  fl_set_browser_fontstyle(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_style);
		}

	fl_redraw_object(mf->me_mime);

	if (mf->me_flags & MF_HEADER) {
	  col = b_getcfg_int(conf_name, "headcolor", FL_READ);
	  sprintf(mdescr, "@C%d", col);
	  while((msg_tell(mfd) < msg->header->header_len) && msg_gets(buf, 255, mfd) && (strlen(buf) > 1)) {
	  if (view_line(mf->me_text, (mime && mime->charset && mime->charset->decode) ? (*mime->charset->decode)(buf) : buf , &nl, &len, wrap, mdescr) == -1)
		break;
	  }
	fl_add_browser_line(mf->me_text, "@-");
					}

 	if (mime == NULL) {
		display_msg(MSG_STAT, NULL, "View: Nothing to display");
#ifdef MMAP_MSG
		msg->free_text(msg);

		mmsg = NULL;
		mmlen = 0;
		mmpos = 0;
#else
		fclose(mfd);
#endif
		return;	}

	msg_seek(mfd, mime->m_start, SEEK_SET);

	if (mime->boundary && (mime->flags & TEXT_PART)) {
	 while(msg_gets(buf, 255, mfd)) {
	   if (strlen(buf) <= 1)
		break;
				        }	
							 }

#ifndef	MMAP_MSG
	if (ferror(mfd) || feof(mfd)) {
		display_msg(MSG_WARN, "VIEW", "Error reading message");
		fclose(mfd);
		return;	}
#endif

	(*mime->encoding->ce_dec)(NULL, &i);
	while ((msg_tell(mfd) < mime->m_end) && msg_gets(buf, 255, mfd)) {

	  if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
		continue;

	  col = 0;
	  if (markincl) {
	   if (!strncmp(buf,prefix, strlen(prefix)))  {
		col = markincl;
		sprintf(mdescr, "@C%d", col);
							}
	   else {
		mname = p;
		if ((*mname == ' ') || (*mname == '\t'))
			mname++;
		if ((*mname == ':') || (*mname == '>') ||
			(*mname == '|')) {
			col = markincl;
			sprintf(mdescr, "@C%d", col);
				  	}
		}
			}

	  if (view_line(mf->me_text, mime->charset->decode ? (*mime->charset->decode)(p) : p, &nl, &len, wrap, col ? mdescr : NULL) == -1)
		break;
				}

	p = (*mime->encoding->ce_dec)(NULL, &i);
	if (p && (strlen(p) > 1))
	  view_line(mf->me_text, p, &nl, &len, wrap, NULL);
			} else {
 char *text = NULL;
 u_int maxelines;

	mime = get_text_part(msg);

	if (mime && mime->charset && 
		(mime->charset->charset_code != CHAR_UNKNOWN)) {
	  fl_set_object_lstyle(mf->me_text, mime->charset->font_style);
	  fl_set_object_lsize(mf->me_text, mime->charset->font_size);

	  fl_set_browser_fontsize(mf->me_mime, mime->charset->font_size);
	  fl_set_browser_fontstyle(mf->me_mime, mime->charset->font_style);
								}
	else 	{
	  fl_set_browser_fontsize(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_size);
	  fl_set_object_lsize(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_size);

	  fl_set_browser_fontstyle(mf->me_mime, supp_charsets[DEFAULT_CHARSET].font_style);
	  fl_set_object_lstyle(mf->me_text, supp_charsets[DEFAULT_CHARSET].font_style);
		}

	fl_redraw_object(mf->me_mime);

	fl_get_char_height(mf->me_text->lstyle, mf->me_text->lsize, &maxelines, &i);	
	maxelines = mf->me_text->h / maxelines;
	if (maxelines > MAX_EDITABLE_LINES)
		maxelines = MAX_EDITABLE_LINES;

 	if (mime == NULL) {
		display_msg(MSG_STAT, NULL, "Edit: Nothing to display");
#ifdef MMAP_MSG
		msg->free_text(msg);

		mmsg = NULL;
		mmlen = 0;
		mmpos = 0;
#else
		fclose(mfd);
#endif
		return;	}

	msg_seek(mfd, mime->m_start, SEEK_SET);

	if (mime->boundary) {
	 while(msg_gets(buf, 255, mfd)) {
	   if (strlen(buf) <= 1)
		break;
				     }	
					}

#ifndef MMAP_MSG
	if (ferror(mfd) || feof(mfd)) {
		display_msg(MSG_WARN, "EDIT", "Error reading message");
		fclose(mfd);
		return;	}
#endif

	nl = 0;
	(*mime->encoding->ce_dec)(NULL, &i);
	while (((mf->tofft = msg_tell(mfd)) < mime->m_end) && msg_gets(buf, 255, mfd)) {

		if ((p = (*mime->encoding->ce_dec)(buf, &i)) == NULL)
			continue;

		len += strlen(p);
		p1 = p;
		while ((p1 = strchr(p1, '\n')) != NULL) {
		  nl++;
		  p1++;
						       }
		if (nl >= maxelines) {
			display_msg(MSG_STAT, NULL, "Too many lines in message. Use external editor");
			break; }

		if (len >= MAX_EDITABLE_SIZE) {
			display_msg(MSG_STAT, NULL, "Message is too big. Use external editor");
			break; }

		if (!text) {
		 text = (char *)malloc(len + 1);
		 if (text == NULL) {
		  display_msg(MSG_FATAL, "EDIT", "malloc failed");
		  break;
				  }
		 text[0] = '\0';
			   }
		else
		 text = (char *)realloc(text, len + 1);


		strcat(text, p);
					}

 if (text) {
   fl_set_input(mf->me_text, text);	
   fl_set_input_cursorpos(mf->me_text, 0, 0);
   free(text);
	   }	
				}

#ifndef MMAP_MSG
 fclose(mfd);
#else
 msg->free_text(msg);

 mmsg = NULL;
 mmlen = 0;
 mmpos = 0;
#endif

 return;

}

char *
compose_msg_text(mf, update)
struct msg_form *mf;
int update;
{
static char nfile[64];
struct _mime_msg *mime;
FILE *mfd, *nfd;
char buf[255];
char *ntext, *p;
int i;

 strcpy(nfile, get_temp_file("nfile"));

 if ((nfd = fopen(nfile, "w")) == NULL) {
	display_msg(MSG_WARN, "Can not open file", "%s", nfile);
	return NULL; }

 ntext = (char *)fl_get_input(mf->me_text);
 if ((mime = get_text_part(mf->me_msg)) == NULL) {
	if (update && (strlen(ntext) < 1)) {
		fclose(nfd);
		return nfile;  }

	mime = create_mime();
	if (!mime) {
	  display_msg(MSG_WARN, "compose text", "Can not open MIME");
	  fclose(nfd);
	  return NULL;
		   }
	mime->flags = TEXT_PART;
	mime->mime_next = mf->me_msg->mime;
	mf->me_msg->mime = mime;
						}

 if ((mfd = fopen(mf->me_msg->get_file(mf->me_msg), "r")) == NULL) {
	display_msg(MSG_WARN, "Can not open message file", "%s", mf->me_msg->get_file(mf->me_msg));
	fclose(nfd);
	fclose(mfd);
	return NULL; }

 fseek(mfd, mime->m_start, SEEK_SET);

 if (mime->boundary) {
	while(fgets(buf, 255, mfd)) {
		if (strlen(buf) <= 1)
		  break;
				    }	
		     }

 fputs(ntext, nfd);
 if (fseek(mfd, mf->tofft, SEEK_SET) == -1) {
	display_msg(MSG_WARN, "edit", "Failed to compose message");
	fclose(nfd);
	fclose(mfd);
	return NULL;
					    }

 (*mime->encoding->ce_dec)(NULL, &i);
 while ((ftell(mfd) < mime->m_end) && fgets(buf, 255, mfd)) {
	  if ((p = (*mime->encoding->ce_dec)(buf, &i)) != NULL)
		fputs(p, nfd); 
							    }

 if ((p = (*mime->encoding->ce_dec)(NULL, &i)) != NULL)
	fputs(p, nfd); 

 if (ftell(nfd) == 0)  {
    if (update) {
	unlink(nfile);
	mime->flags = 0;
		}
		       }
 fclose(nfd);
 fclose(mfd);

 mime->src_info = strdup(nfile);

 if (update)
	update_mime(mf->me_msg);

 return nfile;
}

