/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: search.c,v 1.10 1996/06/11 15:16:15 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

static FD_Find_Form *search_obj;
static int ready = 0;

void Search_Call(FL_OBJECT *obj, long param)
{
}

void
search_init()
{
 search_obj = create_form_Find_Form();
}

void
search_msgs() 
{
char exp[255], sin[255];
int flags = 0;
int sfold, efold;
int nmsg, nfld, num;
int i;

 if (ready) {
	XRaiseWindow(fl_display, search_obj->Find_Form->window);
        return; }

 ready = 1;

 fl_set_button(search_obj->Search_Case,0);
 fl_set_button(search_obj->Search_All,0);
 fl_set_input(search_obj->Search_In,"Header");

 fl_show_form(search_obj->Find_Form, FL_PLACE_CENTER, FL_TRANSIENT, "Search");
 fl_do_only_forms();

 strncpy(exp, fl_get_input(search_obj->Search_Exp), 254);
 if (!exp || (strlen(exp) < 1)) {
 	fl_hide_form(search_obj->Find_Form);
	ready = 0;
	return; }
 exp[254] = '\0';

 strncpy(sin, fl_get_input(search_obj->Search_In), 254);
 sin[254] = '\0';

 if (!fl_get_button(search_obj->Search_Case))
	flags |= S_CASE;	

 nfld = nmsg = 0;
 if (fl_get_button(search_obj->Search_All)) {
  sfold = 0;
  efold = folders_num;
	} else {
  sfold = get_folder_index(current_folder);
  efold = sfold + 1;
	}

 fl_hide_form(search_obj->Find_Form);

 set_cursor(main_form, XC_watch);
 my_deactivate();
 for (i = sfold; i < efold;i++) 	{
	if (abortpressed())
		break;

	if (mailbox[i] == NULL)
		continue;

	num = mailbox[i]->search(mailbox[i], exp, sin, flags);
	if (num == -1) {
		display_msg(MSG_WARN, "search", "Search failed");
		break; }

	if (num > 0) {
		nfld++;
		mailbox[i]->flags |= SEARCH;
		if ((mailbox[i] ==  current_folder) && (sort_type == BY_FLAGS))
		  current_folder->flags &= ~SORTED;
		}

	nmsg += num;
				}

 my_activate();
 set_cursor(main_form, 0);

 if (nmsg == 0)
	display_msg(MSG_MSG, "search", "No messages found");
 else {
	display_msg(MSG_MSG, "search", "%d message(s) found in %d folder(s)", nmsg, nfld);
 	redraw_folders();
	}

 ready = 0;
 return;         

}
