/*
 * Copyright(c) 1995 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *                  and Ugen J. S. Antsilevich (ugen@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for 
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: view_edit.c,v 1.10 1996/05/14 16:53:26 gena Exp $
 */

#include <fmail.h>
#include <umail.h>
#include <fmail.h>
#include <choose_folder.h>

static FD_View_Conf *view_obj;
static FD_Edit_Conf *edit_obj;
static int ready = 0;
int markincl, headcolor;

void View_EView_Call(FL_OBJECT *obj, long param)
{
}

void View_Wrap_Call(FL_OBJECT *obj, long param)
{
}

void View_Ext_Call(FL_OBJECT *obj, long param)
{
}

void Mark_Included_Call(FL_OBJECT *obj, long param)
{
  if (fl_get_button(obj)) {
	markincl = fl_show_colormap(FL_BLUE);
	fl_set_object_color(obj, FL_WHITE, markincl);
			  }
  else
	markincl = 0;
}

void View_Header_Call(FL_OBJECT *obj, long param)
{
  if (fl_get_button(obj)) {
	headcolor = fl_show_colormap(FL_RED);
	fl_set_object_color(obj, FL_WHITE, headcolor);
			  }
  else
	fl_set_object_color(obj, headcolor, headcolor);
}

void Edit_EEdit_Call(FL_OBJECT *obj, long param)
{
}

void Edit_Wrap_Call(FL_OBJECT *obj, long param)
{
}

void Send_Confirm_Call(FL_OBJECT *obj, long param)
{
}

void
view_conf() 
{

 if (ready)
        return;

 ready = 1;

 view_obj = create_form_View_Conf();

 fl_clear_choice(view_obj->Send_Confirm);
 fl_addto_choice(view_obj->Send_Confirm, "Always");
 fl_addto_choice(view_obj->Send_Confirm, "Ask");
 fl_addto_choice(view_obj->Send_Confirm, "Never");

 fl_set_choice(view_obj->Send_Confirm, b_getcfg_int(conf_name, "vconfirm", 1));

 fl_set_counter_bounds(view_obj->View_Wrap, 40, 100);
 fl_set_counter_precision(view_obj->View_Wrap, 0);
 fl_set_counter_step(view_obj->View_Wrap, 1, 1);
 fl_set_counter_value(view_obj->View_Wrap, (double)((double)b_getcfg_int(conf_name,"viewrap",80)));

 fl_set_input(view_obj->View_EView, b_getcfg_str(conf_name, "extview", "/usr/bin/X11/xedit"));
 headcolor = b_getcfg_int(conf_name, "headcolor", FL_RED);
 if (b_getcfg_int(conf_name, "sheader", 0)) {
	fl_set_button(view_obj->View_Header, 1);
	fl_set_object_color(view_obj->View_Header, FL_WHITE, headcolor);
					}
 else 	{
	fl_set_button(view_obj->View_Header, 0);
	fl_set_object_color(view_obj->View_Header, headcolor, headcolor);
	}

 markincl = b_getcfg_int(conf_name, "markincl", 0);
 fl_set_button(view_obj->Mark_Included, markincl ? 1 : 0);
 fl_set_object_color(view_obj->Mark_Included, FL_WHITE, markincl);

 fl_set_button(view_obj->View_Ext, b_getcfg_int(conf_name, "viewexit",0));

 fl_show_form(view_obj->View_Conf, FL_PLACE_CENTER, FL_TRANSIENT, "View");
 fl_do_only_forms();

 b_putcfg_int(conf_name, "viewrap", (int)fl_get_counter_value(view_obj->View_Wrap));
 b_putcfg_str(conf_name, "extview", (char *)fl_get_input(view_obj->View_EView));
 b_putcfg_int(conf_name, "sheader", fl_get_button(view_obj->View_Header));
 b_putcfg_int(conf_name, "headcolor", headcolor);
 b_putcfg_int(conf_name, "markincl", markincl);

 b_putcfg_int(conf_name, "vconfirm", fl_get_choice(view_obj->Send_Confirm));
 b_putcfg_int(conf_name, "viewexit", fl_get_button(view_obj->View_Ext));

 fl_hide_form(view_obj->View_Conf);
 fl_free_form(view_obj->View_Conf);
 fl_free(view_obj);
 view_obj = NULL;

 ready = 0;
 return;         

}

void
edit_conf() 
{

 if (ready)
        return;

 ready = 1;

 edit_obj = create_form_Edit_Conf();
 fl_set_counter_bounds(edit_obj->Edit_Wrap, 40, 100);
 fl_set_counter_precision(edit_obj->Edit_Wrap, 0);
 fl_set_counter_step(edit_obj->Edit_Wrap, 1, 1);
 fl_set_counter_value(edit_obj->Edit_Wrap, (double)((double)b_getcfg_int(conf_name,"editwrap",80)));

 fl_set_input(edit_obj->Edit_EEdit, b_getcfg_str(conf_name, "extedit", "/usr/bin/X11/xedit"));

 fl_set_input(edit_obj->Edit_Spell, b_getcfg_str(conf_name, "extspell", "/usr/bin/X11/xterm -e /usr/local/bin/ispell"));

 fl_show_form(edit_obj->Edit_Conf, FL_PLACE_CENTER, FL_TRANSIENT, "Edit");
 fl_do_forms();

 b_putcfg_int(conf_name, "editwrap", (int)(fl_get_counter_value(edit_obj->Edit_Wrap)));
 b_putcfg_str(conf_name, "extedit", (char *)fl_get_input(edit_obj->Edit_EEdit));
 b_putcfg_str(conf_name, "extspell",(char *)fl_get_input(edit_obj->Edit_Spell));

 fl_hide_form(edit_obj->Edit_Conf);
 fl_free_form(edit_obj->Edit_Conf);
 fl_free(edit_obj);
 edit_obj = NULL;

 ready = 0;
 return;         

}
